// ABone.h: interface for the ABone class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _ABONE_H_
#define _ABONE_H_

#include "BBAInclude.h"
#include "_ANMAtom.h"

class ABone  
{
public:
	bool dumpBBA;
	ABone(ANMBoneAtom* bone);
	virtual ~ABone();

	void UpdateData( CBBABone* cBone, unsigned int* keyIndex );
	
//	static ABone** boneReg;
//	static int boneRegSize;

	int getBoneID(){return _boneID;}
	int getParentID(){return _parentID;}
	void addChild(ABone* child){_children.push_back(child);}
	void setParent(ABone* parent){_parent=parent;}
	matrix4 GetMatrix();
	void CalculateT0();
	void CalculateMatrix(LPBYTE matBuff, int frameNo, bool invers = true);
	void UpdateMatrix(LPBYTE matBuff,int frameNo,bool dirty=true, bool invers = true);
	void AddFrame();
	matrix4 GetFrame(int index);
	int GetFrameCount(){return _frames.size();}
	int GetChildrenCount(){ return _children.size(); }
	void ClearData();

protected:
	ABone* _parent;
	int _boneID;
	int _parentID;
	char** _outBuff;
	BIFSvector<ABone*> _children;
	BIFSvector<matrix4*> _frames;
	bool _IsDirty;
	bool isQuat;
	bool matDump;
	bool compDump;
		
	matrix4 t0,t0i;
	__vec4f _rot,_orot;
	__vec4f _scRot,_oscRot;
	__vec3f _cen,_ocen;
	__vec3f _trans,_otrans;
	__vec3f _scale,_oscale;
	__vec3f _rote;

	void SlerpQuats( __vec4f qa1, __vec4f qa2, __vec4f *qr, float u );
	void InterpolateCoord( __vec3f *op1, __vec3f *op2, __vec3f *qr, float u );

};

#endif // !defined(_ABONE_H_)
