#ifndef __ANIMATOR_H__
#define __ANIMATOR_H__

#include "stdio.h"
#include <math.h>
#include <assert.h>

class ABone;

enum OUT_TYPE
{
	OUT_MAT=0,
	OUT_ANM
};

class Animator
{

protected:
	int rootID[20];
	int rootCount;
	OUT_TYPE outType;
	int frameCount;
	int boneCount;
	int framerate;
	int decodeTime;
	int BBASize;

	ABone** boneReg;
	int boneRegSize;

	unsigned char* anmBuff;
	int anmBuffSize;
	float* frame;
	void* bbaDecoder;
	bool all_Intra;
	
	void* ParseANMBuffer(unsigned char* anmBuffer, int anmBufferSize);
	void CreateBoneTree();
	void FetchBoneData(void* cbone);
	int InsertFrame(unsigned char* pInData, bool addFrame, unsigned int* keyIndex);
	void InitialiseDecoder(unsigned char* anmBuffer0, int anmBuffer0Size);
	void InitStream(unsigned char * bbaBuffer, int bbaBufferSize, bool checkAllIntra = true);
	void DecodeStream(unsigned char * bbaBuffer, int bbaBufferSize);
	bool CheckStartCode();
	int DecodeOneFrame(bool addFrame=true, int time = -1);
	int DecodeHeader(unsigned char * bbaBuffer, int bbaBufferSize);
	virtual void InsertFrame0();
	void FreeBBADecoderData();
	virtual int InsertData(bool addFrame, int time);

	void BBA_TO_Matrix(unsigned char * bbaBuffer, int bbaBufferSize, unsigned char* anmBuffer0, int anmBuffer0Size);

	void BBA_TO_ANM(unsigned char * bbaBuffer, int bbaBufferSize, unsigned char* anmBuffer0, int anmBuffer0Size,unsigned char** anmBuffer, int* anmBufferSize);
	virtual int UpdateMorph( unsigned char* pData, unsigned int* keyIndex ){return 0;}

	virtual void Init();
	void clearBoneData();
	void deleteDecoder();

public:

	bool dumpBBA;
	int frmTot;
	
	Animator();
	Animator(OUT_TYPE outputType, unsigned char * bbaBuffer, int bbaBufferSize, unsigned char* anmBuffer0, int anmBuffer0Size);	
	virtual ~Animator();

	float* GetFrame(int index, float* trMat, bool invers = true);
	int GetFrameCount(){return frameCount;}
	int GetBoneCount(){return boneCount;}
	int GetFrameRate(){ return framerate; }
	void GetANM(unsigned char **anmBuffer,int* anmBufferSize) {if (outType==OUT_ANM){*anmBuffer=anmBuff;*anmBufferSize=anmBuffSize;}}

	void FindLeafBones( int* &ids, int &count );
	int getDecodeTime() { return decodeTime; }
	int getBBASize() { return BBASize; };

};

#endif //__ANIMATOR_H__