// vector.cpp: implementation of the vector class.
//
//////////////////////////////////////////////////////////////////////

#include "BIFSvector.h"
#include "ztypes.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

template<class T> BIFSvector<T>::BIFSvector()
{
	 _list=NewChain();
}

template<class T> BIFSvector<T>::BIFSvector(BIFSvector<T>& vector)
{
	_list=NewChain();	
	int i;
	for (i=0;i<ChainGetCount(vector._list);i++)
	{
		T* item=(T*)ChainGetEntry(vector._list,i);
		T* value;
		value = new T();
		*value = *item;
		ChainAddEntry( _list, value);
	}
}

template<class T> BIFSvector<T>::~BIFSvector()
{
	clear();
	DeleteChain(_list);
}

template<class T> void BIFSvector<T>::push_back(T val)
{
	T* value;
	value = new T();
	*value=val;
	ChainAddEntry(_list,value);
}

template<class T> void BIFSvector<T>::pop_back()
{
	if ( ChainGetCount(_list) )
	{
		ChainDeleteEntry( _list, ChainGetCount(_list) - 1 );
	}
}

template<class T> void BIFSvector<T>::pop_front()
{
	if ( ChainGetCount(_list) )
	{
		ChainDeleteEntry( _list, 0 );
	}
}

template<class T> unsigned int BIFSvector<T>::size()
{
	return ChainGetCount(_list);
}
	
template<class T> T& BIFSvector<T>::operator[](int i)
{
	T* val=(T*)ChainGetEntry(_list,i);
	return *val;
}

template<class T> BIFSvector<T>& BIFSvector<T>::operator=(const BIFSvector<T>& vector)
{
	ChainReset(_list); 
	int i;
	for (i=0;i<ChainGetCount(vector._list);i++)
	{
		T* item=(T*)ChainGetEntry(vector._list,i);
		ChainAddEntry(_list,item);
	}
	return *this;
}

template<class T> void BIFSvector<T>::clear()
{
	for ( int i = 0; i < ChainGetCount(_list); i++ )
	{
		T* item;
		item = ( T* )ChainGetEntry( _list, i );
		delete item;
	}
	ChainReset(_list);	
}


#include "_ANMAtom.h"
#include "ABone.h"
//template BIFSvector<OgAtom*>;
//template BIFSvector<OgMeshAtom*>;
//template BIFSvector<OgFacesAtom*>;
//template BIFSvector<OgWedgesAtom*>;
template BIFSvector<Vec3f>;
template BIFSvector<unsigned int>;
//template BIFSvector<OgMeshAtom*>;
template BIFSvector<Vec2f>;
template BIFSvector<Color3f>;
//template BIFSvector<BoneInf>;
template BIFSvector<float>;
template BIFSvector<ANMAtom*>;
template BIFSvector<ANMBoneAtom*>;
template BIFSvector<ANMSkeletonAtom*>;
//template BIFSvector<OPCAtom*>;
//template BIFSvector<OPCTextureAtom*>;
//template BIFSvector<OPCMaterialAtom*>;
//template BIFSvector<STREAM_DATA>;
template BIFSvector<ABone*>;
template BIFSvector<matrix4*>;