/********************************************************************************/
/* This software module was developped by										*/

/*	   Marius Preda (MP), marius.preda@int-evry.fr,								*/
/*                        Institut National des Telecommunications, France		*/

/* in the course of development of the MPEG-4 standard (Part 16 AFX).			*/
/* This software module is an implementation of a part of one or				*/
/* more MPEG-4 tools as specified by the										*/
/* MPEG-4 standard. ISO/IEC gives users of the MPEG-4 standard					*/
/* free license to this software module or modifications thereof				*/
/* for use in hardware or software products claiming conformance				*/
/* to the MPEG-4 standard. Those intending to use this software					*/
/* module in hardware or software products are advised that its					*/
/* use may infringe existing patents. The original developer of					*/
/* this software module and his company, the subsequent							*/
/* editors and their companies, and ISO/IEC have no liability					*/
/* for use of this software module or modifications thereof in					*/
/* an implementation. Copyright is not released for non							*/
/* MPEG-4 standard conforming products. INT ARTEMIS								*/
/* retain full right to use the code for their own purposes,					*/
/* assign or donate the code to a third party and to inhibit					*/
/* third parties from using the code for non MPEG-4 standard					*/
/* conforming products. This copyright notice must be included					*/
/* in all copies or derivative works.    										*/
/* Copyright (c)2002 - 2005														*/
/********************************************************************************/

//#include<stdio.h>
#include<stdlib.h>

#include "CBBABone.h"

CBBABone::CBBABone(){
	prec=NULL;
	suiv=NULL;
 	boneDCTData = NULL;	
}

CBBABone::~CBBABone()
{

}


int innod(CBBABone *p,CBBABone * &first,CBBABone * &last)
{
	// add or update a bone content

  CBBABone *q;
  q=first;
  
  if(first==NULL){
      first=p;
      first->suiv=NULL;
      first->prec=NULL;
      last=p;
      last->prec=NULL;
      last->suiv=NULL;
      return 1;
    }
  if(p->boneIdentifier < first->boneIdentifier){
      p->suiv=first;
      p->prec=NULL;
      first->prec=p;
      first=p;
      return 1;
    }
  if(p->boneIdentifier > last->boneIdentifier){
      last->suiv=p;
      p->suiv=NULL;
      p->prec=last;
      last=p;
      return 1;
    }
  while (q){
	  if (p->boneIdentifier == q->boneIdentifier){
		q->boneMask=p->boneMask;
		q->boneDataIMax=p->boneDataIMax;
		q->boneDataIMin=p->boneDataIMin;
		q->boneDataPMax=p->boneDataPMax;
		q->boneDataPMin=p->boneDataPMin;
		q->canBePredicted=p->canBePredicted;
		q->isInCurrentFrame=true;
		return 0;
	  }
	  else q=q->suiv;
  }
  q=first;
  while (q){
	  while (p->boneIdentifier < q->boneIdentifier)
		q=q->suiv;
	  p->suiv=q;
	  p->prec=q->prec;
	  q->prec->suiv=p;
	  q->prec=p;
	  return 1;
  }
  return 1;
}



CBBABone *getnodindexi(int index,CBBABone * &first,CBBABone * &last)
{
  CBBABone *q;
  q=first;
  
  if(first==NULL){
      return NULL;
    }
  
  for (int i=0;i<index;i++)
	q=q->suiv;
  return q;
}

CBBABone *getnodIDi(int ID,CBBABone * &first,CBBABone * &last)
{
  CBBABone *q;
  q=first;
  
  if(first==NULL){
      return NULL;
    }
  
  while (q) {
	  if (q->boneIdentifier==ID)
		  return q;
	  q=q->suiv;
  }
  return q;
}


void outnod(CBBABone * p,CBBABone * &first,CBBABone * &last)
{
  
  if(first==NULL) return;

  if(p==first)
    {
      first=first->suiv;
      delete p;
      if(first==NULL) last=NULL;
      else first->prec=NULL;
      return;
     
    }
  if(p==last)
    {
      last=last->prec;
      delete p;
      if(last==NULL) first=NULL;
      else last->suiv=NULL;
      return;
    }
  p->prec->suiv=p->suiv;
  p->suiv->prec=p->prec;
  delete p;
}

void freeliste(CBBABone * &first,CBBABone* &last)
{
  CBBABone *p=NULL;

  if(first==NULL) return;
  
  do
    {
      p=first;
      outnod(p,first,last);
    }while(first != NULL);
}
      
 
void affiche_liste(CBBABone *first)
{
 
  CBBABone *p=NULL;
    
  if(first==NULL)
    {
      fprintf(stderr,"liste vide\n");
      return;
    }
  p=first;
  do
    {
     
      fprintf(stderr,"%d, ",p->boneIdentifier);
      p=p->suiv;
    }while(p != NULL);
  fprintf(stderr,"\n");
}
