#ifndef _BBATYPES_H_
#define _BBATYPES_H_

	typedef struct __vec2f
	{
		float x;
		float y;
	} M4Point2D;

	typedef struct __vec3f
	{
		float x;
		float y;
		float z;
	} M4Vec;


	/*vector4/quat/rotation*/
	typedef struct __vec4f
	{
		float x;
		float y;
		float z;
		float q;
	} M4Vec4;

	typedef struct {
		float	red;
		float	green;
		float	blue;
	} SFColor;

	typedef struct __vec2f SFVec2f;
	typedef struct __vec3f SFVec3f;
	typedef struct __vec4f SFRotation;
	typedef struct __vec4f SFVec4f;

	/**********************************************************************
					CHAIN: list tool
	**********************************************************************/
	typedef struct tagChain Chain;

	Chain *NewChain();
	/* don't forget to delete YOUR objects */
	void DeleteChain(Chain *ptr);
	/* Get the number of items */
	unsigned int ChainGetCount(Chain *ptr);
	/* Add an item at the end of the list */
	int ChainAddEntry(Chain *ptr, void* item);
	/* insert an item at the specified position (between 0 and ChainGetCount() - 1) */
	int ChainInsertEntry(Chain *ptr, void *item, unsigned int position);
	/* Delete an entry from the list (between 0 and ChainGetCount() - 1)
	Don't forget to delete your object as well ;) */
	int ChainDeleteEntry(Chain *ptr, unsigned int itemNumber);
	/* get the specified entry (between 0 and ChainGetCount() - 1) */
	void *ChainGetEntry(Chain *ptr, unsigned int itemNumber);
	/*returns entry index if found, -1 otherwise*/
	int ChainFindEntry(Chain *ptr, void *item);
	/*removes item by index. returns entry index if found, -1 otherwise*/
	int ChainDeleteItem(Chain *ptr, void *item);
	/*empty list content*/
	void ChainReset(Chain *ptr);

#endif //_BBATYPES_H_