// matrix4.h: interface for the matrix4 class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _MATRIX4_H_
#define _MATRIX4_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//#include "m4_scenegraph_vrml.h"
#include "math.h"
//#include <gpac/intern/m4_bifs_tables.h>
#include "memory.h"
#include "stdio.h"

#ifdef BBADECODER
#include "bbatypes.h"
#endif
  
class matrix4  
{

private:
	
	float* m;
	
	bool destroy;

public:
	matrix4();
	matrix4(const matrix4& mat);
	matrix4(float* mat, bool Destroy=false);
	virtual ~matrix4();

	void Clear();
	void setData(int x, int y, float val){ m[ x * 4 + y ] = val; }
	float Data(int x,int y){return m[x*4+y];}
	matrix4&	Identity();
	matrix4&	Translation(const SFVec3f &v);
	matrix4&	Rotation(const SFVec3f &v);
	matrix4&	Rotation(const SFRotation q);
	matrix4&	Scale(const SFVec3f &v);
	float		Determinant();
	matrix4		Invert();
	void		DumpToFile(const char* message, int boneid, int parentid);

	SFRotation	makeQuat(SFRotation q);
	SFRotation  unMakeQuat(SFRotation q);
	matrix4		operator*(matrix4 mat);
	matrix4&	operator=(const matrix4 mat);
	void		Assign(float* mat);

};

#endif // !defined(_MATRIX4_H_)
