// ostream.cpp: implementation of the ostream class.
//
//////////////////////////////////////////////////////////////////////

#include "ostream.h"

using namespace BIFS;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

ostream::ostream()
{
	_buffSize=0;
	_size=0;
	_delta=1024;
	_pos=0;
	_buffer=(char*)malloc(0);
}

ostream::~ostream()
{
	free(_buffer);
}

void ostream::EnlargeBuffer()
{
	_buffSize	+= _delta;
	_buffer		= ( char* ) realloc( _buffer, _buffSize );
}

void ostream::write(const char* buff,unsigned int size)
{
	while ( _pos + size >= _buffSize )
		EnlargeBuffer(); 
	memcpy( _buffer + _pos, buff, size);	
	_pos += size;
	if ( _pos > _size )
		_size = _pos;
}

void ostream::moveForward(unsigned int size)
{
	_pos += size;
}

void ostream::startBuffer()
{
	_pos = 0;
}

int ostream::readInt(unsigned int size)
{
	if ( _pos + 4 > _size )
		return 0;
	int data;	
	char* tempData;
	tempData=(char*)malloc(4);
	memset(tempData,0,4);
	memcpy(tempData,_buffer+_pos,size);
	_pos+=size;
	data= *((int*)(tempData));
	free(tempData);
	return data; 
}

float ostream::readFloat(unsigned int size)
{
	if ( _pos + 4 > _size )
		return 0;
	float data;	
	char* tempData;  
	tempData=(char*)malloc(4);
	memset(tempData,0,4);
	memcpy(tempData,_buffer+_pos,size);
	_pos+=size;
	data= *((float*) (tempData));
	free(tempData);
	return data;
}


void ostream::seekp(unsigned int position)
{
	if ( position <= _size)
		_pos = position;
}

void ostream::GetData(char** buff,int &size)
{
	size = _size;
	( *buff ) = ( char* ) malloc( size );
	memcpy( *buff, _buffer, _size );

}