/***********************************************************************
This software module was originally developed by James D. K. Kim, 
Sang Oak Woo and Shin Jun Lee(Samsung Advance Institute of Technology)
in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1)
standard. This software module is an implementation of a part of one or
more MPEG-4 Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4
Systems (ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 
Systems (ISO/IEC 14496-1) free license to this software module or 
modifications thereof for use in hardware or software products claiming
conformance to the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to 
use this software module in hardware or software products are advised that
its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Samsung Advance Institute of Technology
retains full right to use the code for his/her own purpose, assign or 
donate the code to a third party and to inhibit third parties from using
the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
This copyright notice must be included in all copies or derivative works.
Copyright ?2001
************************************************************************

For more information or to receive an up to date version of this module,
you may contact James D. K. Kim at jacobkim@sait.samsung.co.kr
----------------------------------------------------------------------*/

// OriIDPCMKeyValueD.h: interface for the OriIDPCMKeyValueD class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ORIIDPCMKEYVALUE_H__1CBA7829_779F_4098_96E3_2BD16255E038__INCLUDED_)
#define AFX_ORIIDPCMKEYVALUE_H__1CBA7829_779F_4098_96E3_2BD16255E038__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <stdio.h>
#include "Entropy.h"
#include "KeySelectionFlagD.h"
#include "OriIKeyValueHeaderD.h"
#include "OriIDPCMKeyValueHeaderD.h"
#include "JWTemplArray.h"
#include "QuaternionD.h"
#include "SFRotationD.h"
#include "Quantizer.h"
#include "QuatErrorD.h"
//#include "arithmeticDecoder.h"

class OriIDPCMKeyValueD  
{
public:
	OriIDPCMKeyValueD();
	virtual ~OriIDPCMKeyValueD();

public:
	void readBitstream(
		CAC_QFD& codec,
		OriIDPCMKeyValueHeaderD& kvHeader,
		int nNumKV
	);

	void InitializeModel();

	void decodingProcess(
		KeyHeaderD& kHeader,
		KeySelectionFlagD& ksFlag,
		OriIKeyValueHeaderD& oriIKVHeader,
		double* key,
		JWArrayD <SFRotationD>& keyValue,
		JWArrayD <QuaternionD>& keyValueQuat
	);

	void ICDPCM(
		int* curIDPCMKeyValue, 
		int deltaKeyValue, 
		int prevIDPCMKeyValue,
		int nKVQBit
	);

public:
	JWArrayD <QuaternionD>	DeltaKeyValue;
	
	SAIT_CACD						kvXUSignContext;
	SAIT_CACD						kvXUContext;
	SAIT_CACD						kvYUSignContext;
	SAIT_CACD						kvYUContext;
	SAIT_CACD						kvZUSignContext;
	SAIT_CACD						kvZUContext;
	SAIT_CACD						kvXSignContext;
	SAIT_CACD						kvXContext[32];
	SAIT_CACD						kvYSignContext;
	SAIT_CACD						kvYContext[32];
	SAIT_CACD						kvZSignContext;
	SAIT_CACD						kvZContext[32];
};

#endif // !defined(AFX_ORIIDPCMKEYVALUE_H__1CBA7829_779F_4098_96E3_2BD16255E038__INCLUDED_)
