/***********************************************************************
This software module was originally developed by James D. K. Kim, 
Sang Oak Woo and Shin Jun Lee(Samsung Advance Institute of Technology)
in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1)
standard. This software module is an implementation of a part of one or
more MPEG-4 Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4
Systems (ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 
Systems (ISO/IEC 14496-1) free license to this software module or 
modifications thereof for use in hardware or software products claiming
conformance to the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to 
use this software module in hardware or software products are advised that
its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Samsung Advance Institute of Technology
retains full right to use the code for his/her own purpose, assign or 
donate the code to a third party and to inhibit third parties from using
the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming products. 
This copyright notice must be included in all copies or derivative works.
Copyright ?2001
************************************************************************

For more information or to receive an up to date version of this module,
you may call Sang Oak Woo at sowoo@sait.samsung.co.kr
----------------------------------------------------------------------*/

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Interpolator Compression
FILE:       PosIKeyValueD.h
AUTHOR:     Sang Oak Woo (SAMSUNG AIT)
OVERVIEW:   Implementation of Interpolator Compression
-------------------------------------------------------------------------*/

// PosIKeyValueD.h: interface for the PosIKeyValueD class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_POSIKEYVALUE_H__96139878_055B_4122_BAD4_4FEC2E8F2F7A__INCLUDED_)
#define AFX_POSIKEYVALUE_H__96139878_055B_4122_BAD4_4FEC2E8F2F7A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "entropy.h"
#include "PosIKeyValueHeaderD.h"
#include "JWTemplArray.h"
#include "SSFVec3fD.h"

#include "JWTemplArray.h"
#include "SSFVec3fD.h"
#include "KeySelectionFlagD.h"

class PosIKeyValueD  
{
public:
	PosIKeyValueD();
	virtual ~PosIKeyValueD();

public:
	void readBitstream(
		CAC_QFD& codec, PosIKeyValueHeaderD kvHeader, 
		int nNumberOfKeyValue
	);

	void decodingProcess(
		PosIKeyValueHeaderD& kvHeader,
		KeySelectionFlagD& ksFlag,
		JWArrayD<double>& key,
		JWArrayD<SSFVec3fD>& keyValue
	);

	void InitializeModel();

public:
	int* keyValue_X;
	int* keyValue_Y;
	int* keyValue_Z;

	// model for arithmetic decoder
public:
	SAIT_CACD kvXSignContext;
	SAIT_CACD kvXUContext;
	SAIT_CACD kvXMaxValueContext;
	SAIT_CACD kvXFoundContext;
	SAIT_CACD kvXNotFoundContext;

	SAIT_CACD kvYSignContext;
	SAIT_CACD kvYUContext;
	SAIT_CACD kvYMaxValueContext;
	SAIT_CACD kvYFoundContext;
	SAIT_CACD kvYNotFoundContext;

	SAIT_CACD kvZSignContext;
	SAIT_CACD kvZUContext;
	SAIT_CACD kvZMaxValueContext;
	SAIT_CACD kvZFoundContext;
	SAIT_CACD kvZNotFoundContext;
};

#endif // !defined(AFX_POSIKEYVALUE_H__96139878_055B_4122_BAD4_4FEC2E8F2F7A__INCLUDED_)
