/*************************************************************************************

  Title		: Orientation Interpolator Fast Encoder
  Date		: 2002. 4.23
  Author	: Jameskim
  Contents	:
				̸   OrientationInterpolator data ȭϷκ ޾Ƶ鿩
				̸ quaternion · ٲٰ  а  ,
				ȭϴ   ̴.
				1. V. 1.0(2/23)
					- OrientationInterpolator node key, key value data ȣȭ
					- Linear Quantiztion, No Index, Inter Mode, Arithmetic ON
					- Key Selection  Lossy Coding
					-  encoding  ϳ file   quantization range
					   ÿ encoding

				2. V. 2.0(2002/4/23)
					- PDAM ö bitstream format ȯ(N4627)
	
**************************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <fstream>
using namespace std;

//#include "QuatEncoder.h"
#include "JWTemplArray.h"
#include "JWToken.h"
#include "JWInterpolator.h"
#include "JWOrientationInterpolator.h"
#include "CompressedOrientationInterpolator.h"
#include "main.h"


void ReadParameter(
	char argv[], 
	JWArray<double>& adThresholds,
	JWArray<int>& anKQBits,
	JWArray<int>& anKVQBits
);


void OIParseIM1Text(JWToken& token, JWInterpolator*& pInterpolator);
void OIWriteIM1Text(char* fileName, JWInterpolator* pInterpolator, char* buffer);
void KeySampling(char* orgFileName, char* quantFileName, int nNumberOfKey_Resampling, int nTempDigit);

char*gAAC, *gLinearKeyCoder, *gPreservingMode,
	*gKeyQuant, *gDPCM;


int SoWonOrientationInterpolator(std::vector<double> &key, std::vector<double> &keyvalue, std::string &_buf, int key_qp, int keyvalue_qp)
{
	char	fIn[256], fQout[256], fAacout[256], fErrorout[256];

	int argc = 11;
	char *argv[11]= {"", "ori_test.txt","q_output","acc_output","err_output","param.txt","k","l","uuu","k","1"};

	///////////////////////////////////////////////////////////////
	//
	//	Resampling Routine
	//
	//	2002.01.28. SOWOO
	// 
	// 1) key  ,  key ũ Ǵ ۰...
	// 2) Ȯ ©? Key Digit?
	//
	///////////////////////////////////////////////////////////////

	int nNumberOfKey_Resampling = 0;

	if(argc > 11)
		nNumberOfKey_Resampling = ::atoi(argv[11]);
	else
		nNumberOfKey_Resampling = -1;


	// sowoo 20020125
	bool bCuttingByDigit = false;

	if(argc > 12)
		bCuttingByDigit = (argv[12][0] == 'd')? true: false;
	else
		bCuttingByDigit = false;

	int nTempDigit = -1;



	//-----------------------------------------------------------------------------
	//
	// key resampling - by sowoo
	// ̰ key resamplingؼ ٽ ϳ....
	//
	//-----------------------------------------------------------------------------
	if(nNumberOfKey_Resampling > 0)
	{
		KeySampling(argv[1], argv[2], nNumberOfKey_Resampling, nTempDigit);

		return 0;
	}
	///////////////////////////////////////////////////////////////



	strcpy(fIn, argv[1]);
	strcpy(fQout, argv[2]);
	strcpy(fAacout, argv[3]);
	strcpy(fErrorout, argv[4]);

	bool bUseKeyCoder = true; // Always true
	bool bPreserveKey = (argv[6][0] == 'k')? true: false;
	bool IsLinearKeyCoder = (argv[7][0] == 'l')? true: false;

	bool bIsUnaryAAC_X = (argv[8][0] == 'u')? true: false;
	bool bIsUnaryAAC_Y = (argv[8][1] == 'u')? true: false;
	//bool bIsUnaryAAC_Z = (argv[8][1] == 'u')? true: false;
	bool bIsUnaryAAC_Z = (argv[8][2] == 'u')? true: false;


	bool bKeyQuant = (argv[9][0] == 'k')? true: false;
	char chDPCM = argv[10][0];



	gAAC = argv[8];
	gLinearKeyCoder = argv[7];
	gPreservingMode = argv[6];
	gKeyQuant = argv[9];
	gDPCM = argv[10];




	JWArray<int> anKQBits;
	JWArray<int> anKVQBits;
	JWArray<double> adThresholds;

	adThresholds.Add(atof("0.06"));
	anKQBits.Add(key_qp);
	anKVQBits.Add(keyvalue_qp);

	// ---------------------------------------------------------
	//
	// Compressed OrientationInterpolator encoding
	//
	// ---------------------------------------------------------
	CompressedOrientationInterpolator compressedOriInterp;
	compressedOriInterp.encode(key, keyvalue, argv[2], argv[3], argv[4],
								bPreserveKey, IsLinearKeyCoder, 
								bIsUnaryAAC_X, bIsUnaryAAC_Y, bIsUnaryAAC_Z,
								bKeyQuant, chDPCM,
								adThresholds, anKQBits, anKVQBits);

	ifstream fi;
	fi.open(argv[3], ios::in | ios::binary);
	char c;
	while(fi.get(c)) _buf.push_back (c);
	fi.close();

	return 0;
}


void KeySampling(char* orgFileName, char* quantFileName, int nNumberOfKey_Resampling, int nTempDigit)
{
	// ù° Interpolator д´.
	JWToken token;
	if(!token.SetFile(orgFileName))
	{
		cout << "Cannot open file " << endl;
		cout << "File Name: " << orgFileName << endl;

		return;
	}

	JWInterpolator* pInterpolator = NULL;

	OIParseIM1Text(token, pInterpolator);

	pInterpolator->Resampling(
		nNumberOfKey_Resampling, nTempDigit);

	char aBuffer[256];
	sprintf(aBuffer, "%s_Resampling_%d.txt", quantFileName, nNumberOfKey_Resampling);

	//pInterpolator->SetDEF("myPOSITION");
	pInterpolator->SetDEF("myORIENTATION");

	char aBuffer2[256];
	sprintf(aBuffer2,
		"#File=%s_Resampling_%d.txt,Type=Real,OriginalSceneFile=NONE,OriginalFile=NONE,Company=SamsungAIT,NumberOfKeys=%d,AverageDistortion=0,NumberOfVertices=1",
		quantFileName, nNumberOfKey_Resampling, nNumberOfKey_Resampling
	);

	OIWriteIM1Text(aBuffer, pInterpolator, aBuffer2);


	if(pInterpolator != NULL)
		delete pInterpolator;

	return;
}

void ReadParameter(
	char argv[], 
	JWArray<double>& adThresholds,
	JWArray<int>& anKQBits,
	JWArray<int>& anKVQBits
)
{
	char buffer[256];
	ifstream file(argv);

	// 1. THRESHOLD
	// 1.1 dummy line
	file.getline(buffer, 256);

	file.getline(buffer, 256);
	do {
		adThresholds.Add(atof(buffer));
		file.getline(buffer, 256);
	} while(strcmp(buffer, "KEY") != 0);


	// 2. KEY-Q-Bit
	file.getline(buffer, 256);
	do {
		anKQBits.Add(atoi(buffer));
		file.getline(buffer, 256);
	} while(strcmp(buffer, "KEYVALUE") != 0);

	// 3. KEYVALLUE-Q-Bit
	do {
		file.getline(buffer, 256);
		anKVQBits.Add(atoi(buffer));
	} while(file.peek() != -1);

	file.close();
}




void OIWriteIM1Text(char* fileName, JWInterpolator* pInterpolator, char* buffer)
{
	ofstream file;
	file.open(fileName);

	if(!file.is_open())
	{
		cout << "    . ̾~" << endl;
		cout << "File Name: " << fileName << endl;
		return;
	}

	// 1. Comment ۼѴ.
	file << buffer << endl << endl;

	// 2. Group .
	file << "Group {" << endl;
	file << '\t' << "children [" << endl;
	pInterpolator->Write(file);
	file << '\t' << ']' << endl;
	file << '}' << endl;

	file.close();
}


void OIParseIM1Text(JWToken& token, JWInterpolator*& pInterpolator)
{
	bool bIsDEF = false;
	char buffer[256];

	token.GetNextToken();
	if(token == Group)
	{
		token.GetNextToken();
		if(token == BRACE_OPEN)
		{
			token.GetNextToken();
			if(token == children)
			{
				token.GetNextToken();
				if(token == SQUAREBRACKET_OPEN)
				{
					token.GetNextToken();
					
					// DEF ״ Ư ó !
					if(token == DEF)
					{
						// DEF Name о,
						token.GetNextToken();

						// DEF Name Ѵ.
						bIsDEF = true;
						::strcpy(buffer, token);

						// Node ̸ д´.
						token.GetNextToken();
					}

					switch(token)
					{
					/*
					case PositionInterpolator:
						// PositionInterpolator class ϰ,
						// Parsingϵ Ѵ.
						pInterpolator = new JWPositionInterpolator;
						pInterpolator->Parse(token);
						break;
					*/
					case OrientationInterpolator:
						pInterpolator = new JWOrientationInterpolator;
						pInterpolator->Parse(token);
						break;
					}

					if(bIsDEF)
						pInterpolator->SetDEF(buffer);
				}

				if(token == SQUAREBRACKET_CLOSE)
				{
					token.GetNextToken();
				}
			}
		}

		if(token == BRACE_CLOSE)
		{
		}
	}
}
