#ifndef _CMDARGUMENTS_H_
#define _CMDARGUMENTS_H_


/******************************************************************************\
* Includes
\******************************************************************************/

#include <stdlib.h>
#include <string.h>

/******************************************************************************\
* Defines
\******************************************************************************/


/******************************************************************************\
* Class CDMArguments
this class parse the arguments for mp4 encoders
if not suplied, some "default" coefficients for encding are aplied.
\******************************************************************************/
class CMDArguments
{
	public:

	CMDArguments(void);
	~CMDArguments(void);

	//methods
	void Parse( int argc, char* argv[] );
	


	//variables
	int		type;
	char*	fileInput;
	char*	fileOutput;
	bool isFAMC;

	int m_dmc_bitsPerCoord ;
	int m_dmc_bitsPerNormal  ;
	int m_dmc_bitsPerColor ;
	int m_dmc_bitsPerTexCoord   ;
	int m_dmc_img_flag;
	int m_dmc_img_u ;
	int m_dmc_img_v ;
	int m_dmc_coordPrediction  ;
	int m_dmc_normalPrediction ;
	int m_dmc_colorPrediction ;
	int m_dmc_texCoordPrediction ;
	int m_dmc_erMode;   
	int m_dmc_packetSize;
	int m_dmc_boundaryPrediction;
	bool m_dmc_hierarchicalMode ;
	bool m_dmc_saveClsFile    ;
	bool m_dmc_saveWrlLevels  ;
	bool m_dmc_vertex_order_flag ;
	bool m_dmc_face_order_flag  ;
	bool m_dmc_face_order_per_CC_flag ;
	bool m_dmc_vertex_order_per_CC_flag ;

	int m_bba_automatic;
	int m_bba_P_frames;
	int m_bba_coding_type;
	int m_bba_p2q;
	int m_bba_qs;
	
	int m_famc_sizeAnimSeg;
	int m_famc_transformType;
	double m_famc_globalRMSE;
	double m_famc_ratioWeights;
	int m_famc_qAT;
	int m_famc_qCoord;
	int m_famc_qNormal;
	int m_famc_qColor;
	int m_famc_qOther;
	int m_famc_LD_auto;
	int m_famc_LD_L;
	int m_famc_LD_l;
	int m_famc_LD_P;
	int m_famc_LD_B;
	int m_famc_LD_Pred;
	int m_famc_SNR_L;
	int m_famc_SNR_l;
	int m_famc_Normal_Pred;

	int m_ic_key_qp;
	int m_ic_keyvalue_qp;
};


#endif //_CMDARGUMENTS_H_