#ifndef _MP43DMC_H_
#define _MP43DMC_H_

/******************************************************************************\
* Includes
\******************************************************************************/
#include <stdlib.h>
#include <string.h>


/******************************************************************************\
* Class MP43DMC
\******************************************************************************/
class MP43DMC
{
public:
	//de/constructor
	MP43DMC(int coordinate_number=0, int normal_number=0, int text_coordinate_number=0, int color_number=0, int index_coordinate_number=0, int index_normal_number=0, int index_text_coordinate_number=0, int index_color_number=0, int DMCID = 0, const char * fileID="" );
	
	~MP43DMC(void);

	//methods
	bool AddCoordinate( float x, float y, float z );
	bool AddNormal( float nx, float ny, float nz );
	bool AddTextureCoordinate( float u, float v );
	bool AddColor( float r, float g, float b );
	bool AddCoordinateIndex( int first, int second, int third );
	bool AddNormalIndex( int first, int second, int third );
	bool AddTextureCoordinateIndex( int first, int second, int third );
	bool AddColorIndex( int first, int second, int third );
	int  GetCoordinateCount () { return m_coordinatesCount* 3; }
	int  GetNormalCount ()	{ return m_normalsCount* 3; }
	int  GetTextureCoordinateCount () { return m_texturecoordinatesCount* 2; }
	int  GetColorCount () { return m_colorsCount* 3; }
	int  GetCoordinateIndexCount () { return m_coordintesIndexCount * 4; }
	int  GetNormalIndexCount () { return m_normalsIndexCount* 4; }
	int  GetTextureCoordinateIndexCount () { return m_texturecoordinateIndexCount* 4; }
	int  GetColorIndexCount () { return m_colorsIndexCount* 4; }
	float*  GetCoordinate () { return m_pcoordinates; }
	float*  GetNormal ()	{ return m_pnormals; }
	float*  GetTextureCoordinate () { return m_ptexturecoordinates; }
	float*  GetColor () { return m_pcolors; }
	int*  GetCoordinateIndex () { return m_pcoordintesIndex; }
	int*  GetNormalIndex () { return m_pnormalsIndex; }
	int*  GetTextureCoordinateIndex () { return m_ptexturecoordinateIndex; }
	int*  GetColorIndex () { return m_pcolorsIndex; }

	int Get3DMCID(){ return m_3DMCID; }
	const char* Get3DMCFileID(){ return m_pfileID; }
	void Set3DMCFileID( const char* fileID ){ if( m_pfileID) free(m_pfileID); m_pfileID = strdup(fileID); }

//private
	public:
	
	//variables
	int		m_coordinatesCount;
	int		m_normalsCount;
	int		m_texturecoordinatesCount;
	int		m_colorsCount;
	int		m_coordintesIndexCount;
	int		m_normalsIndexCount;
	int		m_texturecoordinateIndexCount;
	int		m_colorsIndexCount;

	float* m_pcoordinates;
	float* m_pnormals;
	float* m_ptexturecoordinates;
	float* m_pcolors;
	int*   m_pcoordintesIndex;
	int*   m_pnormalsIndex;
	int*   m_ptexturecoordinateIndex;
	int*   m_pcolorsIndex;

	int		m_coordinatesPos;
	int		m_normalsPos;
	int		m_texturecoordinatesPos;
	int		m_colorsPos;
	int		m_coordintesIndexPos;
	int		m_normalsIndexPos;
	int		m_texturecoordinateIndexPos;
	int		m_colorsIndexPos;

	int		m_3DMCID;
	char*	m_pfileID;

};

struct MeshFrame
	{
		MP43DMC* mesh;
		float time;
	};

//typedef std::vector<MeshFrame> MeshFrameList;



#endif //_MP43DMC_H_
