#ifndef _MATRIX_H_
#define _MATRIX_H_

/******************************************************************************\
* Includes
\******************************************************************************/
#include "math.h"
#include "memory.h"
#include "stdio.h"
#include "malloc.h"

/******************************************************************************\
* Structures
\******************************************************************************/
typedef struct {
	float	x;
	float	y;
	float	z;
} Vec3f;

typedef struct {
	float	x;
	float	y;
	float	z;
	float	q;
} Vec4f;


/******************************************************************************\
* Class matrix
\******************************************************************************/


class matrix  
{

private:
	
	float* m;
	
	bool destroy;

public:
	matrix();
	matrix(const matrix& mat);
	matrix(float* mat, bool Destroy=false);
	virtual ~matrix();

	void Clear();
	void setData(int x, int y, float val){ m[ x * 4 + y ] = val; }
	float Data(int x,int y){return m[x*4+y];}
	matrix&	Identity();
	matrix&	Translation(const Vec3f &v);
	matrix&	Rotation(const Vec3f &v);
	matrix&	Rotation(const Vec4f q);
	matrix&	Scale(const Vec3f &v);
	float		Determinant();
	matrix		Invert();
	

	Vec4f		makeQuat(Vec4f q);
	Vec4f		unMakeQuat(Vec4f q);
	matrix		operator*(matrix mat);
	matrix&		operator=(const matrix mat);
	void		Assign(float* mat);

};








#endif //_MATRIX_H_