
#ifndef _MP4TOVBLIB_H_
#define _MP4TOVBLIB_H_
 
enum textureType
{
	TT_NONE		= 0,
	TT_BMP		= 1,
	TT_JPEG		= 2,
	TT_JPEG2000 = 3
};

enum outputType
{
	NOTHING = -1,
	OUT_VB	= 0,
	OUT_IFS	= 1
};
// initializes the library, call this function first
int MP4toVBLib_Init();

// Frees the memory for data in the library, call it at the end
int MP4toVBLib_Free();

// Loads and processes the mp4 file
int MP4toVBLib_LoadMP4File( const char *FileName, outputType type );

//Returns the size of the bifs track in mp4 file
int MP4toVBLib_GetBIFSSize();
//the buffer is allocated inside the function

int MP4toVBLib_GetBIFS( unsigned char* &buff, int &size, bool alloc );
// Returns the size of the output buffer
int MP4toVBLib_GetVBBufferSize();

// If alloc is true, the buffer is allocated inside the function
// If alloc is false, the buffer should be allocated before calling the function
int MP4toVBLib_GetVB( unsigned char* &buff, int &size, bool alloc );

// Returns the size of the appearance output buffer
int MP4toVBLib_GetAppBufferSize();

// If alloc is true, the buffer is allocated inside the function
// If alloc is false, the buffer should be allocated before calling the function
int MP4toVBLib_GetAppBuffer( unsigned char* &buff, int &size, bool alloc );

// Returns the number of textures
int MP4toVBLib_GetTextureCount();

// Returns the size of the texture
int MP4toVBLib_GetTextureSize( unsigned int texID );
// If alloc is true, the buffer is allocated inside the function
// If alloc is false, the buffer should be allocated before calling the function
int MP4toVBLib_GetTexture( unsigned int texID, unsigned char* &buff, int &size, textureType &type, bool alloc );

// Decompreses the textures. 
// After calling this function all textures are decompressed
// and the compressed textures are no longer availible
int MP4toVBLib_DecompressTextures();

// Returns the number of animatons
int MP4toVBLib_GetBBACount();
// Returns the size of the bba encoded buffer
int MP4toVBLib_GetBBASize( unsigned int ID );
// If alloc is true, the buffer is allocated inside the function
// If alloc is false, the buffer should be allocated before calling the function
int MP4toVBLib_GetBBA( unsigned int ID, unsigned char* &buff, int &size, bool alloc );
// If alloc is true, the buffer is allocated inside the function
// If alloc is false, the buffer should be allocated before calling the function
int MP4toVBLib_GetBBAbyRef( const char* metaName, unsigned char* &buff, int &size, bool alloc );
// Returns the number of 3dmc tracks
int MP4toVBLib_Get3DMCCount();
// Returns the size of the 3DMC buffer
int MP4toVBLib_Get3DMCSize( unsigned int ID );
// If alloc is true, the buffer is allocated inside the function
// If alloc is false, the buffer should be allocated before calling the function
int MP4toVBLib_Get3DMC( unsigned int ID, unsigned char* &buff, int &size, bool alloc );
// If alloc is true, the buffer is allocated inside the function
// If alloc is false, the buffer should be allocated before calling the function
int MP4toVBLib_Get3DMCbyMetaName( const char* metaName, unsigned char* &buff, int &size,  bool alloc );
// If alloc is true, the buffer is allocated inside the function
// If alloc is false, the buffer should be allocated before calling the function
int MP4toVBLib_Get3DMCbyRef( const char* metaName, unsigned char* &buff, int &size, bool alloc );
// If alloc is true, the buffer is allocated inside the function
// If alloc is false, the buffer should be allocated before calling the function

int MP4toVBLib_GetTexturebyRef( const char* metaName, unsigned char* &buff, int &size, bool alloc );
// If alloc is true, the buffer is allocated inside the function
// If alloc is false, the buffer should be allocated before calling the function

int MP4toVBLib_GetFAMCCount();
// Returns the size of the 3DMC buffer
int MP4toVBLib_GetFAMCSize( unsigned int ID );
// If alloc is true, the buffer is allocated inside the function
// If alloc is false, the buffer should be allocated before calling the function
int MP4toVBLib_GetFAMC( unsigned int ID, unsigned char* &buff, int &size, bool alloc );
// If alloc is true, the buffer is allocated inside the function
// If alloc is false, the buffer should be allocated before calling the function
int MP4toVBLib_GetFAMCbyRef( const char* metaName, unsigned char* &buff, int &size, bool alloc );

int MP4toVBLib_GetRAR( unsigned char* &buff, int &size, bool alloc );
// If alloc is true, the buffer is allocated inside the function
// If alloc is false, the buffer should be allocated before calling the function
int MP4toVBLib_GetRARfromMETA( unsigned char* &buff, int &size, bool alloc );
int MP4toVBLib_GetXMLfromMETA( unsigned char* &buff, int &size,  bool alloc );
#endif //_MP4TOVBLIB_H_
