#include "MP4toX3DDecode.h"

#include "DecodeMP4Streams.h"
//#include "MP4Animation.h"
#include "MP43DMC.h"
#include "MP4toVBLib.h"
//#include "MPG_IfsQ_C_Ifs.h"
//#include "MPG_IfsQ_E_Ifs.h"
#include "matrix.h"
#include "gpac/scenegraph.h"
#include "gpac/scene_manager.h"
#include "gpac/internal/scenegraph_dev.h"
#include "gpac/nodes_x3d.h"

MP4toX3DDecode::MP4toX3DDecode(void)
{
}

MP4toX3DDecode::~MP4toX3DDecode(void)
{
}

bool MP4toX3DDecode::RestoreXML( const char * x3dFileName )
{
	
	unsigned char * restBuff = NULL;
	int				restBuffSize = 0;
	MP4toVBLib_GetXMLfromMETA( restBuff ,restBuffSize,true);

	DecodeMP4Streams *ds= new DecodeMP4Streams();
	MP43DMC * dmc = NULL;
	ds->DecodeXMLStream( restBuff, restBuffSize);
	if (restBuff)
		free(restBuff);
	restBuff = NULL;
	restBuffSize =0;
	ds->GetDecodedXML( restBuff, restBuffSize,true);
	delete ds;

	FILE *x3d;
	x3d = fopen( x3dFileName , "wb");
	fwrite(restBuff, restBuffSize,1,x3d);
	fclose( x3d );
	if (restBuff)
		free( restBuff );
	
	return true;
}


bool MP4toX3DDecode::RestoreGeometry( const char * x3dFileName )
{
	
	unsigned char* buff= NULL;
	int buffSize = 0;

	// open the empty x3d file
	GF_SceneLoader		lc;
	memset(&lc,0, sizeof(lc));
	lc.scene_graph = gf_sg_new();
	lc.type = GF_SM_LOAD_X3D;
	lc.ctx = gf_sm_new( lc.scene_graph );

	FILE *f;
	f = fopen( x3dFileName , "r" );
	fseek( f, 0, SEEK_END );
	int size = ftell( f );
	fseek( f, 0, SEEK_SET );
	char *str = (char*) malloc( size+1 );
	fread( str, 1, size, f );
	fclose( f );
	str[size]=0;
	
	//parse file in a string
	gf_sm_load_string( &lc, str, true );

	free( str );


	//
	int cur = 0;
	for ( unsigned int i = 0; i < gf_list_count(lc.scene_graph->all_nodes); i++ )
	{
		GF_Node* pNode = (GF_Node*)gf_list_get( lc.scene_graph->all_nodes, i );
		
		if ( pNode->sgprivate->tag == TAG_X3D_IndexedFaceSet  )
		{
			X_IndexedFaceSet* pIfs = (X_IndexedFaceSet*)pNode;
			X_Coordinate* pCoord = NULL;
			X_Normal* pNormal = NULL;
			X_TextureCoordinate* pTexCoord = NULL;
			X_Color* pColor = NULL;
			MFInt32* pCoordIndex = NULL;
			MFInt32* pNormalIndex = NULL;
			MFInt32* pTexCoordIndex = NULL;
			MFInt32* pColorIndex = NULL;

			//find appopriate 3DMC
			
			char ref[10] ; 
			itoa( gf_node_get_id( (GF_Node*) pIfs ), ref,10);
			if ( !MP4toVBLib_Get3DMCbyRef( ref,  buff, buffSize, true ) )
				continue;
			DecodeMP4Streams *ds= new DecodeMP4Streams();
			MP43DMC * dmc = NULL;
			ds->Decode3DMCStream((char*)buff, buffSize);
			free( buff );
			dmc = ds->GetDecoded3DMC();


			//put values from 3DMC in BIFS
			
			if (dmc->GetCoordinateCount() != 0 )
			{
				pCoord = ( X_Coordinate* ) pIfs->coord;	
				pCoord->point.count = dmc->GetCoordinateCount()/3;
				SFVec3f* values = (SFVec3f*) malloc( dmc->GetCoordinateCount()/3 * sizeof (SFVec3f));
				for (int c=0; c<dmc->GetCoordinateCount();)
				{
					values[c/3].x = dmc->GetCoordinate()[c++];
					values[c/3].y = dmc->GetCoordinate()[c++];
					values[c/3].z = dmc->GetCoordinate()[c++];
				}
				pCoord->point.vals = values;
			}
			
			if (dmc->GetNormalCount() != 0 )
			{
				pNormal = ( X_Normal* ) pIfs->normal;	
				pNormal->vector.count = dmc->GetNormalCount()/3;
				SFVec3f* values = (SFVec3f*) malloc( dmc->GetNormalCount()/3 * sizeof (SFVec3f));
				for (int c=0; c<dmc->GetNormalCount();)
				{
					values[c/3].x = dmc->GetNormal()[c++];
					values[c/3].y = dmc->GetNormal()[c++];
					values[c/3].z = dmc->GetNormal()[c++];
				}
				pNormal->vector.vals = values;
				
			}
		
			if (dmc->GetTextureCoordinateCount() != 0 )
			{
				pTexCoord = ( X_TextureCoordinate* ) pIfs->texCoord;	
				pTexCoord->point.count = dmc->GetTextureCoordinateCount()/2;
				SFVec2f* values = (SFVec2f*) malloc( dmc->GetTextureCoordinateCount()/2 * sizeof (SFVec2f));
				for (int c=0; c<dmc->GetTextureCoordinateCount();)
				{
					values[c/2].x = dmc->GetTextureCoordinate()[c++];
					values[c/2].y = dmc->GetTextureCoordinate()[c++];
				}
				pTexCoord->point.vals = values;
				
			}
		
			if (dmc->GetColorCount() != 0 )
			{
				pColor = ( X_Color* ) pIfs->color;	
				pColor->color.count = dmc->GetColorCount()/3;
				SFColor* values = (SFColor*) malloc( dmc->GetColorCount()/3 * sizeof (SFColor));
				for (int c=0; c<dmc->GetColorCount();)
				{
					values[c/3].red= dmc->GetColor()[c++];
					values[c/3].green = dmc->GetColor()[c++];
					values[c/3].blue = dmc->GetColor()[c++];
				}
				pColor->color.vals = values;
				
			}
		
			u32 parCount = gf_node_get_parent_count( (GF_Node*) pCoord );

			if (dmc->GetCoordinateIndexCount() != 0 )
			{
				u32 off = 0;
				for ( u32 j = 0; j < parCount; j++ )
				{
					X_IndexedFaceSet* par = (X_IndexedFaceSet*)gf_node_get_parent((GF_Node*)pCoord, j);
					par->coordIndex.count = par->coordIndex.vals[0]; //dmc->GetCoordinateIndexCount();
					free(par->coordIndex.vals);
					s32* values = (s32*) malloc( par->coordIndex.count * sizeof (s32));
					for (int c = 0; c < par->coordIndex.count; c++ )
						values[c]= dmc->GetCoordinateIndex()[c + off];
					par->coordIndex.vals = values;
					off += par->coordIndex.count;
				}
			}
				
			if (dmc->GetNormalIndexCount() != 0)
			{
				u32 off = 0;
				for ( u32 j = 0; j < parCount; j++ )
				{
					X_IndexedFaceSet* par = (X_IndexedFaceSet*)gf_node_get_parent((GF_Node*)pCoord, j);
					par->normalIndex.count = par->normalIndex.vals[0]; //dmc->GetNormalIndexCount();
					free(par->normalIndex.vals);
					s32* values = (s32*) malloc( par->normalIndex.count * sizeof (s32));
					for (int c = 0; c < par->normalIndex.count; c++ )
						values[c] = dmc->GetNormalIndex()[c + off];
					par->normalIndex.vals = values;
					off += par->normalIndex.count;
				}
			}

			if (dmc->GetTextureCoordinateIndexCount() != 0)
			{
				u32 off = 0;
				for ( u32 j = 0; j < parCount; j++ )
				{
					X_IndexedFaceSet* par = (X_IndexedFaceSet*)gf_node_get_parent((GF_Node*)pCoord, j);
					par->texCoordIndex.count = par->texCoordIndex.vals[0];//dmc->GetTextureCoordinateIndexCount();
					free(par->texCoordIndex.vals);
					s32* values = (s32*) malloc( par->texCoordIndex.count * sizeof (s32));
					for (int c = 0; c < par->texCoordIndex.count; c++ )
						values[c] = dmc->GetTextureCoordinateIndex()[c + off];
					par->texCoordIndex.vals = values;
					off += par->texCoordIndex.count;
				}
			}

			if (dmc->GetColorIndexCount() != 0)
			{
				u32 off = 0;
				for ( u32 j = 0; j < parCount; j++ )
				{
					X_IndexedFaceSet* par = (X_IndexedFaceSet*)gf_node_get_parent((GF_Node*)pCoord, j);
					par->colorIndex.count = par->colorIndex.vals[0];//dmc->GetColorIndexCount();
					free(par->colorIndex.vals);
					s32* values = (s32*) malloc( par->colorIndex.count * sizeof (s32));
					for (int c = 0; c < par->colorIndex.count; c++ )
						values[c] = dmc->GetColorIndex()[c + off];
					par->colorIndex.vals = values;
					off += par->colorIndex.count;
				}
			}
		}
	}
			
	//dump new scene in file m_pRestX3DFileName
	char* tmp =  (char*) malloc ( strlen(x3dFileName)+5);
	strcpy( tmp, x3dFileName );
	gf_sm_dump( lc.ctx, tmp , GF_SM_DUMP_X3D_XML );	
	free ( tmp );
	
	return true;
}

bool MP4toX3DDecode::RestoreX3DFile(  const char * mp4FileName, const char* x3dFileName )
{
	MP4toVBLib_Init();
	MP4toVBLib_LoadMP4File( mp4FileName, NOTHING);
	
	RestoreXML( x3dFileName );

	RestoreGeometry(x3dFileName );
	//RestoreAnimation( file );
	//RestoreImages( file );
	
	MP4toVBLib_Free();

	return true;

	
}
