#include "Animation.h"

//AnimationBuff class
AnimationBuff::AnimationBuff(char * AnimBuff, int AnimBuffSize, bool hierarchy)
{
	
	BIFS::ostream as;
	as.write( (char*) AnimBuff, AnimBuffSize );
	as.seekp( 0 );

	size			= as.readInt( 4 );	
	hasHierarchy	= as.readInt( 1 );
	if (( hasHierarchy ) && ( hierarchy ))
	{
		hier = new Hierarchy();
		hier->ReadHierarchy( as );
	}
	NoFrames		= as.readInt ( 4 );
	frames = (Frames**) malloc (NoFrames * sizeof( Frames* ));
	for (int i=0; i < NoFrames; i++)
	{
		frames[i] = new Frames();
		frames[i]->ReadFrames( as );
	}
}


AnimationBuff::~AnimationBuff(void)
{
	delete hier;
}


//Hierarchy class
Hierarchy::Hierarchy(void)
{
	size		= 0;
	rootCount	= 0;
	roots		= NULL;

}

Hierarchy::~Hierarchy(void)
{
	for (int i=0; i<rootCount; i++)
		delete roots[i];
	free( roots );
}

void Hierarchy::ReadHierarchy(BIFS::ostream &str)
{
		size		= str.readInt( 4 );	
		rootCount	= str.readInt( 4 );
		roots = (Bone**) malloc(rootCount * sizeof (Bone*));
		for (int i=0; i<rootCount; i++)
		{
			Bone *b = new Bone();
			b->ReadBone( str );
			roots[i] = b;
		}
			
}



//Bone class
Bone::Bone(void)
{
	idBone		= 0;
	childCount	= 0;

}

Bone::~Bone(void)
{
	for (int i=0; i<childCount; i++)
		delete child[i] ;
	free( child );
}

void Bone::ReadBone ( BIFS::ostream &str )
{
	
	idBone			= str.readInt( 4 );	
	childCount		= str.readInt( 4 );	
	child			= (Bone**) malloc(childCount * sizeof (Bone*));
	for (int i=0; i<childCount; i++)
	{
		child[i] = new Bone;
	    child[i]->ReadBone ( str );	

	}
}

//Frames class
void Frames::ReadFrames(BIFS::ostream &str)
{
		size		    = str.readInt( 4 );	
		boneDataCount	= str.readInt( 4 );
		
		bonesData  = (BoneData **) malloc(boneDataCount  * sizeof (BoneData*));
		for (int i=0; i<boneDataCount ; i++)
		{
			BoneData *bd = new BoneData ();
			bd->ReadBoneData( str );
			bonesData [i] = bd;
		}
			
}

Frames::Frames(void)
{
}

//BoneData class

void BoneData ::ReadBoneData ( BIFS::ostream &str )
{
	
	boneDataMask = 0;
	boneDataMask = str.readInt( 1 );
	//to do
	hasTranslation		=	boneDataMask & 0x00000001;
	isQuaternion		=	boneDataMask & 0x00000002;
	hasRotation			=	boneDataMask & 0x00000004;
	hasCenter			=	boneDataMask & 0x00000008;
	hasScaleOrientation	=	boneDataMask & 0x00000010;
	hasScale			=	boneDataMask & 0x00000020;
	if (hasTranslation)
	{
		Translation.x = str.readFloat ( 4 );
		Translation.y = str.readFloat ( 4 );
		Translation.z = str.readFloat ( 4 );
	}
	if (hasRotation)
	{
		Rotation.x = str.readFloat ( 4 );
		Rotation.y = str.readFloat ( 4 );
		Rotation.z = str.readFloat ( 4 );
		Rotation.q = str.readFloat ( 4 );
	}
	if (hasCenter)
	{
		Center.x = str.readFloat ( 4 );
		Center.y = str.readFloat ( 4 );
		Center.z = str.readFloat ( 4 );
	}
	if (hasScaleOrientation)
	{
		ScaleOrientation.x = str.readFloat ( 4 );
		ScaleOrientation.y = str.readFloat ( 4 );
		ScaleOrientation.z = str.readFloat ( 4 );
		ScaleOrientation.q = str.readFloat ( 4 );
	}
	if (hasScale)
	{
		Scale.x = str.readFloat ( 4 );
		Scale.y = str.readFloat ( 4 );
		Scale.z = str.readFloat ( 4 );
	}

}

BoneData ::BoneData(void)
{

}