#pragma once
#include "ostream.h"
//#include "gpac/scenegraph_vrml.h"

typedef struct {
	float	x;
	float	y;
	float	z;
} Vec3f;

typedef struct {
	float	x;
	float	y;
	float	z;
	float	q;
} Vec4f;

class Bone
{
	public:
	Bone(void);
	~Bone(void);
	//variables
	int idBone;
	int childCount;
	Bone **child;
	//methods
	void ReadBone (BIFS::ostream &str );

};

class Hierarchy
{
public:
	Hierarchy(void);
	~Hierarchy(void);

	//variables
	int		size;
	int		rootCount;
	Bone	**roots;
	//methods
	void ReadHierarchy(BIFS::ostream &str);

};



class BoneData
{
public:	
	BoneData(void);
	~BoneData(void);
	//variables
	int	 boneDataMask;
	bool hasTranslation;
	bool isQuaternion;
	bool hasRotation;
	bool hasCenter;
	bool hasScaleOrientation;
	bool hasScale;
	Vec3f Translation;
	Vec4f Rotation;
	Vec3f Center;
	Vec4f ScaleOrientation;
	Vec3f Scale;
	//methods
	void ReadBoneData(BIFS::ostream &str);

};

class Frames
{
public:
	Frames(void);
	~Frames(void);
	//variables

	int size;
	int boneDataCount;
	BoneData **bonesData;
	//methods
	void ReadFrames (BIFS::ostream &str);
};

class AnimationBuff
{
public:
	AnimationBuff(char * AnimBuff, int AnimBuffSize,bool hierarchy);
	~AnimationBuff(void);
	//variables
	int			size;
	bool		hasHierarchy;
	Hierarchy	*hier;
	int			NoFrames;
	Frames		**frames;

};


