#include "CreateOD.h"



ODData *NewODData()
{
	ODData * tmp;
	tmp = (ODData*) malloc(sizeof(ODData));
	(*tmp).outAU				= NULL;
	u32  au_length				= 0;
	GF_Err e;					
	int NumberODs				= 1 ;
	GF_BifsEncoder* encoder		= NULL;
	GF_ODCom *command;
	GF_ODUpdate* odUpdate = (GF_ODUpdate*)command;

	GF_ObjectDescriptor* od				= NULL;
	
	ESDescriptor* pOdESD				= NULL;
	DecoderConfigDescriptor* pDecCon	= NULL;
	SLConfigDescriptor* pSlcCon			= NULL;
	return tmp;
}


int InitOD()
{
	
	encoder = OD_NewCodec(OD_WRITE);
	command = OD_NewCommand(ODUpdate_Tag);
    return 0;
}


int AddODSample(int ODID, int ESID, const char* streamFormat, int streamType, int objectTypeIndication, int bufferSizeDB)
{
	    od = (ObjectDescriptor*) OD_NewDescriptor (ObjectDescriptor_Tag);
		od->objectDescriptorID = (u16) ODID;

		pOdESD = OD_NewESDescriptor (2); 
		pOdESD->ESID = (u16) ESID;
		pOdESD->streamFormat = strdup(streamFormat);
		
		pDecCon = (DecoderConfigDescriptor*) OD_NewDescriptor(DecoderConfigDescriptor_Tag);
		pDecCon->streamType = (u8)streamType; 
		pDecCon->objectTypeIndication = (u8) objectTypeIndication;
		
		pDecCon->bufferSizeDB = (u32) bufferSizeDB;
		//TO DO : if need stg else in DecoderConfigDescriptor, can be add here;
		pOdESD->decoderConfig = pDecCon;

		pSlcCon = (SLConfigDescriptor*) OD_NewDescriptor(SLConfigDescriptor_Tag);
		pSlcCon->useAccessUnitStartFlag   = TRUE;
		pSlcCon->useAccessUnitEndFlag	  = TRUE;
		pSlcCon->useRandomAccessPointFlag = TRUE;
		pSlcCon->useTimestampsFlag		  = TRUE;	
		pSlcCon->timestampResolution      = 1000;
		pSlcCon->timestampLength          = 10;
		//pSlcCon->AUDuration.............  ADD WHAT WE HAVE
		pOdESD->slConfig  = pSlcCon;

		ChainAddEntry(od->ESDescriptors,pOdESD); 
		ChainAddEntry(odUpdate->objectDescriptors,od); 

		return 0;

}

int CreateODBuffer()
{
	e = OD_AddCommand(encoder, command); 
	e = OD_EncodeAU(encoder);  //with encoding each command is deleted, so no need to delete ODCommand *command
	e = OD_GetEncodedAU(encoder, &outAU, &au_length); 
	OD_DeleteCodec(encoder);

	return 0;
}


int InitMux()
{
	mm  =  MovieCreate("c:\\test.mp4", M4_OPEN_WRITE);
	//Add iods
	e = AddMovieIOD(mm->moov, true);
}
int AddTracktoMux(M4_ODMediaType,)
{
	
	//Add OD track
	u32 Ok = M4_NewTrack(mm, 1, M4_ODMediaType, 1000);  // 1 -tracknumber 
	M4Sample *sample = M4_NewFullSample(outAU,au_length, 0, 0, 0);
	u32 index;
	ESDescriptor* pESD = (ESDescriptor*)ChainGetEntry(od->ESDescriptors,0);  //for each OD  'i-1' entry
	e = M4_NewStreamDescription( (M4File *)mm, 1, pESD, NULL, NULL, &index); // 1 -tracknumber 
	e = M4_AddSample(mm, Ok, index,sample); //// Ok -tracknumber 
	
	
	// Add track to iods.........only for OD and BIFS....we do like this, I don't know why........
	e = M4_AddTrackToRootOD((M4File *)mm, 1); // 1 -tracknumber 

	//Add other tracks
	InitOD();
	//to do: for each samle  AddODSample(int ODID, int 
	//to do: for ChainGetCount(od->ESDescriptors,0
	//u32 Ok = M4_NewTrack(mm, 1, M4_ODMediaType, 1000);  // 1 -tracknumber 
	//M4Sample *sample = M4_NewFullSample(outAU,au_length, 0, 0, 0);
	//u32 index;
	//ESDescriptor* pESD = (ESDescriptor*)ChainGetEntry(od->ESDescriptors,0);  //for each OD  'i-1' entry
	//e = M4_NewStreamDescription( (M4File *)mm, 1, pESD, NULL, NULL, &index); // 1 -tracknumber 
	//e = M4_AddSample(mm, Ok, index,sample); //// Ok -tracknumber 
//CreateODBuffer()  and delete od buffers

	return 0;
}

int CreateMux()
{
	M4_MovieClose(mm);

	return 0;
}
