#include "VBtoMP4Lib.h"
#include "MakeOD.h"
#include "Animation.h"
#include "BBA_Encoder_Lib.h"
#include <vector>

#define BBABUFFERSIZE	10000000 
#define FIRSTFRAME		1
#define LASTFRAME		2
#define ONLYONEFRAME	3
enum BufferType
{
	BT_NONE		= 0,
	BT_OD		= 1,
	BT_BIFS		= 2,
	BT_TEX		= 3,
	BT_BBA		= 4,
	BT_3DMC		= 5,
	BT_RAR		= 6
};

extern "C"
{
#include "gpac/isomedia.h"
#include "gpac/internal/isomedia_dev.h"
#include "gpac/nodes_mpeg4.h"
#include "gpac/internal/scenegraph_dev.h"
#include "gpac/internal/bifs_dev.h"
#include "gpac/scenegraph.h"
	
	
}


#include "ostream.h"
#include "MakeOD.h"

#include "jasper/jasper.h"

#include <vector>

class VBtoMP4Lib
{
public:

	//con/deconstructor
	VBtoMP4Lib();
	~VBtoMP4Lib();
	//ini variables
	//for OD stream
	int BasicODODID;
	int ODESID;
	int ODstreamType;
	int ODobjectTypeIndication;
	int ODbufferSizeDB;		
	//for Bifs stream
	int BasicBIFSODID;
	int BIFSESID;
	int BIFSstreamType;
	int BIFSobjectTypeIndication;
	int BIFSbufferSizeDB;		
	//for TXT stream  (JPEG2000)
	int BasicTXTODID;
	int TXTESID;
	int JPEG2000streamType;
	int JPEG2000objectTypeIndication;
	int JPEG2000bufferSizeDB;		
	//for BBA stream
	int BasicBBAODID;
	int BBAESID;
	int BBAstreamType;
	int BBAobjectTypeIndication;
	int BBAbufferSizeDB;
	bool AnimisMP4Stream;
	//for 3DMC stream
	int Basic3DMCODID;
	int DMCESID;
	int DMCstreamType;
	int DMCobjectTypeIndication;
	int DMCbufferSizeDB;	
	//for RAR stream
	int BasicRARODID;
	int RARESID;
	int RARstreamType;
	int RARobjectTypeIndication;
	int RARbufferSizeDB;		


	//variables
	int NoOfTracks;
	BufferType* trackType;
	int* NoOfSamples;
	int *texID;
	int *AnmID;
	u32 *MediaType;
	int *dmcID;
	std::vector<char*> dmcDaeId;
	std::vector<char*> txtDaeId;

	char *mp4FileName;
	MakeOD *OD;
	char **Buff;
	int  *BuffSize;
	unsigned char *vb;
	int vbSize; 
	unsigned char *tb;
	int tbSize; 
	unsigned char *ab;
	int abSize; 
	unsigned char **an;
	int *anSize;
	int *aID;
	int noAnim;
	unsigned char *dmc;
	unsigned char *rar;
	int dmcSize; 
	int rarSize;
	unsigned char *bifs;
	int bifsSize;
	int bufferOUTSize;
	unsigned char * bufferOUT;
	int bufferINSize;
	unsigned char * bufferIN;
	AnimationBuff **anim;
	GF_ISOSample ***sample;
	//MP4Sample ***sample;
	int DefID;
	bool hasBIFS;
	bool hasAnimation;
	bool hasTexture;
	bool has3DMC;

	//for size information
	int ODSize;
	int BIFSSize;
	int BBASize;
	int DMCSize;
	int IMGSize;

	GF_SceneGraph* scene;


	//functions
	int  AddBifs( unsigned char *vbf, int vbfSize, unsigned char *abf, int abSizef );
	int  CreateBifs();
	int  CreateBifs_OLDBuffer();
	void AddAnimation( unsigned char *vb, int vbSize, int AnimID, bool isMP4Stream );
	int  CreateAnimation (  );
	int AddTexture( unsigned char *vb, int vbSize, int texID , const char* daeId);
	int  CreateTexture ( int texID );
	int Add3DMC (unsigned char *buff, int size, int id, const char* daeId);
	int AddRAR (unsigned char *buff, int size);
	int SetRARinMETA (unsigned char* &buff, int &size);
	int  Create3DMC ( int id );
	void MakeTextualBBA( Frames* frame );
	Vec4f unMakeQuat(Vec4f q);
	int CreateHierarchy( M_SBSkinnedModel *pSkn, Bone *pBone, M_SBBone *pSBBone );
	int GetTrackSize(int &ODsize, int &BIFSsize, int &DMCsize,int &IMGsize, int &BBAsize);
	//int CreateMP4 (const char* file_name);
	//functions for exporter
	int AddBifs( GF_SceneGraph* scene,unsigned char* &buff, int &size  );
	int SetBIFS(  );
	//int SetBIFS (LPSCENEGRAPH scene);
	int ReadBegin(char* data_buffer,int current_pos,int fileSize);
	bool ReadNextFrame(char* data_buffer, char* frame,int &frame_size,int &current_pos,int fileSize );
	int SetBBA ( unsigned char *vb, int vbSize, int AnimID,bool isEncoded  );
	bool SetFrames();
	int CreateMP4 (const char* file_name, bool NotFromBuffer);

};

VBtoMP4Lib::VBtoMP4Lib()
{

	//ini variables
	//for OD stream
	BasicODODID					= 0;
	ODESID						= 101;
	ODstreamType				= 2;
	ODobjectTypeIndication		= 1;
	ODbufferSizeDB				= 5000;		
	//for Bifs stream
	BasicBIFSODID				= 0;
	BIFSESID					= 201;
	BIFSstreamType				= 3;
	BIFSobjectTypeIndication	= 2;
	BIFSbufferSizeDB			= 4000000;		
	//for TXT stream  (JPEG2000)
	BasicTXTODID				= 300;
	TXTESID						= 500;
	JPEG2000streamType			= 4;
	JPEG2000objectTypeIndication= 0x6c;
	JPEG2000bufferSizeDB		= 9000000;
	//for BBA stream
	BasicBBAODID				= 0;//500;
	BBAESID						= 0;
	BBAstreamType				= 0;
	BBAobjectTypeIndication		= 5;
	BBAbufferSizeDB				= 0;

	//for 3DMC stream
	Basic3DMCODID				= 800;
	DMCESID						= 5000;
	DMCstreamType				= 0;
	DMCobjectTypeIndication		= 55;
	DMCbufferSizeDB				= 4000000;	
	//for RAR stream
	BasicRARODID				= 900;
	RARESID						= 6000;
	RARstreamType				= 0;
	RARobjectTypeIndication		= 33;
	RARbufferSizeDB				= 4000000;	

	//other variables

	NoOfTracks = 1;  //for OD
	MediaType = (u32*) malloc(sizeof (u32));
	trackType = (BufferType*) malloc(sizeof (BufferType));
	NoOfSamples = ( int*) malloc (sizeof( int ));
	Buff = (char**) malloc (sizeof( char* ));
	Buff[0] = NULL;
	BuffSize = (int*) malloc (sizeof ( int ));
	BuffSize[0] = 0;
	trackType[0] = BT_OD;
	NoOfSamples [0] = 1;
	mp4FileName = NULL;
	OD = new MakeOD ();
	texID = NULL;
	AnmID = NULL;
	dmcID = NULL;
	AnimisMP4Stream = false;

	bufferOUTSize = 0;
	bufferOUT = (unsigned char *)malloc (BBABUFFERSIZE); //vbSize ....hope enought place for bba encoded
	bufferINSize = 0;
	bufferIN = (unsigned char *)malloc (BBABUFFERSIZE); //vbSize ....hope enought place for bba text
	hasBIFS = false;
	hasAnimation= false;
	hasTexture= false;
	vb		= NULL;
	ab		= NULL;
	tb		= NULL;
	an		= NULL;
	dmc		= NULL;
	rar		= NULL;
	anSize	= NULL;
	aID		= NULL;
	bufferOUT= NULL;
	bufferIN = NULL;
	sample	 = NULL;
	noAnim = 0;
	scene	= NULL;

	bifs = NULL;

	//for size information
	ODSize		=0;
	BIFSSize	=0;
	BBASize		=0;
	DMCSize		=0;
	IMGSize		=0;

}

VBtoMP4Lib::~VBtoMP4Lib()
{
	free( BuffSize );
	free( MediaType );
	free( trackType );

	//for ( int i=0; i<NoOfTracks; i++ )
	//	if ( Buff[i] )
	//		free( Buff[i] );
	free( Buff );
	if ( texID )
		free( texID );
	if ( AnmID )
		free( AnmID );
	if ( dmcID )
		free( dmcID );
	if ( mp4FileName )
		free( mp4FileName );
	delete OD;
	delete vb;
	delete ab;
	delete tb;
	delete dmc;
	delete rar;
	delete bifs;
	for (int i=0; i<noAnim ; i++)
		delete an[i];
	delete an;
	delete anSize;
	delete aID;
	free ( bufferOUT );
	free ( bufferIN );
	for (int i=0; i<NoOfTracks; i++)
	{
		for (int j=0; j<NoOfSamples[i]; j++)
			if (sample) delete sample[i][j];
		if (sample) delete sample[i];
	}
	delete sample;

	free( NoOfSamples );


}

int VBtoMP4Lib::AddBifs( unsigned char *vbf, int vbfSize, unsigned char *abf, int abfSize )
{
	hasBIFS = true;
	vbSize = vbfSize;
	vb = ( unsigned char *) malloc ( vbSize * sizeof ( unsigned char ));
	memcpy( vb, vbf, vbSize);
	abSize = abfSize;
	ab = ( unsigned char *) malloc ( abSize * sizeof ( unsigned char ));
	memcpy( ab, abf, abSize);
	return 1;
}

Vec4f VBtoMP4Lib::unMakeQuat(Vec4f q)
{
	double sina2 = sqrt(q.x*q.x + q.y*q.y + q.z*q.z);
	double angle = (2.0 * atan2((float)sina2, (float)q.q));

	if (sina2 >= 1e-8) {
		sina2 = 1.0/sina2;
		q.x *= sina2;
		q.y *= sina2;
		q.z *= sina2;
		q.q = angle;
	} else {
		q.x = 0;
		q.y = 1;
		q.z = 0;
		q.q = 0;
	}
	return q;
}

int VBtoMP4Lib::CreateBifs_OLDBuffer()
{

	DefID = 1;

	//Create scene

	GF_SceneGraph* scene =  gf_sg_new ();

	//Create and Add Group Node to Scene
	
	M_Group *pGrp = (M_Group *)gf_node_new( scene, TAG_MPEG4_Group );
	gf_node_register( (GF_Node*)pGrp, NULL );
	scene->RootNode = (GF_Node*)pGrp;

	//Create and Add TRansform Node to Group
	M_Transform *pTrn = (M_Transform *)gf_node_new( scene, TAG_MPEG4_Transform );
	//gf_list_add( pGrp->children, pTrn);
	
	//gf_list_add((GF_List*)pGrp->children, pTrn);
	gf_node_register( (GF_Node*)pTrn,(GF_Node*) pGrp );
	gf_node_insert_child( (GF_Node*)pGrp, (GF_Node*)pTrn, -1 );

	// Read Appearance

	BIFS::ostream as;
	as.write( (char*) ab, abSize );
	as.seekp( 0 );

	as.readInt( 4 );						// total size of the stream
	int ApCount = 0;
	ApCount = as.readInt( 4 );
	// Number of appearance atoms
	int i;
	M_Appearance** apps;
	apps = (M_Appearance**)malloc( ApCount * sizeof( M_Appearance* ) );
	memset( apps, 0, ApCount * sizeof( M_Appearance* ) );




	for ( i = 0; i < ApCount; i++ )
	{
		M_Appearance* pApp = (M_Appearance*)gf_node_new( scene, TAG_MPEG4_Appearance );
		int texId = as.readInt( 4 );
		if ( texId >= 0 )
		{
			M_ImageTexture* pImgTex = (M_ImageTexture*)gf_node_new( scene, TAG_MPEG4_ImageTexture );
			gf_node_register( (GF_Node*)pImgTex, (GF_Node*)pApp );
			pApp->texture = (GF_Node*)pImgTex;
			pImgTex->url.count = 1;
			pImgTex->url.vals = (SFURL*)malloc( pImgTex->url.count * sizeof(SFURL) );
			pImgTex->url.vals[0].OD_ID = BasicTXTODID + texId; 
			pImgTex->url.vals[0].url = NULL;
		}
		int t = as.readInt(1);
		if ( t > 0 )
		{
			M_Material* pMat = (M_Material*)gf_node_new( scene, TAG_MPEG4_Material );
			gf_node_register( (GF_Node*)pMat, (GF_Node*)pApp );
			pApp->material = (GF_Node*)pMat;
			pMat->diffuseColor.red		= as.readFloat( 4 );
			pMat->diffuseColor.green	= as.readFloat( 4 );
			pMat->diffuseColor.blue		= as.readFloat( 4 );
			pMat->specularColor.red		= as.readFloat( 4 );
			pMat->specularColor.green	= as.readFloat( 4 );
			pMat->specularColor.blue	= as.readFloat( 4 );
			pMat->emissiveColor.red		= as.readFloat( 4 );
			pMat->emissiveColor.green	= as.readFloat( 4 );
			pMat->emissiveColor.blue	= as.readFloat( 4 );
			pMat->transparency			= as.readFloat( 4 );
			pMat->ambientIntensity		= as.readFloat( 4 );
			pMat->shininess				= as.readFloat( 4 );
		}
		apps[i] = pApp;
	}


	// End Read Appearance

	// Read Animatiuon

	AnimationBuff* anmBuff = NULL;
	MFInt32* boneIndex = NULL;
	MFFloat* boneInfl = NULL;

	if ( noAnim )
	{
		CreateAnimation( );
		anmBuff = anim[0];
		boneIndex = (MFInt32*)malloc(anmBuff->frames[0]->boneDataCount * sizeof(MFInt32));
		memset( boneIndex, 0, anmBuff->frames[0]->boneDataCount * sizeof(MFInt32) );
		boneInfl = (MFFloat*)malloc(anmBuff->frames[0]->boneDataCount * sizeof(MFFloat));
		memset( boneIndex, 0, anmBuff->frames[0]->boneDataCount * sizeof(MFFloat) );
	}
	// End read Animation

	//Read Vertex Buffer

	BIFS::ostream st;
	st.write( ( char* )vb, vbSize );
	st.seekp( 0 );

	st.readInt( 4 );						// total size of the buffer
	int vbCount;

	vbCount = st.readInt( 1 );				// number of vertex buffers

	if (!vbCount)  return 1;					// there is no one vertex buffer

	//NULL SBVCV2.......always create SBVCV2 not SBVC
	M_SBVCAnimationV2 *pAnmV2 = NULL;

	for ( i = 0; i < vbCount; i++ )
	{
		st.readInt( 4 );					// size of vertex buffer and index buffers
		st.readInt( 4 );					// size of vertex buffer

		int desc;
		desc = st.readInt( 1 );				// description of the vertex buffer
		bool hasBoneInfls;
		bool hasNormals;
		bool hasTexCoords;
		// decoding the descriptor
		hasTexCoords	= (desc & 0x01)==1? true:false;		// texture coordinates
		hasNormals		= (desc & 0x02)==2? true:false;		// normals
		hasBoneInfls	= (desc & 0x04)==4? true:false;		// bone influences

		int vCount;
		vCount = st.readInt( 4 );			// number of vertices

		//Create Coordinate node...it is shared between vc
		M_Coordinate* pCoor = (M_Coordinate*) gf_node_new( scene, TAG_MPEG4_Coordinate);

		gf_node_set_id( (GF_Node*)pCoor, DefID++, NULL );
		pCoor->point.count = vCount;
		pCoor->point.vals = (SFVec3f*) malloc (pCoor->point.count * sizeof (SFVec3f));

		//Create Normal node...it is shared between vc
		M_Normal * pNor = NULL;
		if ( hasNormals )
		{
			pNor = (M_Normal *) gf_node_new( scene, TAG_MPEG4_Normal);
			gf_node_set_id( (GF_Node*)pNor, DefID++, NULL );
			pNor->vector.count = vCount;
			pNor->vector.vals = (SFVec3f*) malloc (pNor->vector.count * sizeof (SFVec3f));
		}

		//Create Texture Node
		M_TextureCoordinate * pTex = NULL;
		if ( hasTexCoords )
		{
			pTex = (M_TextureCoordinate *) gf_node_new( scene, TAG_MPEG4_TextureCoordinate );
			gf_node_set_id( (GF_Node*)pTex, DefID++, NULL );
			pTex->point.count = vCount;
			pTex->point.vals = (SFVec2f*) malloc (pTex->point.count * sizeof (SFVec2f));
			//memset( pTex->point.vals, 0, pTex->point.count * sizeof (SFVec2f*) );
		}
		//Add Coords and Normals
		for ( int j = 0; j < vCount; j++ )
		{

			pCoor->point.vals[j].x = st.readFloat( 4 );			// X coordinate
			pCoor->point.vals[j].y = st.readFloat( 4 );			// Y coordinate
			pCoor->point.vals[j].z = st.readFloat( 4 );			// Z coordinate

			if ( hasBoneInfls )
			{
				//skiping the bone influences
				float b[4];

				int k;
				for ( k = 0; k < 4; k++ )
					b[k] = st.readFloat( 4 );

				int t;
				for ( k = 0; k < 4; k++ )
				{
					t = st.readInt  ( 1 );
					if ( t == 0 )
						continue;
					if ( noAnim )
					{
						boneIndex[t].count++;
						boneIndex[t].vals = ( s32* )realloc( boneIndex[t].vals, boneIndex[t].count * sizeof( s32 ) );
						boneIndex[t].vals[boneIndex[t].count-1] = j;

						boneInfl[t].count++;
						boneInfl[t].vals = ( Fixed* )realloc( boneInfl[t].vals, boneInfl[t].count * sizeof( Fixed ) );
						boneInfl[t].vals[boneIndex[t].count-1] = b[k];
					}
				}
			}

			if ( hasNormals )
			{

				pNor->vector.vals[j].x  = st.readFloat( 4 );
				pNor->vector.vals[j].y  = st.readFloat( 4 );
				pNor->vector.vals[j].z  = st.readFloat( 4 );
			}

			if ( hasTexCoords )
			{
				//keep the texture coordinates in  Textcoord Node
				pTex->point.vals[j].x = st.readFloat( 4 );
				pTex->point.vals[j].y = 1.f - st.readFloat( 4 );
			}
		}

		M_SBSkinnedModel* pSkn = NULL;

		if ( hasBoneInfls && anmBuff && noAnim )					//there is animation, create SBVC
		{

			if ( !pAnmV2 )
			{
				//Add SBVCV2 Node
				pAnmV2 = (M_SBVCAnimationV2 *) gf_node_new( scene, TAG_MPEG4_SBVCAnimationV2 );
				//gf_list_add( (GF_List*)pTrn->children, pAnmV2 );
				gf_node_register( (GF_Node*)pAnmV2, (GF_Node*)pTrn );
				gf_node_insert_child( (GF_Node*)pTrn, (GF_Node*)pAnmV2, -1 );
				pAnmV2->url.count = noAnim;
				pAnmV2->url.vals = (SFURL*)malloc ( pAnmV2->url.count * sizeof (SFURL) );
				memset( pAnmV2->url.vals, 0, pAnmV2->url.count * sizeof (SFURL));
				for (int k=0; k<noAnim ; k++)
					pAnmV2->url.vals[k].OD_ID = BasicBBAODID + aID[k];

			}

			//Create and Add SBSkin Node Node to SBVCV2 Node
			pSkn = (M_SBSkinnedModel *)gf_node_new( scene, TAG_MPEG4_SBSkinnedModel);
			gf_list_add( (GF_List*)pAnmV2->virtualCharacters , pSkn );
			gf_node_register( (GF_Node*)pSkn, (GF_Node*)pAnmV2 );
			//BONES  (skeleton) 

			Bone *bn = anmBuff->hier->roots[gf_list_count((GF_List*)pAnmV2->virtualCharacters) - 1];
			CreateHierarchy( pSkn, bn, NULL );

			for ( int k = 0; k < anmBuff->frames[0]->boneDataCount; k++ )
			{
				BoneData* bd = anmBuff->frames[0]->bonesData[k];
				M_SBBone* pB = (M_SBBone*)  gf_list_get( (GF_List*)pSkn->bones, k );

				pB->skinCoordIndex.count = boneIndex[k].count;
				pB->skinCoordIndex.vals = boneIndex[k].vals;

				pB->skinCoordWeight.count = boneInfl[k].count;
				pB->skinCoordWeight.vals = boneInfl[k].vals;

				if ( bd->hasCenter )
				{
					pB->center.x = bd->Center.x;
					pB->center.y = bd->Center.y;
					pB->center.z = bd->Center.z;
				}

				if ( bd->hasRotation )
				{
					if (bd->isQuaternion)
						bd->Rotation = unMakeQuat(bd->Rotation);
					pB->rotation.x = bd->Rotation.x;
					pB->rotation.y = bd->Rotation.y;
					pB->rotation.z = bd->Rotation.z;
					pB->rotation.q = bd->Rotation.q;
				}
			}

			gf_node_register ((GF_Node*)pCoor, (GF_Node*)pSkn);
			pSkn->skinCoord = (GF_Node*) pCoor;

			if (pNor)
			{
				gf_node_register ((GF_Node*)pNor, (GF_Node*)pSkn);
				pSkn->skinNormal = (GF_Node*)pNor;
			}

		}


		int ibCount = 0;
		ibCount = st.readInt( 1 );					// Number of indexbuffers

		for ( int k = 0; k < ibCount; k++ )
		{
			//for each indexbuffer Create and Add Shape Node to SBSkined
			M_Shape *pShp = (M_Shape *)gf_node_new( scene, TAG_MPEG4_Shape );

			if (hasBoneInfls && noAnim)
			{
				gf_list_add( (GF_List*)pSkn->skin , pShp);
				gf_node_register( (GF_Node*)pShp, (GF_Node*)pSkn );
			}
			else
			{
				//gf_list_add( (GF_List*)pTrn->children , pShp);
				gf_node_register( (GF_Node*)pShp, (GF_Node*)pTrn );
				gf_node_insert_child( (GF_Node*)pTrn, (GF_Node*)pShp, -1 );
			}

			st.readInt( 4 );	
			int appID;
			appID = st.readInt( 4 );			// ID of the appearance

			//Create and Add Appereance to Shape Node 
			M_Appearance* pApp = apps[appID];
			gf_node_register( (GF_Node*)pApp, (GF_Node*)pShp );
			pShp->appearance = (GF_Node*) pApp;

			//Create and Add geometry(IFS) to Shape Node 
			M_IndexedFaceSet* pIFS = (M_IndexedFaceSet *) gf_node_new (scene,TAG_MPEG4_IndexedFaceSet );
			gf_node_register( (GF_Node*)pIFS, (GF_Node*)pShp );
			pShp->geometry = (GF_Node*) pIFS;

			//Add Coordinate to IFS
			gf_node_register( (GF_Node*)pCoor, (GF_Node*)pIFS );
			pIFS->coord   = (GF_Node*) pCoor;

			//Add Normals to IFS
			if ( pNor )
			{
				gf_node_register( (GF_Node*)pNor, (GF_Node*)pIFS );
				pIFS->normal  = (GF_Node*) pNor;
			}

			//Add Textures to IFS
			if ( pTex )
			{
				gf_node_register( (GF_Node*)pTex, (GF_Node*)pIFS );
				pIFS->texCoord = (GF_Node*)pTex;
			}

			//Add CoordIndex
			pIFS->coordIndex.count = st.readInt( 4 ) * 4 / 3;			// Number of indices, triangles
			pIFS->coordIndex.vals = (s32*) malloc (pIFS->coordIndex.count * sizeof (s32*));
			for ( unsigned int m = 0; m < pIFS->coordIndex.count; m++ )
			{
				pIFS->coordIndex.vals[m++] = st.readInt( 4 );
				pIFS->coordIndex.vals[m++] = st.readInt( 4 );
				pIFS->coordIndex.vals[m++] = st.readInt( 4 );
				pIFS->coordIndex.vals[m] = -1;
			}

		}

	}
	//End Read Vertex Buffer

	if ( boneIndex )
		free(boneIndex);
	if ( boneInfl )
		free(boneInfl);

	//BIFS encoding part

	GF_Err e;
	GF_BifsEncoder *encodec;

	encodec = gf_bifs_encoder_new( scene );
	//	encodec = BIFS_NewEncoder(scene);
	u16 ESID = BIFSESID;
	GF_List * chn;
	char* out_data;
	u32 out_data_lenght;

	GF_BIFSConfig *bifsDesc;
	//BIFSConfigDescriptor *bifsDesc;
	bifsDesc = (GF_BIFSConfig*)malloc (sizeof (GF_BIFSConfig));
	//bifsDesc = (BIFSConfigDescriptor*)malloc (sizeof (BIFSConfigDescriptor));
	memset(bifsDesc,0, sizeof(GF_BIFSConfig));
	//bifsDesc->isCommandStream  = 1;
	bifsDesc->nodeIDbits = 10;
	bifsDesc->version = 2;


	
	GF_Command * comm = gf_sg_command_new (scene,GF_SG_SCENE_REPLACE);
	comm->node = scene->RootNode;

	chn = gf_list_new ();
	gf_list_add ((GF_List*)chn , comm );

	
	
	
//	e = BIFS_NewStream(encodec, ESID, bifsDesc, false, false);
//	e = BIFS_EncodeAU (encodec,ESID, chn, &out_data, &out_data_lenght);
	e = gf_bifs_encode_au(encodec, ESID, bifsDesc->elementaryMasks, false, false);

	
	gf_list_del( chn );
	free( bifsDesc );
	gf_bifs_encoder_del(  encodec );
	gf_sg_del( scene );
	free(apps);

	// end BIFS encoding part

	Buff = (char**) realloc( Buff, (NoOfTracks+1) * sizeof( char *) );
	Buff[NoOfTracks] = ( char*)malloc( out_data_lenght * sizeof( char ));
	memcpy( Buff[NoOfTracks], out_data, out_data_lenght * sizeof( char ));
	BuffSize = (int*) realloc( BuffSize, ((NoOfTracks+1) * sizeof (int))); 
	BuffSize [NoOfTracks] = out_data_lenght;

	free(out_data);

	MediaType = (u32*) realloc (MediaType,(NoOfTracks+1) * sizeof (u32));
	trackType = (BufferType*) realloc(trackType, (NoOfTracks+1) * sizeof(BufferType));
	trackType[NoOfTracks] = BT_BIFS;
	NoOfSamples = (int*) realloc( NoOfSamples, (NoOfTracks+1) * sizeof(int));
	NoOfSamples [NoOfTracks] = 1;

	NoOfTracks ++;

	return 0;
}


int VBtoMP4Lib::CreateBifs()
{

	DefID = 1;

	//Create scene

	GF_SceneGraph* scene =  gf_sg_new ();

	//Create and Add Group Node to Scene
	
	M_Group *pGrp = (M_Group *)gf_node_new( scene, TAG_MPEG4_Group );
	gf_node_register( (GF_Node*)pGrp, NULL );
	scene->RootNode = (GF_Node*)pGrp;

	//Create and Add TRansform Node to Group
	M_Transform *pTrn = (M_Transform *)gf_node_new( scene, TAG_MPEG4_Transform );
	//gf_list_add( pGrp->children, pTrn);
	
	//gf_list_add((GF_List*)pGrp->children, pTrn);
	gf_node_register( (GF_Node*)pTrn,(GF_Node*) pGrp );
	gf_node_insert_child( (GF_Node*)pGrp, (GF_Node*)pTrn, -1 );

	// Read Appearance

	BIFS::ostream as;
	as.write( (char*) ab, abSize );
	as.seekp( 0 );

	as.readInt( 4 );						// total size of the stream
	int ApCount = 0;
	ApCount = as.readInt( 4 );
	// Number of appearance atoms
	int i;
	M_Appearance** apps;
	apps = (M_Appearance**)malloc( ApCount * sizeof( M_Appearance* ) );
	memset( apps, 0, ApCount * sizeof( M_Appearance* ) );




	for ( i = 0; i < ApCount; i++ )
	{
		M_Appearance* pApp = (M_Appearance*)gf_node_new( scene, TAG_MPEG4_Appearance );
		int texId = as.readInt( 4 );
		if ( texId >= 0 )
		{
			M_ImageTexture* pImgTex = (M_ImageTexture*)gf_node_new( scene, TAG_MPEG4_ImageTexture );
			gf_node_register( (GF_Node*)pImgTex, (GF_Node*)pApp );
			pApp->texture = (GF_Node*)pImgTex;
			pImgTex->url.count = 1;
			pImgTex->url.vals = (SFURL*)malloc( pImgTex->url.count * sizeof(SFURL) );
			pImgTex->url.vals[0].OD_ID = BasicTXTODID + texId; 
			pImgTex->url.vals[0].url = NULL;
		}
		int t = as.readInt(1);
		if ( t > 0 )
		{
			M_Material* pMat = (M_Material*)gf_node_new( scene, TAG_MPEG4_Material );
			gf_node_register( (GF_Node*)pMat, (GF_Node*)pApp );
			pApp->material = (GF_Node*)pMat;
			pMat->diffuseColor.red		= as.readFloat( 4 );
			pMat->diffuseColor.green	= as.readFloat( 4 );
			pMat->diffuseColor.blue		= as.readFloat( 4 );
			pMat->specularColor.red		= as.readFloat( 4 );
			pMat->specularColor.green	= as.readFloat( 4 );
			pMat->specularColor.blue	= as.readFloat( 4 );
			pMat->emissiveColor.red		= as.readFloat( 4 );
			pMat->emissiveColor.green	= as.readFloat( 4 );
			pMat->emissiveColor.blue	= as.readFloat( 4 );
			pMat->transparency			= as.readFloat( 4 );
			pMat->ambientIntensity		= as.readFloat( 4 );
			pMat->shininess				= as.readFloat( 4 );
		}
		apps[i] = pApp;
	}


	// End Read Appearance

	// Read Animatiuon

	AnimationBuff* anmBuff = NULL;
	MFInt32* boneIndex = NULL;
	MFFloat* boneInfl = NULL;

	if ( noAnim )
	{
		CreateAnimation(  );
		anmBuff = anim[0];
		boneIndex = (MFInt32*)malloc(anmBuff->frames[0]->boneDataCount * sizeof(MFInt32));
		memset( boneIndex, 0, anmBuff->frames[0]->boneDataCount * sizeof(MFInt32) );
		boneInfl = (MFFloat*)malloc(anmBuff->frames[0]->boneDataCount * sizeof(MFFloat));
		memset( boneIndex, 0, anmBuff->frames[0]->boneDataCount * sizeof(MFFloat) );
	}
	// End read Animation

	//Read Vertex Buffer

	BIFS::ostream st;
	st.write( ( char* )vb, vbSize );
	st.seekp( 0 );

	st.readInt( 4 );						// total size of the buffer
	int vbCount;

	vbCount = st.readInt( 1 );				// number of vertex buffers

	if (!vbCount)  return 1;					// there is no one vertex buffer

	//NULL SBVCV2.......always create SBVCV2 not SBVC
	M_SBVCAnimationV2 *pAnmV2 = NULL;

	for ( i = 0; i < vbCount; i++ )
	{
		st.readInt( 4 );					// size of vertex buffer and index buffers
		st.readInt( 4 );					// size of vertex buffer

		int desc;
		desc = st.readInt( 1 );				// description of the vertex buffer
		bool hasBoneInfls;
//		bool hasNormals;
//		bool hasTexCoords;
		// decoding the descriptor
		//hasTexCoords	= (desc & 0x01)==1? true:false;		// texture coordinates
		//hasNormals		= (desc & 0x02)==2? true:false;		// normals
		hasBoneInfls	= (desc & 0x01)? true:false;		// bone influences

		int vCount;
		vCount = st.readInt( 4 );			// number of vertices

		//Create Coordinate node...it is shared between vc
		M_Coordinate* pCoor = (M_Coordinate*) gf_node_new( scene, TAG_MPEG4_Coordinate);

		gf_node_set_id( (GF_Node*)pCoor, DefID++, NULL );
		pCoor->point.count = vCount;
		pCoor->point.vals = (SFVec3f*) malloc (pCoor->point.count * sizeof (SFVec3f));

		//Add Coords and Normals
		for ( int j = 0; j < vCount; j++ )
		{

			pCoor->point.vals[j].x = st.readFloat( 4 );			// X coordinate
			pCoor->point.vals[j].y = st.readFloat( 4 );			// Y coordinate
			pCoor->point.vals[j].z = st.readFloat( 4 );			// Z coordinate

			if ( hasBoneInfls )
			{
				//add bone influences
				float b[4];

				int k;
				for ( k = 0; k < 4; k++ )
					b[k] = st.readFloat( 4 );

				int t;
				for ( k = 0; k < 4; k++ )
				{
					t = st.readInt  ( 1 );
					if ( b[k] == 0 )
						continue;
					if ( noAnim )
					{
						boneIndex[t].count++;
						boneIndex[t].vals = ( s32* )realloc( boneIndex[t].vals, boneIndex[t].count * sizeof( s32 ) );
						boneIndex[t].vals[boneIndex[t].count-1] = j;
						
						boneInfl[t].count++;
						boneInfl[t].vals = ( Fixed* )realloc( boneInfl[t].vals, boneInfl[t].count * sizeof( Fixed ) );
						boneInfl[t].vals[boneIndex[t].count-1] = b[k];

					}
				}
			}
		}
		int nCount = st.readInt(4);
		//Create Normal node...it is shared between vc
		M_Normal * pNor = NULL;
		if ( nCount )
		{
			
			pNor = (M_Normal *) gf_node_new( scene, TAG_MPEG4_Normal);
			gf_node_set_id( (GF_Node*)pNor, DefID++, NULL );
			pNor->vector.count = nCount;
			pNor->vector.vals = (SFVec3f*) malloc (pNor->vector.count * sizeof (SFVec3f));
		}
		for ( int j = 0; j < nCount; j++ )
		{

			pNor->vector.vals[j].x  = st.readFloat( 4 );
			pNor->vector.vals[j].y  = st.readFloat( 4 );
			pNor->vector.vals[j].z  = st.readFloat( 4 );
		}
		int tCount = st.readInt(4);
		//Create Texture Node
		M_TextureCoordinate * pTex = NULL;
		if ( tCount )
		{
			pTex = (M_TextureCoordinate *) gf_node_new( scene, TAG_MPEG4_TextureCoordinate );
			gf_node_set_id( (GF_Node*)pTex, DefID++, NULL );
			pTex->point.count = tCount;
			pTex->point.vals = (SFVec2f*) malloc (pTex->point.count * sizeof (SFVec2f));
			//memset( pTex->point.vals, 0, pTex->point.count * sizeof (SFVec2f*) );
		}

		for ( int j = 0; j < tCount; j++ )
		{
			//keep the texture coordinates in  Textcoord Node
			pTex->point.vals[j].x = st.readFloat( 4 );
			pTex->point.vals[j].y = 1.f - st.readFloat( 4 );
		}

		M_SBSkinnedModel* pSkn = NULL;

		if ( hasBoneInfls && anmBuff && noAnim )					//there is animation, create SBVC
		{

			if ( !pAnmV2 )
			{
				//Add SBVCV2 Node
				pAnmV2 = (M_SBVCAnimationV2 *) gf_node_new( scene, TAG_MPEG4_SBVCAnimationV2 );
				//gf_list_add( (GF_List*)pTrn->children, pAnmV2 );
				gf_node_register( (GF_Node*)pAnmV2, (GF_Node*)pTrn );
				gf_node_insert_child( (GF_Node*)pTrn, (GF_Node*)pAnmV2, -1 );
				pAnmV2->url.count = noAnim;
				pAnmV2->url.vals = (SFURL*)malloc ( pAnmV2->url.count * sizeof (SFURL) );
				memset( pAnmV2->url.vals, 0, pAnmV2->url.count * sizeof (SFURL));
				for (int k=0; k<noAnim ; k++)
					pAnmV2->url.vals[k].OD_ID = BasicBBAODID + aID[k];

				
			}

			//Create and Add SBSkin Node Node to SBVCV2 Node
			pSkn = (M_SBSkinnedModel *)gf_node_new( scene, TAG_MPEG4_SBSkinnedModel);
			gf_list_add( (GF_List*)pAnmV2->virtualCharacters , pSkn );
			gf_node_register( (GF_Node*)pSkn, (GF_Node*)pAnmV2 );
			//BONES  (skeleton) 

			Bone *bn = anmBuff->hier->roots[gf_list_count((GF_List*)pAnmV2->virtualCharacters) - 1];
			CreateHierarchy( pSkn, bn, NULL );


			for ( int k = 0; k < anmBuff->frames[0]->boneDataCount; k++ )
			{
				BoneData* bd = anmBuff->frames[0]->bonesData[k];
				M_SBBone* pB = (M_SBBone*)  gf_list_get( (GF_List*)pSkn->bones, k );

				if (boneIndex[k].vals && boneInfl[k].vals )
				{
					pB->skinCoordIndex.count = boneIndex[k].count;
					pB->skinCoordIndex.vals = boneIndex[k].vals;

					pB->skinCoordWeight.count = boneInfl[k].count;
					pB->skinCoordWeight.vals = boneInfl[k].vals;
				}
					if ( bd->hasTranslation )
					{
						//FILE *f;
						//f = fopen("..\\tempComp.txt","a");
						//fprintf(f, "tr: %d = %f - %f -  %f\n", pB->boneID,bd->Translation.x, bd->Translation.y,bd->Translation.z );
						//fclose ( f );
						pB->center.x = bd->Translation.x;
						pB->center.y = bd->Translation.y;
						pB->center.z = bd->Translation.z;
					}
					
					if ( bd->hasRotation )
					{
						if (bd->isQuaternion)
						{
							bd->Rotation = unMakeQuat( bd->Rotation );
						}
						/*FILE *f;
						f = fopen("..\\tempComp.txt","a");
						fprintf(f, "rot: %d = %f - %f -  %f - %f\n", pB->boneID,bd->Rotation.x, bd->Rotation.y,bd->Rotation.z,bd->Rotation.q );
						fclose ( f );*/
						pB->rotation.x = bd->Rotation.x ;
						pB->rotation.y = bd->Rotation.y ;
						pB->rotation.z = bd->Rotation.z ;
						pB->rotation.q = bd->Rotation.q ;
					}
				//}
			}

			gf_node_register ((GF_Node*)pCoor, (GF_Node*)pSkn);
			pSkn->skinCoord = (GF_Node*) pCoor;

			if (pNor)
			{
				gf_node_register ((GF_Node*)pNor, (GF_Node*)pSkn);
				pSkn->skinNormal = (GF_Node*)pNor;
			}

		}


		int ibCount = 0;
		ibCount = st.readInt( 1 );					// Number of indexbuffers

		for ( int k = 0; k < ibCount; k++ )
		{
			//for each indexbuffer Create and Add Shape Node to SBSkined
			M_Shape *pShp = (M_Shape *)gf_node_new( scene, TAG_MPEG4_Shape );

			if (hasBoneInfls && noAnim)
			{
				gf_list_add( (GF_List*)pSkn->skin , pShp);
				gf_node_register( (GF_Node*)pShp, (GF_Node*)pSkn );
			}
			else
			{
				//gf_list_add( (GF_List*)pTrn->children , pShp);
				gf_node_register( (GF_Node*)pShp, (GF_Node*)pTrn );
				gf_node_insert_child( (GF_Node*)pTrn, (GF_Node*)pShp, -1 );
			}

			st.readInt( 4 );	
			int appID;
			appID = st.readInt( 4 );			// ID of the appearance

			//Create and Add Appereance to Shape Node 
			if ( ApCount )
			{
				M_Appearance* pApp = apps[appID];
				gf_node_register( (GF_Node*)pApp, (GF_Node*)pShp );
				pShp->appearance = (GF_Node*) pApp;

			}

			//Create and Add geometry(IFS) to Shape Node 
			M_IndexedFaceSet* pIFS = (M_IndexedFaceSet *) gf_node_new (scene,TAG_MPEG4_IndexedFaceSet );
			gf_node_register( (GF_Node*)pIFS, (GF_Node*)pShp );
			pShp->geometry = (GF_Node*) pIFS;

			//Add Coordinate to IFS
			gf_node_register( (GF_Node*)pCoor, (GF_Node*)pIFS );
			pIFS->coord   = (GF_Node*) pCoor;


			//Add Normals to IFS
			if ( pNor )
			{
				gf_node_register( (GF_Node*)pNor, (GF_Node*)pIFS );
				pIFS->normal  = (GF_Node*) pNor;
			}

			//Add Textures to IFS
			if ( pTex )
			{
				gf_node_register( (GF_Node*)pTex, (GF_Node*)pIFS );
				pIFS->texCoord = (GF_Node*)pTex;
			}

			//Add CoordIndex
			pIFS->coordIndex.count = st.readInt( 4 ) * 4 / 3;			// Number of indices, triangles
			pIFS->coordIndex.vals = (s32*) malloc (pIFS->coordIndex.count * sizeof (s32*));
			for ( unsigned int m = 0; m < pIFS->coordIndex.count; m++ )
			{
				pIFS->coordIndex.vals[m++] = st.readInt( 4 );
				pIFS->coordIndex.vals[m++] = st.readInt( 4 );
				pIFS->coordIndex.vals[m++] = st.readInt( 4 );
				pIFS->coordIndex.vals[m] = -1;
			}
			//Add TexCoordIndex
			int ti = st.readInt( 4 );
			if ( ti )
			{
				pIFS->texCoordIndex.count = ti * 4 / 3;			// Number of indices, triangles
				pIFS->texCoordIndex.vals = (s32*) malloc (pIFS->texCoordIndex.count * sizeof (s32*));
				for ( unsigned int m = 0; m < pIFS->coordIndex.count; m++ )
				{
					pIFS->texCoordIndex.vals[m++] = st.readInt( 4 );
					pIFS->texCoordIndex.vals[m++] = st.readInt( 4 );
					pIFS->texCoordIndex.vals[m++] = st.readInt( 4 );
					pIFS->texCoordIndex.vals[m] = -1;
				}
			}
			int ni = st.readInt( 4 );
			if ( ni )
			{
				//Add NormalCoordIndex
				pIFS->normalIndex.count = ni * 4 / 3;			// Number of indices, triangles
				pIFS->normalIndex.vals = (s32*) malloc (pIFS->normalIndex.count * sizeof (s32*));
				for ( unsigned int m = 0; m < pIFS->normalIndex.count; m++ )
				{
					pIFS->normalIndex.vals[m++] = st.readInt( 4 );
					pIFS->normalIndex.vals[m++] = st.readInt( 4 );
					pIFS->normalIndex.vals[m++] = st.readInt( 4 );
					pIFS->normalIndex.vals[m] = -1;
				}
			}

		}

	}
	//End Read Vertex Buffer



	if ( boneIndex )
		free(boneIndex);
	if ( boneInfl )
		free(boneInfl);

	//BIFS encoding part

	GF_Err e;
	GF_BifsEncoder *encodec;
	u16 ESID = BIFSESID;
	encodec = gf_bifs_encoder_new( scene );

	//GF_BIFSConfig* bcfg = (GF_BIFSConfig*)gf_odf_desc_new(GF_ODF_BIFS_CFG_TAG);
	
	
		
	//	encodec = BIFS_NewEncoder(scene);
	
	GF_List * chn;
	char* out_data;
	u32 out_data_lenght = 0;

	GF_BIFSConfig *bifsDesc;
	//BIFSConfigDescriptor *bifsDesc;
	bifsDesc = (GF_BIFSConfig*)malloc (sizeof (GF_BIFSConfig));
	//bifsDesc = (BIFSConfigDescriptor*)malloc (sizeof (BIFSConfigDescriptor));
	memset(bifsDesc,0, sizeof(GF_BIFSConfig));
	//bifsDesc->isCommandStream  = 1;
	bifsDesc->nodeIDbits = 10;
	bifsDesc->version = 2;
	
	gf_bifs_encoder_new_stream(encodec, ESID, bifsDesc, false, false );

	
	GF_Command * comm = gf_sg_command_new (scene,GF_SG_SCENE_REPLACE);
	comm->node = scene->RootNode;
	

	chn = gf_list_new ();
	gf_list_add ((GF_List*)chn , comm );

	
	
	
//	e = BIFS_NewStream(encodec, ESID, bifsDesc, false, false);
//	e = BIFS_EncodeAU (encodec,ESID, chn, &out_data, &out_data_lenght);
	e = gf_bifs_encode_au(encodec, ESID, chn, &out_data, &out_data_lenght);


	
	gf_list_del( chn );
	free( bifsDesc );
	gf_bifs_encoder_del(  encodec );
	gf_sg_del( scene );
	free(apps);

	// end BIFS encoding part

	Buff = (char**) realloc( Buff, (NoOfTracks+1) * sizeof( char *) );
	Buff[NoOfTracks] = ( char*)malloc( out_data_lenght * sizeof( char ));
	memcpy( Buff[NoOfTracks], out_data, out_data_lenght * sizeof( char ));
	BuffSize = (int*) realloc( BuffSize, ((NoOfTracks+1) * sizeof (int))); 
	BuffSize [NoOfTracks] = out_data_lenght;

	free(out_data);

	MediaType = (u32*) realloc (MediaType,(NoOfTracks+1) * sizeof (u32));
	trackType = (BufferType*) realloc(trackType, (NoOfTracks+1) * sizeof(BufferType));
	trackType[NoOfTracks] = BT_BIFS;
	NoOfSamples = (int*) realloc( NoOfSamples, (NoOfTracks+1) * sizeof(int));
	NoOfSamples [NoOfTracks] = 1;

	NoOfTracks ++;

	return 0;
}


//int VBtoMP4Lib::CreateBifs()
//{
//
//	DefID = 1;
//
//	//Create scene
//
//	GF_SceneGraph* scene =  gf_sg_new ();
//
//	//Create and Add Group Node to Scene
//	
//	M_Group *pGrp = (M_Group *)gf_node_new( scene, TAG_MPEG4_Group );
//	gf_node_register( (GF_Node*)pGrp, NULL );
//	scene->RootNode = (GF_Node*)pGrp;
//
//	//Create and Add TRansform Node to Group
//	M_Transform *pTrn = (M_Transform *)gf_node_new( scene, TAG_MPEG4_Transform );
//	//gf_list_add( pGrp->children, pTrn);
//	
//	gf_list_add((GF_List*)pGrp->children, pTrn);
//	gf_node_register( (GF_Node*)pTrn,(GF_Node*) pGrp );
//
//	// Read Appearance
//
//	BIFS::ostream as;
//	as.write( (char*) ab, abSize );
//	as.seekp( 0 );
//
//	as.readInt( 4 );						// total size of the stream
//	int ApCount = 0;
//	ApCount = as.readInt( 4 );
//	// Number of appearance atoms
//	int i;
//	M_Appearance** apps;
//	apps = (M_Appearance**)malloc( ApCount * sizeof( M_Appearance* ) );
//	memset( apps, 0, ApCount * sizeof( M_Appearance* ) );
//
//
//
//
//	for ( i = 0; i < ApCount; i++ )
//	{
//		M_Appearance* pApp = (M_Appearance*)gf_node_new( scene, TAG_MPEG4_Appearance );
//		int texId = as.readInt( 4 );
//		if ( texId >= 0 )
//		{
//			M_ImageTexture* pImgTex = (M_ImageTexture*)gf_node_new( scene, TAG_MPEG4_ImageTexture );
//			gf_node_register( (GF_Node*)pImgTex, (GF_Node*)pApp );
//			pApp->texture = (GF_Node*)pImgTex;
//			pImgTex->url.count = 1;
//			pImgTex->url.vals = (SFURL*)malloc( pImgTex->url.count * sizeof(SFURL) );
//			pImgTex->url.vals[0].OD_ID = BasicTXTODID + texId; 
//			pImgTex->url.vals[0].url = NULL;
//		}
//		int t = as.readInt(1);
//		if ( t > 0 )
//		{
//			M_Material* pMat = (M_Material*)gf_node_new( scene, TAG_MPEG4_Material );
//			gf_node_register( (GF_Node*)pMat, (GF_Node*)pApp );
//			pApp->material = (GF_Node*)pMat;
//			pMat->diffuseColor.red		= as.readFloat( 4 );
//			pMat->diffuseColor.green	= as.readFloat( 4 );
//			pMat->diffuseColor.blue		= as.readFloat( 4 );
//			pMat->specularColor.red		= as.readFloat( 4 );
//			pMat->specularColor.green	= as.readFloat( 4 );
//			pMat->specularColor.blue	= as.readFloat( 4 );
//			pMat->emissiveColor.red		= as.readFloat( 4 );
//			pMat->emissiveColor.green	= as.readFloat( 4 );
//			pMat->emissiveColor.blue	= as.readFloat( 4 );
//			pMat->transparency			= as.readFloat( 4 );
//			pMat->ambientIntensity		= as.readFloat( 4 );
//			pMat->shininess				= as.readFloat( 4 );
//		}
//		apps[i] = pApp;
//	}
//
//
//	// End Read Appearance
//
//	// Read Animatiuon
//
//	AnimationBuff* anmBuff = NULL;
//	MFInt32* boneIndex = NULL;
//	MFFloat* boneInfl = NULL;
//
//	if ( noAnim )
//	{
//		CreateAnimation();
//		anmBuff = anim[0];
//		boneIndex = (MFInt32*)malloc(anmBuff->frames[0]->boneDataCount * sizeof(MFInt32));
//		memset( boneIndex, 0, anmBuff->frames[0]->boneDataCount * sizeof(MFInt32) );
//		boneInfl = (MFFloat*)malloc(anmBuff->frames[0]->boneDataCount * sizeof(MFFloat));
//		memset( boneIndex, 0, anmBuff->frames[0]->boneDataCount * sizeof(MFFloat) );
//	}
//	// End read Animation
//
//	//Read Vertex Buffer
//
//	BIFS::ostream st;
//	st.write( ( char* )vb, vbSize );
//	st.seekp( 0 );
//
//	st.readInt( 4 );						// total size of the buffer
//	int vbCount;
//
//	vbCount = st.readInt( 1 );				// number of vertex buffers
//
//	if (!vbCount)  return 1;					// there is no one vertex buffer
//
//	//NULL SBVCV2.......always create SBVCV2 not SBVC
//	M_SBVCAnimationV2 *pAnmV2 = NULL;
//
//	for ( i = 0; i < vbCount; i++ )
//	{
//		st.readInt( 4 );					// size of vertex buffer and index buffers
//		st.readInt( 4 );					// size of vertex buffer
//
//		int desc;
//		desc = st.readInt( 1 );				// description of the vertex buffer
//		bool hasBoneInfls;
//		bool hasNormals;
//		bool hasTexCoords;
//		// decoding the descriptor
//		hasTexCoords	= (desc & 0x01)==1? true:false;		// texture coordinates
//		hasNormals		= (desc & 0x02)==2? true:false;		// normals
//		hasBoneInfls	= (desc & 0x04)==4? true:false;		// bone influences
//
//		int vCount;
//		vCount = st.readInt( 4 );			// number of vertices
//
//		//Create Coordinate node...it is shared between vc
//		M_Coordinate* pCoor = (M_Coordinate*) gf_node_new( scene, TAG_MPEG4_Coordinate);
//
//		gf_node_set_id( (GF_Node*)pCoor, DefID++, NULL );
//		pCoor->point.count = vCount;
//		pCoor->point.vals = (SFVec3f*) malloc (pCoor->point.count * sizeof (SFVec3f));
//
//		//Create Normal node...it is shared between vc
//		M_Normal * pNor = NULL;
//		if ( hasNormals )
//		{
//			pNor = (M_Normal *) gf_node_new( scene, TAG_MPEG4_Normal);
//			gf_node_set_id( (GF_Node*)pNor, DefID++, NULL );
//			pNor->vector.count = vCount;
//			pNor->vector.vals = (SFVec3f*) malloc (pNor->vector.count * sizeof (SFVec3f));
//		}
//
//		//Create Texture Node
//		M_TextureCoordinate * pTex = NULL;
//		if ( hasTexCoords )
//		{
//			pTex = (M_TextureCoordinate *) gf_node_new( scene, TAG_MPEG4_TextureCoordinate );
//			gf_node_set_id( (GF_Node*)pTex, DefID++, NULL );
//			pTex->point.count = vCount;
//			pTex->point.vals = (SFVec2f*) malloc (pTex->point.count * sizeof (SFVec2f));
//			//memset( pTex->point.vals, 0, pTex->point.count * sizeof (SFVec2f*) );
//		}
//		//Add Coords and Normals
//		for ( int j = 0; j < vCount; j++ )
//		{
//
//			pCoor->point.vals[j].x = st.readFloat( 4 );			// X coordinate
//			pCoor->point.vals[j].y = st.readFloat( 4 );			// Y coordinate
//			pCoor->point.vals[j].z = st.readFloat( 4 );			// Z coordinate
//
//			if ( hasBoneInfls )
//			{
//				//skiping the bone influences
//				float b[4];
//
//				int k;
//				for ( k = 0; k < 4; k++ )
//					b[k] = st.readFloat( 4 );
//
//				int t;
//				for ( k = 0; k < 4; k++ )
//				{
//					t = st.readInt  ( 1 );
//					if ( t == 0 )
//						continue;
//					if ( noAnim )
//					{
//						boneIndex[t].count++;
//						boneIndex[t].vals = ( s32* )realloc( boneIndex[t].vals, boneIndex[t].count * sizeof( s32 ) );
//						boneIndex[t].vals[boneIndex[t].count-1] = j;
//
//						boneInfl[t].count++;
//						boneInfl[t].vals = ( Fixed* )realloc( boneInfl[t].vals, boneInfl[t].count * sizeof( Fixed ) );
//						boneInfl[t].vals[boneIndex[t].count-1] = b[k];
//					}
//				}
//			}
//
//			if ( hasNormals )
//			{
//
//				pNor->vector.vals[j].x  = st.readFloat( 4 );
//				pNor->vector.vals[j].y  = st.readFloat( 4 );
//				pNor->vector.vals[j].z  = st.readFloat( 4 );
//			}
//
//			if ( hasTexCoords )
//			{
//				//keep the texture coordinates in  Textcoord Node
//				pTex->point.vals[j].x = st.readFloat( 4 );
//				pTex->point.vals[j].y = 1.f - st.readFloat( 4 );
//			}
//		}
//
//		M_SBSkinnedModel* pSkn = NULL;
//
//		if ( hasBoneInfls && anmBuff && noAnim )					//there is animation, create SBVC
//		{
//
//			if ( !pAnmV2 )
//			{
//				//Add SBVCV2 Node
//				pAnmV2 = (M_SBVCAnimationV2 *) gf_node_new( scene, TAG_MPEG4_SBVCAnimationV2 );
//				gf_list_add( (GF_List*)pTrn->children, pAnmV2 );
//				gf_node_register( (GF_Node*)pAnmV2, (GF_Node*)pTrn );
//				pAnmV2->url.count = noAnim;
//				pAnmV2->url.vals = (SFURL*)malloc ( pAnmV2->url.count * sizeof (SFURL) );
//				memset( pAnmV2->url.vals, 0, pAnmV2->url.count * sizeof (SFURL));
//				for (int k=0; k<noAnim ; k++)
//					pAnmV2->url.vals[k].OD_ID = BasicBBAODID + aID[k];
//
//			}
//
//			//Create and Add SBSkin Node Node to SBVCV2 Node
//			pSkn = (M_SBSkinnedModel *)gf_node_new( scene, TAG_MPEG4_SBSkinnedModel);
//			gf_list_add( (GF_List*)pAnmV2->virtualCharacters , pSkn );
//			gf_node_register( (GF_Node*)pSkn, (GF_Node*)pAnmV2 );
//			//BONES  (skeleton) 
//
//			Bone *bn = anmBuff->hier->roots[gf_list_count((GF_List*)pAnmV2->virtualCharacters) - 1];
//			CreateHierarchy( pSkn, bn, NULL );
//
//			for ( int k = 0; k < anmBuff->frames[0]->boneDataCount; k++ )
//			{
//				BoneData* bd = anmBuff->frames[0]->bonesData[k];
//				M_SBBone* pB = (M_SBBone*)  gf_list_get( (GF_List*)pSkn->bones, k );
//
//				pB->skinCoordIndex.count = boneIndex[k].count;
//				pB->skinCoordIndex.vals = boneIndex[k].vals;
//
//				pB->skinCoordWeight.count = boneInfl[k].count;
//				pB->skinCoordWeight.vals = boneInfl[k].vals;
//
//				if ( bd->hasCenter )
//				{
//					pB->center.x = bd->Center.x;
//					pB->center.y = bd->Center.y;
//					pB->center.z = bd->Center.z;
//				}
//
//				if ( bd->hasRotation )
//				{
//					if (bd->isQuaternion)
//						bd->Rotation = unMakeQuat(bd->Rotation);
//					pB->rotation.x = bd->Rotation.x;
//					pB->rotation.y = bd->Rotation.y;
//					pB->rotation.z = bd->Rotation.z;
//					pB->rotation.q = bd->Rotation.q;
//				}
//			}
//
//			gf_node_register ((GF_Node*)pCoor, (GF_Node*)pSkn);
//			pSkn->skinCoord = (GF_Node*) pCoor;
//
//			if (pNor)
//			{
//				gf_node_register ((GF_Node*)pNor, (GF_Node*)pSkn);
//				pSkn->skinNormal = (GF_Node*)pNor;
//			}
//
//		}
//
//
//		int ibCount = 0;
//		ibCount = st.readInt( 1 );					// Number of indexbuffers
//
//		for ( int k = 0; k < ibCount; k++ )
//		{
//			//for each indexbuffer Create and Add Shape Node to SBSkined
//			M_Shape *pShp = (M_Shape *)gf_node_new( scene, TAG_MPEG4_Shape );
//
//			if (hasBoneInfls && noAnim)
//			{
//				gf_list_add( (GF_List*)pSkn->skin , pShp);
//				gf_node_register( (GF_Node*)pShp, (GF_Node*)pSkn );
//			}
//			else
//			{
//				gf_list_add( (GF_List*)pTrn->children , pShp);
//				gf_node_register( (GF_Node*)pShp, (GF_Node*)pTrn );
//			}
//
//			st.readInt( 4 );	
//			int appID;
//			appID = st.readInt( 4 );			// ID of the appearance
//
//			//Create and Add Appereance to Shape Node 
//			M_Appearance* pApp = apps[appID];
//			gf_node_register( (GF_Node*)pApp, (GF_Node*)pShp );
//			pShp->appearance = (GF_Node*) pApp;
//
//			//Create and Add geometry(IFS) to Shape Node 
//			M_IndexedFaceSet* pIFS = (M_IndexedFaceSet *) gf_node_new (scene,TAG_MPEG4_IndexedFaceSet );
//			gf_node_register( (GF_Node*)pIFS, (GF_Node*)pShp );
//			pShp->geometry = (GF_Node*) pIFS;
//
//			//Add Coordinate to IFS
//			gf_node_register( (GF_Node*)pCoor, (GF_Node*)pIFS );
//			pIFS->coord   = (GF_Node*) pCoor;
//
//			//Add Normals to IFS
//			if ( pNor )
//			{
//				gf_node_register( (GF_Node*)pNor, (GF_Node*)pIFS );
//				pIFS->normal  = (GF_Node*) pNor;
//			}
//
//			//Add Textures to IFS
//			if ( pTex )
//			{
//				gf_node_register( (GF_Node*)pTex, (GF_Node*)pIFS );
//				pIFS->texCoord = (GF_Node*)pTex;
//			}
//
//			//Add CoordIndex
//			pIFS->coordIndex.count = st.readInt( 4 ) * 4 / 3;			// Number of indices, triangles
//			pIFS->coordIndex.vals = (s32*) malloc (pIFS->coordIndex.count * sizeof (s32*));
//			for ( unsigned int m = 0; m < pIFS->coordIndex.count; m++ )
//			{
//				pIFS->coordIndex.vals[m++] = st.readInt( 4 );
//				pIFS->coordIndex.vals[m++] = st.readInt( 4 );
//				pIFS->coordIndex.vals[m++] = st.readInt( 4 );
//				pIFS->coordIndex.vals[m] = -1;
//			}
//
//		}
//
//	}
//	//End Read Vertex Buffer
//
//	if ( boneIndex )
//		free(boneIndex);
//	if ( boneInfl )
//		free(boneInfl);
//
//	//BIFS encoding part
//
//	GF_Err e;
//	GF_BifsEncoder *encodec;
//
//	encodec = gf_bifs_encoder_new( scene );
//	//	encodec = BIFS_NewEncoder(scene);
//	u16 ESID = BIFSESID;
//	GF_List * chn;
//	char* out_data;
//	u32 out_data_lenght;
//
//	GF_BIFSConfig *bifsDesc;
//	//BIFSConfigDescriptor *bifsDesc;
//	bifsDesc = (GF_BIFSConfig*)malloc (sizeof (GF_BIFSConfig));
//	//bifsDesc = (BIFSConfigDescriptor*)malloc (sizeof (BIFSConfigDescriptor));
//	memset(bifsDesc,0, sizeof(GF_BIFSConfig));
//	//bifsDesc->isCommandStream  = 1;
//	bifsDesc->nodeIDbits = 10;
//	bifsDesc->version = 2;
//
//
//	
//	GF_Command * comm = gf_sg_command_new (scene,GF_SG_SCENE_REPLACE);
//	comm->node = scene->RootNode;
//
//	chn = gf_list_new ();
//	gf_list_add ((GF_List*)chn , comm );
//
//	
//	
//	
////	e = BIFS_NewStream(encodec, ESID, bifsDesc, false, false);
////	e = BIFS_EncodeAU (encodec,ESID, chn, &out_data, &out_data_lenght);
//	e = gf_bifs_encode_au(encodec, ESID, bifsDesc->elementaryMasks, false, false);
//
//	
//	gf_list_del( chn );
//	free( bifsDesc );
//	gf_bifs_encoder_del(  encodec );
//	gf_sg_del( scene );
//	free(apps);
//
//	// end BIFS encoding part
//
//	Buff = (char**) realloc( Buff, (NoOfTracks+1) * sizeof( char *) );
//	Buff[NoOfTracks] = ( char*)malloc( out_data_lenght * sizeof( char ));
//	memcpy( Buff[NoOfTracks], out_data, out_data_lenght * sizeof( char ));
//	BuffSize = (int*) realloc( BuffSize, ((NoOfTracks+1) * sizeof (int))); 
//	BuffSize [NoOfTracks] = out_data_lenght;
//
//	free(out_data);
//
//	MediaType = (u32*) realloc (MediaType,(NoOfTracks+1) * sizeof (u32));
//	trackType = (BufferType*) realloc(trackType, (NoOfTracks+1) * sizeof(BufferType));
//	trackType[NoOfTracks] = BT_BIFS;
//	NoOfSamples = (int*) realloc( NoOfSamples, (NoOfTracks+1) * sizeof(int));
//	NoOfSamples [NoOfTracks] = 1;
//
//	NoOfTracks ++;
//
//	return 0;
//}

int VBtoMP4Lib::Add3DMC (unsigned char *buff, int size, int id, const char* daeId)
{
	//	has3dmc = true;
	dmcSize = size;
	dmc = ( unsigned char *) malloc ( size );
	memcpy( dmc, buff, size);
	Create3DMC ( id );
	dmcDaeId.push_back(strdup(daeId));
	
	return 1;

}

int VBtoMP4Lib::Create3DMC( int id )
{

	Buff = (char**) realloc( Buff, (NoOfTracks+1) * sizeof(char*) );
	BuffSize = (int*) realloc( BuffSize, ((NoOfTracks+1) * sizeof (int))); 

	BuffSize[NoOfTracks] = dmcSize;
	Buff[NoOfTracks] = ( char* ) malloc( BuffSize[NoOfTracks] );
	memcpy(  Buff[NoOfTracks], dmc, dmcSize );

	MediaType = (u32*) realloc (MediaType,(NoOfTracks+1) * sizeof (u32));
	trackType = (BufferType*) realloc(trackType, (NoOfTracks+1) * sizeof(BufferType));
	trackType[NoOfTracks] = BT_3DMC;
	this->dmcID = (int*) realloc (this->dmcID ,(NoOfTracks+1) * sizeof ( int ));
	this->dmcID[NoOfTracks] = id;
	NoOfSamples = (int*) realloc(NoOfSamples, (NoOfTracks+1) * sizeof(int));
	NoOfSamples[NoOfTracks] = 1;

	NoOfTracks++; 

	return 0;
}

int VBtoMP4Lib:: AddRAR (unsigned char *buff, int size)
{
	/*rarSize = vbSize;
	rar = ( unsigned char *) malloc ( size );
	memcpy( rar, buff, size);*/
	Buff = (char**) realloc( Buff, (NoOfTracks+1) * sizeof(char*) );
	BuffSize = (int*) realloc( BuffSize, ((NoOfTracks+1) * sizeof (int))); 

	BuffSize[NoOfTracks] = size;
	Buff[NoOfTracks] = ( char* ) malloc( BuffSize[NoOfTracks] );
	memcpy(  Buff[NoOfTracks], buff, size );

	MediaType = (u32*) realloc (MediaType,(NoOfTracks+1) * sizeof (u32));
	trackType = (BufferType*) realloc(trackType, (NoOfTracks+1) * sizeof(BufferType));
	trackType[NoOfTracks] = BT_RAR;
	
	NoOfSamples = (int*) realloc(NoOfSamples, (NoOfTracks+1) * sizeof(int));
	NoOfSamples[NoOfTracks] = 1;

	NoOfTracks++; 

	return 0;

}



//int VBtoMP4Lib::SetRAR( unsigned char* &buff, int &size)
//{
//	Buff = (char**) realloc( Buff, (NoOfTracks+1) * sizeof( char *) );
//	Buff[NoOfTracks] = ( char*)malloc( size * sizeof( char ));
//	memcpy( Buff[NoOfTracks], buff, size * sizeof( char ));
//	BuffSize = (int*) realloc( BuffSize, ((NoOfTracks+1) * sizeof (int))); 
//	BuffSize [NoOfTracks] = size;
//
//	MediaType = (u32*) realloc (MediaType,(NoOfTracks+1) * sizeof (u32));
//	trackType = (BufferType*) realloc(trackType, (NoOfTracks+1) * sizeof(BufferType));
//	trackType[NoOfTracks] = BT_RAR;
//	NoOfSamples = (int*) realloc( NoOfSamples, (NoOfTracks+1) * sizeof(int));
//	NoOfSamples [NoOfTracks] = 1;
//
//	NoOfTracks ++;
//
//	return 0;
//
//}

int VBtoMP4Lib::SetRARinMETA( unsigned char* &buff, int &size)
{
	rarSize = size;
	rar = ( unsigned char *) malloc ( size );
	memcpy( rar, buff, size);
	return size;
	
}
//for exporter.......
int VBtoMP4Lib::AddBifs( GF_SceneGraph* INscene, unsigned char* &buff, int &size )
{
	scene =  INscene;
	bifsSize = size;
	bifs = ( unsigned char *) malloc ( size );
	memcpy( bifs, buff, size);
	return size;
}
int VBtoMP4Lib::SetBIFS ()
{
	//BIFS encoding part

	if ( scene )
	{
		GF_Err e;
		GF_BifsEncoder *encodec;
		u16 ESID = BIFSESID;
		encodec = gf_bifs_encoder_new( scene );
		GF_List * chn;
		char* out_data;
		u32 out_data_lenght = 0;

		GF_BIFSConfig *bifsDesc;
		//BIFSConfigDescriptor *bifsDesc;
		bifsDesc = (GF_BIFSConfig*)malloc (sizeof (GF_BIFSConfig));
		//bifsDesc = (BIFSConfigDescriptor*)malloc (sizeof (BIFSConfigDescriptor));
		memset(bifsDesc,0, sizeof(GF_BIFSConfig));
		//bifsDesc->isCommandStream  = 1;
		bifsDesc->nodeIDbits = 10;
		bifsDesc->version = 2;
		
		gf_bifs_encoder_new_stream(encodec, ESID, bifsDesc, false, false );

		
		GF_Command * comm = gf_sg_command_new (scene,GF_SG_SCENE_REPLACE);
		comm->node = scene->RootNode;
		

		chn = gf_list_new ();
		gf_list_add ((GF_List*)chn , comm );

		
		
		
	//	e = BIFS_NewStream(encodec, ESID, bifsDesc, false, false);
	//	e = BIFS_EncodeAU (encodec,ESID, chn, &out_data, &out_data_lenght);
		e = gf_bifs_encode_au(encodec, ESID, chn, &out_data, &out_data_lenght);


		
		gf_list_del( chn );
		free( bifsDesc );
		gf_bifs_encoder_del(  encodec );
		gf_sg_del( scene );
	

		// end BIFS encoding part
		bifs = ( unsigned char *) malloc ( out_data_lenght );
		memcpy( bifs, out_data, out_data_lenght );
		bifsSize = out_data_lenght;
		free(out_data);
	}
	Buff = (char**) realloc( Buff, (NoOfTracks+1) * sizeof( char* ));
	Buff[NoOfTracks] = ( char*)malloc( bifsSize * sizeof( char ));
	memcpy( Buff[NoOfTracks], bifs, bifsSize * sizeof( char ));
	BuffSize = (int*) realloc( BuffSize, ((NoOfTracks+1) * sizeof (int))); 
	BuffSize [NoOfTracks] = bifsSize;

	

	MediaType = (u32*) realloc (MediaType,(NoOfTracks+1) * sizeof (u32));
	trackType = (BufferType*) realloc(trackType, (NoOfTracks+1) * sizeof(BufferType));
	trackType[NoOfTracks] = BT_BIFS;
	NoOfSamples = (int*) realloc(NoOfSamples, (NoOfTracks+1) * sizeof(int));
	NoOfSamples [NoOfTracks] = 1;

	NoOfTracks ++;

	return 0;
}


//for exporter BBA
int VBtoMP4Lib::SetBBA ( unsigned char *vb, int vbSize, int AnimID, bool isEncoded )
{
	if ( !isEncoded )
	{
		hasAnimation = true;
		EncodeFromBufferIN( true , 0, 0, 0, 1, 7,  vb, vbSize, (char*)bufferOUT, bufferOUTSize, 0, 0, 0, 0, 3);
	}
	else
	{
		hasAnimation = true;
		AnimisMP4Stream = true;
		bufferOUTSize = vbSize;
		bufferOUT = (unsigned char*)malloc(bufferOUTSize);
		memcpy(bufferOUT, vb, bufferOUTSize );
	}
	return 0;

}

int VBtoMP4Lib::ReadBegin(char* data_buffer,int current_pos,int fileSize)
{
	unsigned int begin=0;
	while ((begin!=490)&&(current_pos<fileSize-4))
	{
		begin=(unsigned char)data_buffer[current_pos+0];

		begin<<=8;
		begin|=(unsigned char)(data_buffer[current_pos+1]);

		begin<<=8;
		begin|=(unsigned char)(data_buffer[current_pos+2]);

		begin<<=8;
		begin|=(unsigned char)(data_buffer[current_pos+3]);


		current_pos++;
	}
	return current_pos+3;
}


bool VBtoMP4Lib::ReadNextFrame(char* data_buffer, char* frame,int &frame_size,int &current_pos,int fileSize )
{
	bool hasMoreFrames=true;
	unsigned int beginframe=0;
	unsigned int endframe=0;
	frame_size=0;

	while ((beginframe!=492)&&(beginframe!=491)&&(current_pos<fileSize-3))
	{
		beginframe=(unsigned char)(data_buffer[current_pos+0]);

		beginframe<<=8;
		beginframe|=(unsigned char)(data_buffer[current_pos+1]);

		beginframe<<=8;
		beginframe|=(unsigned char)(data_buffer[current_pos+2]);

		beginframe<<=8;
		beginframe|=(unsigned char)(data_buffer[current_pos+3]);
		current_pos++;
	}

	frame[frame_size]=data_buffer[current_pos-2];
	frame_size++;

	frame[frame_size]=data_buffer[current_pos-1];
	frame_size++;


	while ((endframe!=492)&&(endframe!=491)&&(current_pos<(fileSize-3)))
	{
		frame[frame_size]=data_buffer[current_pos];
		frame_size++;
		endframe=(unsigned char)(data_buffer[current_pos+0]);

		endframe<<=8;
		endframe|=(unsigned char)(data_buffer[current_pos+1]);

		endframe<<=8;
		endframe|=(unsigned char)(data_buffer[current_pos+2]);

		endframe<<=8;
		endframe|=(unsigned char)(data_buffer[current_pos+3]);
		current_pos++;

	}

	current_pos=current_pos-1;	

	if ((beginframe==491)||(endframe==491)) hasMoreFrames=false;
	if ((current_pos>=fileSize-4)) {hasMoreFrames=false;}

	FILE* f;
	f = fopen("C://testbba2","wb");
	
	fwrite(frame,frame_size,1,f);
	fclose ( f );


	return hasMoreFrames;
}


bool VBtoMP4Lib::SetFrames( )
{
	int begin_pos=0;
	int current_pos=0;
	bool isFirstFrame = true;
	current_pos=ReadBegin((char *) bufferOUT,current_pos,bufferOUTSize);
	begin_pos=current_pos;
	char frame_data[4096];
	int frame_size=0;
	char firstFrame[4096];
	int firstFrameSize = 0;
	bool hasFrames = true;
	NoOfSamples = (int*) realloc(NoOfSamples, (NoOfTracks+1) * sizeof(int));
	sample = ( GF_ISOSample*** ) realloc ( sample, (NoOfTracks+1)* sizeof (GF_ISOSample**) );
	sample[NoOfTracks] = NULL;
	NoOfSamples[NoOfTracks]= 1;
	int i = 1;
	while (hasFrames)
	{
		hasFrames = ReadNextFrame(( char *)bufferOUT,frame_data,frame_size,current_pos,bufferOUTSize);
		//from the first frame create the track
		if (isFirstFrame)
		{
			memccpy(firstFrame,frame_data,1,frame_size);
			firstFrameSize = frame_size;
			isFirstFrame = false;

			Buff = (char**) realloc( Buff, ( NoOfTracks+1 )* sizeof( char *) );
			Buff[NoOfTracks] = ( char* ) malloc( bufferOUTSize* sizeof( char ));
			memcpy( Buff[NoOfTracks], bufferOUT, bufferOUTSize * sizeof( char ));
			BuffSize = (int*) realloc( BuffSize, ((NoOfTracks+1) * sizeof (int))); 
			BuffSize[NoOfTracks] = bufferOUTSize;

			continue;
		}
		//add samples in the track from the other frames
		/*Buff = (char**) realloc( Buff, (NoOfTracks+1) * sizeof( char* ) );
		Buff[NoOfTracks] = ( char* ) malloc( frame_size* sizeof( char ));
		memcpy( Buff[NoOfTracks], frame_data, frame_size * sizeof( char ));
		BuffSize = (int*) realloc( BuffSize, ((NoOfTracks+1) * sizeof (int))); 
		BuffSize[NoOfTracks] += frame_size;*/
		//new sample
		
		sample[NoOfTracks] = ( GF_ISOSample** ) realloc ( sample[NoOfTracks], (NoOfSamples[NoOfTracks]+1)* sizeof (GF_ISOSample*));
		sample[NoOfTracks][NoOfSamples[NoOfTracks]] = gf_isom_sample_new();
		sample[NoOfTracks][NoOfSamples[NoOfTracks]]->data = frame_data;
		sample[NoOfTracks][NoOfSamples[NoOfTracks]]->dataLength = frame_size;
		//sample[NoOfTracks][NoOfSamples[NoOfTracks]] = M4_NewFullSample(Buff[NoOfTracks] ,BuffSize[NoOfTracks] , 0, 0, 0);

		NoOfSamples[NoOfTracks]++;
		i++;
		//to do : put bba end code in teh last frame
	}

	//data for new track in MP4 file
	//to do : put bba start code in teh start frame
	

	MediaType = (u32*) realloc (MediaType,(NoOfTracks+1) * sizeof (u32));
	trackType = (BufferType*) realloc(trackType, (NoOfTracks+1) * sizeof(BufferType));
	trackType[NoOfTracks] = BT_BBA;
	AnmID = (int*) realloc (AnmID ,(NoOfTracks+1) * sizeof ( int ));
	AnmID[NoOfTracks] = 49 ;//to do: add for more animation aID[k]
	NoOfTracks++; 

	return true;
}
//end for exporter BBA


//Texture encoding part
int VBtoMP4Lib::AddTexture (unsigned char *vb, int vbSize, int texID, const char* daeId)
{
	hasTexture = true;
	tbSize = vbSize;
	tb = ( unsigned char *) malloc ( vbSize );
	memcpy( tb, vb, vbSize);
	CreateTexture( texID );
	txtDaeId.push_back(strdup(daeId));
	return 1;

}
int VBtoMP4Lib::CreateTexture ( int texID )
{
	//  add  jasper......


	/*jas_stream_t *in, *out;

	if (jas_init()) {
		return -1;
	}

	in = jas_stream_memopen( (char*)tb, tbSize );

	jas_image_t *image;

	int infmt =jas_image_getfmt(in);
	char *inopts = NULL;
	image = jas_image_decode(in, infmt, inopts);
	jas_stream_close(in);

	int numcmpts = jas_image_numcmpts(image);

	{
		jas_image_t *newimage;
		jas_cmprof_t *outprof;
		outprof = jas_cmprof_createfromclrspc(JAS_CLRSPC_SRGB);
		newimage = jas_image_chclrspc(image, outprof, JAS_CMXFORM_INTENT_PER);
		jas_image_destroy(image);
		jas_cmprof_destroy(outprof);
		image = newimage;
	}

	out = jas_stream_memopen( NULL, 0 );

	int outfmt = jas_image_strtofmt( "jp2" );
	char outopts = '\0';
	jas_image_encode( image, out, outfmt, &outopts );
	jas_stream_flush(out);*/


	/*Buff = (char**) realloc( Buff, (NoOfTracks+1) * sizeof(char*) );
	BuffSize = (int*) realloc( BuffSize, ((NoOfTracks+1) * sizeof (int))); 

	BuffSize[NoOfTracks] = jas_stream_length( out );
	Buff[NoOfTracks] = ( char* ) malloc( BuffSize[NoOfTracks] );
	jas_stream_rewind( out );
	jas_stream_read( out, Buff[NoOfTracks], BuffSize[NoOfTracks] );

	jas_stream_close(out);

	jas_image_destroy(image);
	jas_cleanup();*/

	Buff = (char**) realloc( Buff, (NoOfTracks+1) * sizeof(char*) );
	BuffSize = (int*) realloc( BuffSize, ((NoOfTracks+1) * sizeof (int))); 

	BuffSize[NoOfTracks] = tbSize;
	Buff[NoOfTracks] = ( char* ) malloc( BuffSize[NoOfTracks] );
	memcpy( Buff[NoOfTracks], tb, BuffSize[NoOfTracks]);

	MediaType = (u32*) realloc (MediaType,(NoOfTracks+1) * sizeof (u32));
	trackType = (BufferType*) realloc(trackType, (NoOfTracks+1) * sizeof(BufferType));
	trackType[NoOfTracks] = BT_TEX;
	this->texID = (int*) realloc (this->texID ,(NoOfTracks+1) * sizeof ( int ));
	this->texID[NoOfTracks] = texID;
	NoOfSamples = (int*) realloc(NoOfSamples, (NoOfTracks+1) * sizeof(int));
	NoOfSamples[NoOfTracks] = 1;

	NoOfTracks++; 

	return 0;
}

void VBtoMP4Lib::MakeTextualBBA( Frames* frame )
{
	memset(bufferIN, 0, BBABUFFERSIZE); 
	bufferINSize = 0;
	int j = 0;
	for (int i=0; i<frame->boneDataCount;i++)
	{
		//put mask
		if (frame->bonesData[i]->hasCenter)
			bufferIN[j++]= 1;
		else 
			bufferIN[j++]= 0;
		if (frame->bonesData[i]->hasRotation)
		{
			bufferIN[j++]= 1;
			if (frame->bonesData[i]->isQuaternion)
				bufferIN[j++]= 1;
		}
		else 
			bufferIN[j++]= 0;
		if (frame->bonesData[i]->hasTranslation)
			bufferIN[j++]= 1;
		else 
			bufferIN[j++]= 0;
		if (frame->bonesData[i]->hasScale )
			bufferIN[j++]= 1;
		else 
			bufferIN[j++]= 0;
		if (frame->bonesData[i]->hasScaleOrientation)
			bufferIN[j++]= 1;
		else 
			bufferIN[j++]= 0;
	}
	bufferIN[j++]= '\n';

	//put Data
	for (int i=0; i<frame->boneDataCount;i++)
	{
		if (frame->bonesData[i]->hasCenter)
		{
			bufferIN[j++]= frame->bonesData[i]->Center.x;
			bufferIN[j++]= frame->bonesData[i]->Center.y;
			bufferIN[j++]= frame->bonesData[i]->Center.z;
		}

		if (frame->bonesData[i]->hasRotation)
		{

			bufferIN[j++]= frame->bonesData[i]->Rotation.x;
			bufferIN[j++]= frame->bonesData[i]->Rotation.y;
			bufferIN[j++]= frame->bonesData[i]->Rotation.z;
			bufferIN[j++]= frame->bonesData[i]->Rotation.q;
		}
		//TO DO ............in better times
		/*if (frame->bonesData[i]->hasTranslation)
		bufferIN[i++]= 1;

		if (frame->bonesData[i]->hasScale )
		bufferIN[i++]= 1;

		if (frame->bonesData[i]->hasScaleOrientation)
		bufferIN[i++]= 1;*/
	}

	bufferIN[j++]= '\n';
	bufferINSize = j;

}
void VBtoMP4Lib::AddAnimation (unsigned char *anb, int anbSize, int AnimID,bool isMP4Stream )
{
	hasAnimation = true;
	noAnim++;

	an = ( unsigned char **) realloc (an,noAnim * sizeof ( unsigned char* ));
	anSize = (int*) realloc (anSize,noAnim * sizeof ( int ));
	aID = (int*) realloc (aID ,noAnim * sizeof ( int ));
	anSize[noAnim-1] = anbSize;
	an[noAnim-1] = ( unsigned char *) malloc ( anbSize * sizeof ( unsigned char ));
	memcpy( an[noAnim-1], anb, anSize[noAnim-1]);
	aID[noAnim-1] = AnimID;

	AnimisMP4Stream = isMP4Stream;
}

int VBtoMP4Lib::CreateHierarchy( M_SBSkinnedModel *pSkn, Bone *pBone, M_SBBone *pSBBone )
{
	for ( int i = 0; i < pBone->childCount; i++ )
	{
		M_SBBone *pBon = (M_SBBone *) gf_node_new( pSkn->sgprivate->scenegraph, TAG_MPEG4_SBBone);
		gf_list_add( (GF_List*)pSkn->bones, pBon );
		gf_node_register( (GF_Node*)pBon, (GF_Node*)pSkn );

		pBon->boneID = pBone->child[i]->idBone;
		gf_node_set_id( (GF_Node*) pBon, DefID++, NULL );

		if ( pSBBone )
		{
			//gf_list_add( (GF_List*)pSBBone->children, pBon );
			gf_node_register( (GF_Node*)pBon, (GF_Node*)pSBBone );
			gf_node_insert_child( (GF_Node*)pSBBone, (GF_Node*)pBon, -1 );
		}
		else
		{
			gf_list_add( (GF_List*)pSkn->skeleton, pBon );
			gf_node_register( (GF_Node*)pBon, (GF_Node*)pSkn );			
		}
		CreateHierarchy( pSkn, pBone->child[i], pBon );
	}
	return 0;
}

int VBtoMP4Lib::CreateAnimation (  )
{
	//create  frames data

	/*char*	bt = NULL;
	int		bs = 0;

	if ( AnimisMP4Stream )
	{
		for (int i=0; i<noAnim; i++)
		{
			int j=0;
			while (j < anSize[i])
			{
				
				while (an[i][j] != 492 )
					j++;

				while (an[i][j] != 492 && an[i][j] != 491 )
				{
					bs++;
					j++;
				}

				j-=bs;

				bt = ( char* ) malloc( bs* sizeof( char ));
				memcpy( bt , (char*)an[i][j], bs * sizeof( char ));
				
				Buff = (char**) realloc( Buff, ( NoOfTracks+1 )* sizeof( char* ) );
				Buff[NoOfTracks] = ( char* ) malloc( bs* sizeof( char ));
				memcpy( Buff[NoOfTracks], bt, bs * sizeof( char ));
				BuffSize = (int*) realloc( BuffSize, ((NoOfTracks+1) * sizeof (int))); 
				BuffSize[NoOfTracks] = bufferOUTSize;

				MediaType = (u32*) realloc (MediaType,(NoOfTracks+1) * sizeof (u32));
				trackType = (BufferType*) realloc(trackType, (NoOfTracks+1) * sizeof(BufferType));
				trackType[NoOfTracks] = BT_BBA;
				NoOfSamples = (int*) realloc( NoOfSamples, (NoOfTracks+1) * sizeof(int));	
				AnmID = (int*) realloc (AnmID ,(NoOfTracks+1) * sizeof ( int ));
				AnmID[NoOfTracks] = aID[i];
				NoOfTracks++; 
			}
		}
			
	}
	else*/
	{
		anim = (AnimationBuff**) malloc ( noAnim * sizeof( AnimationBuff* ));
		bool hierarchy = true;

		//one track
		for (int i=0; i<noAnim ; i++)
		{
			anim[i] = new AnimationBuff ((char*) an[i], anSize [i], hierarchy);
			hierarchy = false; 
			NoOfSamples = (int*) realloc( NoOfSamples, (NoOfTracks+1) * sizeof(int));	
			NoOfSamples[NoOfTracks]= 1;
			//one sample
			for ( int j=1; (j < anim[i]->NoFrames); j++)
			{
				MakeTextualBBA( anim[i]->frames[j]);

				bufferOUTSize = 0;
				bufferOUT = NULL;
				if (j = (anim[i]->NoFrames - 1))
					EncodeFromBufferIN( true , 0, 0, 0, 1, 7,  bufferIN, bufferINSize, (void*)bufferOUT, bufferOUTSize, 1, 0, 0, 0, LASTFRAME);
				else
					EncodeFromBufferIN( true , 0, 0, 0, 1, 7,  bufferIN, bufferINSize, (void*)bufferOUT, bufferOUTSize, 1, 0, 0, 0, 0);
				Buff = (char**) realloc( Buff, (NoOfTracks+1) * sizeof( char * ));
				Buff[NoOfTracks] = ( char* ) malloc( bufferOUTSize* sizeof( char ));
				memcpy( Buff[NoOfTracks], bufferOUT, bufferOUTSize * sizeof( char ));
				BuffSize = (int*) realloc( BuffSize, ((NoOfTracks+1) * sizeof (int))); 
				BuffSize[NoOfTracks] = bufferOUTSize;
				//new sample
				sample = ( GF_ISOSample*** ) realloc ( sample, (NoOfTracks+1)* sizeof (GF_ISOSample**) );
				sample[NoOfTracks] = ( GF_ISOSample** ) realloc ( sample[NoOfTracks], (NoOfSamples[NoOfTracks]+1)* sizeof (GF_ISOSample*));
				sample[NoOfTracks][NoOfSamples[NoOfTracks]] = gf_isom_sample_new();
				sample[NoOfTracks][NoOfSamples[NoOfTracks]]->data = Buff[NoOfTracks];
				sample[NoOfTracks][NoOfSamples[NoOfTracks]]->dataLength = BuffSize[NoOfTracks];
				
	//			sample[NoOfTracks][NoOfSamples[NoOfTracks]] = (GF_ISOSample*) M4_NewFullSample(Buff[NoOfTracks] ,BuffSize[NoOfTracks] , 0, 0, 0);

				NoOfSamples[NoOfTracks]++;
			}
			//
			//for 1st sample
			MakeTextualBBA( anim[i]->frames[0]);

			//EncodeFromBufferIN(bool hasHeader,int automaticIN,int p_framesIN,int coding_typeIN,int p2q, int gs, void* bufferIN,int bufferINSize, void* bufferOUT,int &bufferOUTSize, int noFrames, bool saveINFile, int key, float t, int frameLoc)
			bufferOUTSize = 0;
			bufferOUT = NULL;
			if (NoOfSamples[NoOfTracks]== 1)
				EncodeFromBufferIN( true , 0, 0, 0, 1, 7,  bufferIN, bufferINSize, (void*)bufferOUT, bufferOUTSize, 1, 0, 0, 0,ONLYONEFRAME) ;
			else
				EncodeFromBufferIN( true , 0, 0, 0, 1, 7,  bufferIN, bufferINSize, (void*)bufferOUT, bufferOUTSize, 1, 0, 0, 0, FIRSTFRAME);

			Buff = (char**) realloc( Buff, ( NoOfTracks+1 )* sizeof( char* ) );
			Buff[NoOfTracks] = ( char* ) malloc( bufferOUTSize* sizeof( char ));
			memcpy( Buff[NoOfTracks], bufferOUT, bufferOUTSize * sizeof( char ));
			BuffSize = (int*) realloc( BuffSize, ((NoOfTracks+1) * sizeof (int))); 
			BuffSize[NoOfTracks] = bufferOUTSize;

			MediaType = (u32*) realloc (MediaType,(NoOfTracks+1) * sizeof (u32));
			trackType = (BufferType*) realloc(trackType, (NoOfTracks+1) * sizeof(BufferType));
			trackType[NoOfTracks] = BT_BBA;
			AnmID = (int*) realloc (AnmID ,(NoOfTracks+1) * sizeof ( int ));
			AnmID[NoOfTracks] = aID[i];
			NoOfTracks++; 
		}
	}
	return 0;
}

int VBtoMP4Lib::GetTrackSize(int &ODsize, int &BIFSsize,int &DMCsize, int &IMGsize, int &BBAsize)
{
	ODsize		= ODSize;
	BIFSsize	= BIFSSize;
	IMGsize		= IMGSize;
	BBAsize		= BBASize;
	DMCsize		= DMCSize;
	return 0;
}

int VBtoMP4Lib::CreateMP4 (const char* file_name, bool NotFromBuffer)
{
	//set file name
	mp4FileName = strdup( file_name );

	if (hasBIFS) 
		CreateBifs();
	else
		SetBIFS( );

	/*if (hasTexture)
	CreateTexture ();*/

	if (hasAnimation)
	{
		if (NotFromBuffer) 
			SetFrames();
		else
			CreateAnimation (  );
	}


	//create OD
	OD->InitOD ();

	int ODID					= 0; 
	int ESID					= ODESID;
	const char* streamFormat	= NULL; 
	int streamType				= 2;
	int objectTypeIndication	= 1;
	int bufferSizeDB			= 5000;


	//Add Od ESD....not need ????????????
	//mp4Lib->OD->AddODSample (ODID, ODESID,"OD", /*OD*/1, 2, 5000 );
	//Add other
	for (int i=1; i< NoOfTracks; i++)
	{
		switch (trackType[i])
		{
		case BT_BIFS:
			{
				ODID					= 0; 
				ESID					= BIFSESID;
				streamFormat			= NULL; 
				streamType				= GF_ISOM_PL_SCENE;
				objectTypeIndication	= 2;
				bufferSizeDB			= 4000000;
				
				MediaType[i]			= GF_ISOM_MEDIA_SCENE;

			}
			break;
		case BT_TEX:
			{
				ODID					= BasicTXTODID + (texID[i]);
				ESID					= TXTESID + (texID[i]);
				streamFormat			= "JPEG2000"; 
				streamType				= GF_ISOM_PL_VISUAL;//M4ST_VISUAL;;
				objectTypeIndication	= 0x6e;
				bufferSizeDB			= 800000;
				MediaType[i]			= GF_ISOM_MEDIA_VISUAL;

			}
			break;
		case BT_BBA:
			{
				if ( AnmID[i]<0 ) 
					AnmID[i] = 0;
				ODID					= BasicBBAODID + (AnmID[i]);
				ESID					= BBAESID+(AnmID[i]); 
				streamFormat			= NULL; 
				streamType				= GF_ISOM_PL_SCENE;
				objectTypeIndication	= BBAobjectTypeIndication;
				bufferSizeDB			= 0;
				MediaType[i]			= GF_ISOM_MEDIA_SCENE;

			}
			break;
		case BT_3DMC:
			{
				ODID					= Basic3DMCODID + (dmcID[i]);
				ESID					=  DMCESID + (dmcID[i]);
				streamFormat			= "3DMC"; 
				streamType				= GF_ISOM_PL_VISUAL;
				objectTypeIndication	= 55;
				bufferSizeDB			= 4000000;
				MediaType[i]			= GF_ISOM_MEDIA_VISUAL;

			}
			break;
		case BT_RAR:
			{
				ODID					= BasicRARODID; 
				ESID					= RARESID;
				streamFormat			= 0; 
				streamType				= GF_ISOM_PL_VISUAL;
				objectTypeIndication	= 33;
				bufferSizeDB			= RARbufferSizeDB;
				MediaType[i]			= GF_ISOM_MEDIA_VISUAL;


			}
			break;
		}	//check if it is BIFS, not add
		if (ESID!= BIFSESID) OD->AddODSample (ODID, ESID, streamFormat,1, objectTypeIndication, bufferSizeDB );	

		
	}
	OD->CreateODBuffer ();
	Buff[0] = (char*) malloc( OD->au_length * sizeof( char));
	memcpy(Buff[0], OD->outAU, OD->au_length );
	BuffSize[0] = OD->au_length;
	MediaType[0] = GF_ISOM_MEDIA_OD;



	//MUX
	//find descriptors
	OD->InitOD ();
	int* trackID;
	trackID = (int*) malloc (NoOfTracks * sizeof (int)) ;


	for (int j=0; j< NoOfTracks; j++)
	{
		switch (trackType[j])
		{
		case BT_OD:
			{
				ODID					= 0; 
				ESID					= ODESID;
				streamFormat			= NULL; 
				streamType				= GF_ISOM_PL_OD;
				objectTypeIndication	= 1;
				bufferSizeDB			= 5000;
				MediaType[j]			= GF_ISOM_MEDIA_OD;
				trackID[j]				= ODESID;
				ODSize					= ODSize + BuffSize[j];

			}
			break;	
		case BT_BIFS:
			{
				ODID					= 0; 
				ESID					= BIFSESID;
				streamFormat			= NULL; 
				streamType				= GF_ISOM_PL_SCENE;
				objectTypeIndication	= 2;
				bufferSizeDB			= 4000000;
				MediaType[j]			= GF_ISOM_MEDIA_SCENE;
				trackID[j]				= BIFSESID;
				BIFSSize				= BIFSSize + BuffSize[j];

			}
			break;
		case BT_TEX:
			{
				ODID					= BasicTXTODID + (texID[j]);
				ESID					= TXTESID + (texID[j]);
				streamFormat			= NULL;//"JPEG2000"; 
				streamType				= GF_ISOM_PL_VISUAL;
				objectTypeIndication	= 0x6e;
				bufferSizeDB			= 800000;
				MediaType[j]			= GF_ISOM_MEDIA_VISUAL;
				trackID[j]				= TXTESID + (texID[j]);
				IMGSize					= IMGSize + BuffSize[j];

			}
			break;
		case BT_BBA:
			{
				if ( AnmID[j]<0 ) 
					AnmID[j] = 0;
				ODID					= BasicBBAODID +(AnmID[j]); 
				ESID					= BBAESID+(AnmID[j]); 
				streamFormat			= NULL; 
				streamType				= GF_ISOM_PL_SCENE;
				objectTypeIndication	= BBAobjectTypeIndication;
				bufferSizeDB			= 0;
				MediaType[j]			= GF_ISOM_MEDIA_SCENE;//M4_BIFSMediaType;
				trackID[j]				= BBAESID + (AnmID[j]);
				BBASize					= BBASize + BuffSize[j];

			}
			break;
		case BT_3DMC:
			{
				ODID					= Basic3DMCODID + (dmcID[j]);
				ESID					=  DMCESID + (dmcID[j]);
				streamFormat			= "3DMC"; 
				streamType				= GF_ISOM_PL_VISUAL;
				objectTypeIndication	= 55;
				bufferSizeDB			= 4000000;
				MediaType[j]			= GF_ISOM_MEDIA_VISUAL;
				trackID[j]				= DMCESID + (dmcID[j]);
				DMCSize					= DMCSize + BuffSize[j];

			}
			break;
		case BT_RAR:
			{
				ODID					= BasicRARODID; 
				ESID					= RARESID;
				streamFormat			= NULL; 
				streamType				= GF_ISOM_PL_VISUAL;
				objectTypeIndication	= 33;
				bufferSizeDB			= RARbufferSizeDB;
				MediaType[j]			= GF_ISOM_MEDIA_VISUAL;//M4_VisualMediaType;
				trackID[j]				= RARESID;

			}
			break;
		}
		OD->AddODSample (ODID, ESID, streamFormat,streamType, objectTypeIndication, bufferSizeDB );	

	}	//start mux_ing

	GF_ISOFile *mm  =  gf_isom_create_movie(mp4FileName, GF_ISOM_OPEN_WRITE, "");
	
	//Add iods
	GF_Descriptor* dec = gf_odf_desc_new(GF_ODF_IPMP_TL_TAG);
	
	GF_Err e = gf_isom_add_desc_to_root_od( mm, dec ); // AddMovieIOD(mm->moov, true);

	//Add track
	for (int i=0; i< NoOfTracks; i++)
	{

		u32 Ok = gf_isom_new_track( mm, trackID[i] ,MediaType[i], 1000);  
		GF_ISOSample *firstSample = gf_isom_sample_new();
		firstSample->data = Buff[i];
		firstSample->dataLength = BuffSize[i];
		
		//GF_ISOSample *firstSample = gf_isom_(Buff[i] ,BuffSize[i] , 0, 0, 0);
		u32 index;
		GF_ObjectDescriptor *od = (GF_ObjectDescriptor*) gf_list_get(OD->odUpdate->objectDescriptors,i);
		GF_ESD* pESD = (GF_ESD*)gf_list_get( od->ESDescriptors, 0 );  //for each OD  'i-1' entry
		e = gf_isom_new_mpeg4_description(mm, Ok, pESD, NULL, NULL, &index); // Ok -tracknumber 
		e = gf_isom_add_sample( mm, Ok, index,firstSample); //// Ok -tracknumber 
		for (int j=1; j< NoOfSamples[i]; j++)
		{
			sample[i][j]->DTS = j * 40 - 40;
			e = gf_isom_add_sample(mm, Ok, index,(GF_ISOSample*) sample[i][j]); //// Ok -tracknumber 
			
		}
		// Add track to iods.........only for OD and BIFS...
		// if ((MediaType[i]== M4_ODMediaType)||(MediaType[i]	== M4_BIFSMediaType))
		if ((trackID[i] == ODESID) || (trackID[i] == BIFSESID))
			e =gf_isom_add_track_to_root_od((GF_ISOFile *)mm, Ok); 

				
		if (trackID[i] == BIFSESID)
		{
			//add bifsDesc
			
			//GF_BIFSConfig* bcfg = (GF_BIFSConfig*)gf_odf_desc_new(GF_ODF_BIFS_CFG_TAG);
			Media_CreateDataRef
			GF_TrackBox* track = gf_isom_get_track(mm->moov, Ok);
			GF_ESD* esd;
			u32 StreamDescriptionIndex = 1;
			Media_GetESD(track->Media, StreamDescriptionIndex, &esd, 1);
			char *data = (char*)malloc(3);
			data[0] = 0x14;
			data[1] = 0xA5;
			data[2] = 0x40;
			GF_DefaultDescriptor* desc = (GF_DefaultDescriptor*)gf_odf_desc_new( 0x05 );
			desc->data = data;
			desc->dataLength = 3;
			esd->decoderConfig->decoderSpecificInfo = desc;
			//end add BifsDesc
		}
	}
	///file is created

	gf_isom_set_meta_type( mm, true, 0, GF_4CC('m','p','g','4'));
	// add information for 3dmc track in mime type
	for (int i=0; i<dmcDaeId.size(); i++)
	{
		char mime[50];
		sprintf(mime, "scene/3dmc;TrackID=%d", DMCESID + i);
		e = gf_isom_add_meta_item( mm, true,0, false,NULL,dmcDaeId[i], mime ,"",dmcDaeId[i],NULL);
	
	}
	Media_CreateDataRef
	// add information for texture track in mime type
	for (int i=0; i<txtDaeId.size(); i++)
	{
		char mime[50];
		sprintf(mime, "texture/jpeg;TrackID=%d", TXTESID + i);
		//treba da se dodade data ref = TrackID vnatre vo samata f-ja
		e = gf_isom_add_meta_item( mm, true,0, false,NULL,txtDaeId[i], mime ,"",txtDaeId[i],NULL);
		
	}
		// add rar buffer in meta
	if ( rar )
	{
		FILE *f;
		f = fopen( "rarScene.rar" , "wb");
		fwrite(rar, rarSize,1,f);
		fclose( f );
		char mime[50];
		sprintf(mime, "scene/rar");
		e = gf_isom_add_meta_item( mm, true, 0,false,"rarScene.rar","rarScene",mime,"",NULL,NULL);
		//e = gf_isom_set_meta_xml( mm, true, 0, "rarScene.rar", true );
		
		remove( "rarScene.rar" );
	}

	gf_isom_close(mm);
	if ( trackID )
		free( trackID );

	OD->DeleteODData(); 


	return 0;



}



//////////////////////////////////////////////////////////////////////////////////////////////
/*                                                                                           */
/////////////////////////////////////////////////////////////////////////////////////////////
VBtoMP4Lib *mp4Lib = NULL;

int VBtoMP4Lib_Init()
{
	delete mp4Lib;
	mp4Lib = new VBtoMP4Lib ();
	return 0;
}

int VBtoMP4Lib_Free()
{
	delete mp4Lib;
	mp4Lib = NULL;
	return 0;
}

int VBtoMP4Lib_SetVB( unsigned char* &buff, int &size, unsigned char* &Apbuff, int &Apsize)
{
	if ( !mp4Lib )
		return -1;
	return mp4Lib->AddBifs( buff, size, Apbuff, Apsize );
}





int VBtoMP4Lib_SetTB( unsigned char* &buff, int &size, int id, const char* daeId)
{
	if ( !mp4Lib )
		return -1;
	return mp4Lib->AddTexture( buff, size, id,  daeId);
}

int VBtoMP4Lib_SetAB( unsigned char* &buff, int &size, int id, bool isMP4Stream )
{
	if ( !mp4Lib )
		return -1;
	mp4Lib->AddAnimation( buff, size, id, isMP4Stream );
	return 1;
}

int VBtoMP4Lib_Set3DMC( unsigned char* &buff, int &size, int id, const char* daeId)
{
	if ( !mp4Lib )
		return -1;
	mp4Lib->Add3DMC( buff, size, id, daeId );
	return 1;

}

int VBtoMP4Lib_SetRAR( unsigned char* &buff, int &size)
{
	if ( !mp4Lib )
		return -1;
	mp4Lib->AddRAR( buff, size);
	return 1;

}

int VBtoMP4Lib_SetRARinMETA( unsigned char* &buff, int &size)
{
	if ( !mp4Lib )
		return -1;
	mp4Lib->SetRARinMETA( buff, size);
	return 1;

}

int VBtoMP4Lib_GetTrackSize(int &ODSize, int &BIFSSize,int &DMCSize, int &IMGSize, int &BBASize)
{
	if ( !mp4Lib )
		return -1;
	mp4Lib->GetTrackSize(ODSize, BIFSSize,DMCSize,IMGSize, BBASize );
	return 1;
}

int VBtoMP4Lib_CreateMP4(const char* file_name)
{
	if ( !mp4Lib )
		return -1;

	mp4Lib->CreateMP4( file_name, false );
	return 1;
}

//for exporter

int VBtoMP4Lib_AddBifs(void* INscene, unsigned char* &buff, int &size )
{
	if ( !mp4Lib )
		return -1;
	return mp4Lib->AddBifs( (GF_SceneGraph*) INscene, buff, size );
	
}
//int VBtoMP4Lib_SetBIFS(GF_SceneGraphe* INscene )
//{
//	if ( !mp4Lib )
//		return -1;
//	return mp4Lib->SetBIFS( (GF_SceneGraph*) scene );
//}

int VBtoMP4Lib_SetBBA(unsigned char* &buff, int &size, int id, bool isEncoded )
{
	if ( !mp4Lib )
		return -1;
	mp4Lib->SetBBA( buff, size, id, isEncoded  );
	return 1;
}

int VBtoMP4Lib_ExportMP4(const char* file_name)
{
	if ( !mp4Lib )
		return -1;

	mp4Lib->CreateMP4( file_name, true );
	return 1;
}
