#include "FAMCEncoder_E.h"

//#define PROFILING_FAMC

FAMCEncoder_E::FAMCEncoder_E(const FAMCParams & param)
:FAMCEncoder( param )
{
}

FAMCEncoder_E::~FAMCEncoder_E(void)
{
}

bool FAMCEncoder_E::EncodeStream_3DMC( std::vector<MeshFrame> &dmcMesh , char * sFile )
{
	char fin[1024];
	sprintf(fin, "%s.wrl", "fileName");
	char fout[1024];
	sprintf(fout, "%s.mp4", "fileName");

	IndexedFaceSet_E myIFS;
	myIFS.Load_IFS_3DMC( dmcMesh );

	Animation_E myAnim;
	myAnim.LoadInterpolators_3DMC( dmcMesh );

#ifdef PROFILING_FAMC
	IndexedFaceSet_E ifs;
	ifs.Load_IFS_3DMC( dmcMesh );
	for ( int i = 0; i < myAnim.GetNKeyCoord(); i++ )
	{
		Animation segment;
		std::vector<float> keys;
		std::vector<float> coord;
		std::vector<float> normal;
		std::vector<float> color;
		myAnim.GetAnimationSegment(segment, i, i + 1);
		segment.GetAnimationData(keys, coord, normal, color, 0);
		ifs.Load_IFS_Vectors( coord, normal, color );
		char fileName[255];
		sprintf(fileName, "Frame_in_%02d.wrl", i);
		ifs.SaveIFSVRML2(fileName);
	}	
#endif

	// we save the first frame
	char fFirstFrame[1024];
	sprintf(fFirstFrame, "%sFF.wrl", "fileName");
	myIFS.SaveIFSVRML2(fFirstFrame);


	FILE * stat = fopen( sFile , "a");
	FILE * out = fopen( fout, "wb");

	int numberOfFrames = myAnim.GetNKeyCoord();
	int nbrOfFramesPerSegment = params_.sizeAnimSeg_;
	if ( params_.sizeAnimSeg_ == -1) {
		nbrOfFramesPerSegment = numberOfFrames+1;
	}
	int nbrSegments = numberOfFrames/nbrOfFramesPerSegment;
	int sizeLastSegment = numberOfFrames%nbrOfFramesPerSegment;
	for (int s = 0; s < nbrSegments; s++) {
		Animation animSeg;
		myAnim.GetAnimationSegment(animSeg, myIFS, s*nbrOfFramesPerSegment, (s+1)*nbrOfFramesPerSegment -1);
		EncodeAU(animSeg, myIFS, out, stat);
	}
	if ( sizeLastSegment != 0) {
		Animation animSeg;
		myAnim.GetAnimationSegment(animSeg, myIFS, nbrSegments*nbrOfFramesPerSegment, numberOfFrames-1);
		EncodeAU(animSeg, myIFS, out, stat);
	}

	fclose(out);
	fclose(stat);
	return true;

}
