#include "IndexedFaceSet_E.h"


IndexedFaceSet_E::IndexedFaceSet_E(void)
{
}

IndexedFaceSet_E::~IndexedFaceSet_E(void)
{
}

bool IndexedFaceSet_E::Load_IFS_3DMC( std::vector<MeshFrame> &dmcMesh )
{
	FreeMem();

	std::vector<float> coord;
	std::vector<float> normal;
	std::vector<float> texCoord;
	std::vector<float> color;
	
	std::vector<int> coordIndex;
	std::vector<int> colorIndex;
	std::vector<int> normalIndex;
	std::vector<int> texCoordIndex;

	//for (int i=0; i<dmcMesh.size();i++)
	//{
		MP43DMC* mesh = dmcMesh[0].mesh;
		
		//get coordinates
		for ( int j=0; j<mesh->GetCoordinateCount(); j++)
			coord.push_back( mesh->GetCoordinate()[j]);
		//get normals
		//for ( int j=0; j<mesh->GetNormalCount(); j++)
		//	normal.push_back( mesh->GetNormal()[j]);
		//get texture coordinates
		//for ( int j=0; j<mesh->GetTextureCoordinateCount(); j++)
		//	texCoord.push_back( mesh->GetTextureCoordinate()[j]);
		//get colors
		//for ( int j=0; j<mesh->GetColorCount(); j++)
		//	color.push_back( mesh->GetColor()[j]);
		//get coordinate Indices
		for ( int j=0; j<mesh->GetCoordinateIndexCount(); j++)
			coordIndex.push_back( mesh->GetCoordinateIndex()[j]);
		//get normalIndices
		//for ( int j=0; j<mesh->GetNormalIndexCount(); j++)
		//	normalIndex.push_back( mesh->GetNormalIndex()[j]);
		//get texture coordinate Indices
		//for ( int j=0; j<mesh->GetTextureCoordinateIndexCount(); j++)
		//	texCoordIndex.push_back( mesh->GetTextureCoordinateIndex()[j]);
		//get coloe Indices
		//for ( int j=0; j<mesh->GetColorIndexCount(); j++)
		//	colorIndex.push_back( mesh->GetColorIndex()[j]);
	//}

	//filling the strucrure
	
	nCoord_ = (int) coord.size()/3;
	nCoordIndex_ = (int) coordIndex.size()/4;
	nNormal_ = (int) normal.size()/3;
	if (normalPerVertex_) {
		nNormalIndex_ = (int) normalIndex.size()/4;
	}
	else {
		nNormalIndex_ = (int) normalIndex.size();
	}
	nColor_ = (int) color.size()/3;
	if (colorPerVertex_) {
		nColorIndex_ = (int) colorIndex.size()/4;
	}
	else {
		nColorIndex_ = (int) colorIndex.size();
	}
	nTexCoord_ = (int) texCoord.size()/2;
	nTexCoordIndex_ = (int) texCoordIndex.size()/4;

	// coord
	coord_ = new float [3 * nCoord_];
	for (int v = 0; v < 3 * nCoord_; v++) {
		coord_[v] = coord[v];
	}
	
	// normal
	normal_ = new float [3 * nNormal_];
	for (int v = 0; v < 3 * nNormal_; v++) {
		normal_[v] = normal[v];
	}

	// color
	color_ = new float [3 * nColor_];
	for (int v = 0; v < 3 * nColor_; v++) {
		color_[v] = color[v];
	}

	// texCoord
	texCoord_ = new float [2 * nTexCoord_];
	for (int v = 0; v < 2 * nTexCoord_; v++) {
		texCoord_[v] = texCoord[v];
	}

	// fill coordIndex
	coordIndex_ = new int * [nCoordIndex_];
	int k=0;
	for (int p = 0; p < nCoordIndex_; p++) {
		coordIndex_[p] = new int[3];
		for (int h = 0; h <3; h++) {
			coordIndex_[p][h] = coordIndex[k];k++;
		}
		k++;
	}	

	// fill normalIndex
	normalIndex_ = new int * [nNormalIndex_];
	if (normalPerVertex_){
		k=0;
		for (int p = 0; p < nNormalIndex_; p++) {
			normalIndex_[p] = new int[3];
			for (int h = 0; h <3; h++) {
				normalIndex_[p][h] = normalIndex[k];k++;
			}
			k++;
		}
	}
	else {
		for (int p = 0; p < nNormalIndex_; p++) {
			normalIndex_[p] = new int[1];
			normalIndex_[p][0] = normalIndex[p];
		}	
	}

	// fill colorIndex
	colorIndex_ = new int * [nColorIndex_];
	if (colorPerVertex_){
		k=0;
		for (int p = 0; p < nColorIndex_; p++) {
			colorIndex_[p] = new int[3];
			for (int h = 0; h <3; h++) {
				colorIndex_[p][h] = colorIndex[k];k++;
			}
			k++;
		}	
	}
	else {
		for (int p = 0; p < nColorIndex_; p++) {
			colorIndex_[p] = new int[1];
			colorIndex_[p][0] = colorIndex[p];
		}
	}
	
	// fill texCoordIndex
	texCoordIndex_ = new int * [nTexCoordIndex_];
	k=0;
	for (int p = 0; p < nTexCoordIndex_; p++) {
		texCoordIndex_[p] = new int[3];
		for (int h = 0; h <3; h++) {
			texCoordIndex_[p][h] = texCoordIndex[k];k++;
		}
		k++;
	}	
	
	return true;
}

bool IndexedFaceSet_E::Load_IFS_Vectors( std::vector<float> coord, std::vector<float> normal, std::vector<float> color )
{
	int coff = coord.size() - 3 * nCoord_;
	int noff = normal.size() - 3 * nNormal_;
	int loff = color.size() - 3 * nColor_;

	// coord
	for (int v = 0; v < 3 * nCoord_; v++) {
		coord_[v] = coord[v + coff];
	}

	// normal
	for (int v = 0; v < 3 * nNormal_; v++) {
		normal_[v] = normal[v + noff];
	}

	// color
	for (int v = 0; v < 3 * nColor_; v++) {
		color_[v] = color[v + loff];
	}

	return true;
}
