#pragma once

class KMeans  
{
	int d_;				// the vectors dimension
	int n_;				// nbr of input vectors
	int k_;				// nbr clusters
	int NIter_;			// nbr of iteration for the minimization process
	float ** data_;		// the input data
	float ** centroids_;	// lusters centroides
	float * rmse_;		// the errors
	int * tags_;	// tags

public:

	int * partition_;	// the partition

	void Partition();
	void Initialize();
	KMeans(float ** data, int n, int d, int k, int NIter = 100);

	double GetMinDist(int & pos, int p);
	double GetMaxDist(int & pos, int k);
	double Dist(float * vect1, float * vect2);

	
	void UpdatePartition();
	void UpdateCentroids();


	double ComputeError();

	void OutputCentroids(char * fileName);
	void OutputPartition(char * fileName) ;

	virtual ~KMeans();

};

