/*!
 ************************************************************************
 *  \file
 *     gVertex.cpp
 *  \brief
 *     gVertex class.
 *  \author
 *     Copyright (C) 2007  ARTEMIS Department INT/GET, Paris, France.
 *
 *     Khaled MAMOU               <khaled.mamou@int-evry.fr>
 *
 *	   Institut National des Telecommunications		tel.: +33 (0)1 60 76 40 94
 *     9, Rue Charles Fourier,						fax.: +33 (0)1 60 76 43 81
 *     91011 Evry Cedex France
 *
 ************************************************************************
 */

#include "gVertex.h"
#include "Console.h"

extern CConsole logger;
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

gVertex::gVertex()
{
	name_ = -1;
	cc_ = -1;
	error_ = 0.0;

}

gVertex::~gVertex()
{
}

int gVertex::AddEdge(int name)
{
	
	int found = 0;
	std::vector<int>::iterator it = edges_.begin();
	while (  it != edges_.end()) {
		if ( *it == name) {
			found = 1;
			return -1;
		}
		it++;
	}
	edges_.push_back(name);
	return 0;
}

int gVertex::DelEdge(int name)
{
	
	std::vector<int>::iterator it = edges_.begin();
	while (  it != edges_.end()) {
		if ( *it == name) {
			edges_.erase(it);
			return 0;
		}
		it++;
	}
	return -1;
}




void gVertex::Info()
{
	logger.write_2_log("%i, n = %i P(", name_, ancestors_.size());

	logger.write_2_log("E(");
	for (std::vector<int>::iterator pos1 = edges_.begin(); pos1 != edges_.end(); ++pos1) {
		logger.write_2_log("%i, ", *pos1);
    }
	logger.write_2_log(")");

	logger.write_2_log("A(");
	for (std::vector<int>::iterator pos1 = ancestors_.begin(); pos1 != ancestors_.end(); ++pos1) {
		logger.write_2_log("%i, ", *pos1);
    }
	logger.write_2_log(")");
	
}