#ifndef _DECODEMP4STREAMS_H_
#define _DECODEMP4STREAMS_H_


/******************************************************************************\
* Includes
\******************************************************************************/


#include <stdio.h>
#include <tchar.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>
#include <vector>


#include "MP43DMC.h"
#include "MP4Animation.h"



/******************************************************************************\
* Defines
\******************************************************************************/
// maximum size of BBA buffer
#define	BBABUFERSIZE 10000000


/******************************************************************************\
* Class DecodeMP4Streams
\******************************************************************************/
class DecodeMP4Streams
{
	public:

	DecodeMP4Streams(void);
	~DecodeMP4Streams(void);

	//methods
	
	//DMCbuff is the 3dmc stream from the mp4 file
	void Decode3DMCStream( char* DMCbuff, int DMCbuffSize );
	//return 3DMC decoded data in MP43DMC class
	MP43DMC* GetDecoded3DMC(){return m_p3DMC;}
	//Animbuff is the BBA stream from the mp4 file
	void DecodeBBAStream( unsigned char* Animbuff, int AnimbuffSize );
	//return BBA decoded data in MP4AnimationBuff class
	MP4AnimationBuff * GetDecodedBBA(){return m_panimation;}
	//textbuff is the texture (jp2) stream from the mp4 file
	int DecodeTextureStream( char* textbuff, int textbuffSize );
	//return texure decoded data in buff
	// If alloc is true, the buffer is allocated inside the function
	// If alloc is false, the buffer should be allocated before calling the function
	void GetDecodedTexture( unsigned char* &buff, int &buffSize, bool alloc = true );
	//buff is the binary xml from the mp4 file
	void DecodeXMLStream( unsigned char* buff, int buffSize );
	//return decoded xml from the mp4 file
	// If alloc is true, the buffer is allocated inside the function
	// If alloc is false, the buffer should be allocated before calling the function
	void GetDecodedXML(unsigned char* &buff, int &buffSize, bool alloc = true );
	//DMCbuff is the 3dmc stream from the mp4 file
	void DecodeFAMCStream( char* FAMCbuff, int FAMCbuffSize, std::vector<MeshFrame> &meshVec );
	//return 3DMC decoded data in MP43DMC class
	//void (std::vector<MeshFrame>*) GetDecoded3DMC(){return m_pFAMC;}
	//Animbuff is the BBA stream from the mp4 file

private:

	//variables
	bool Decode_OK;
	MP4AnimationBuff * m_panimation;
	MP43DMC* m_p3DMC;
	std::vector<MeshFrame>* m_pFAMC;
	unsigned char* m_ptextBuff;
	int m_textBuffSize;

};

















#endif //_DECODEMP4STREAMS_H_