#include "MPG_IfsQ_E_Ifs.h"


/******************************************************************************\
 MPG_IfsQ_E_Ifs.cpp.cpp: implementation of the MPG_IfsQ_E_Ifs class:
\******************************************************************************/


/******************************************************************************\
* Class MPG_IfsQ_E_Ifs
\******************************************************************************/

MPG_IfsQ_E_Ifs::MPG_IfsQ_E_Ifs(void)
{
}

MPG_IfsQ_E_Ifs::~MPG_IfsQ_E_Ifs(void)
{
}

//struct indexInfomation
//{
//	int *index;
//	int indexoffset;
//}*indexInfo;

void MPG_IfsQ_E_Ifs::stitchAnalysis()
{
	int start = 0;
	int mapCnt = 0;
	//	for(int i = 0; i < numOfvertexStitching; i++)
	//	{
	while(start<vertexStitch.size())
	{
		int min = vertexStitch[start];
		int j;
		for(j = start+1; vertexStitch[j] != -1; j++)
		{	if (min > vertexStitch[j]) min = vertexStitch[j]; }

		for(j = start; vertexStitch[j] != -1; j++)
		{
			int temp = vertexStitch[j];
			if (vertexStitch[j] != min)
			{
				stitchChangeList.push_back(min);
				stitchDellist.push_back(vertexStitch[j]);
			}
		}		
		start = j+1;
	}
}

int MPG_IfsQ_E_Ifs::apply3DMCExtension()
{
	if ( !vertex_order_flag || !face_order_flag )
		return 0;

	//if ( vertexStitch.size() == 0 )
	//	return 0;

	vector<float>              tCoord;
	vector<int>                tCoordIndex;

	vector<float>              tNormal;
	vector<int>                tNormalIndex;

	vector<float>              tColor;
	vector<int>                tColorIndex;

	vector<float>              tTexCoord;
	vector<int>                tTexCoordIndex;

	stitchAnalysis();

	int j;
	//~dmlab

	vector<float>& coord           = getCoord();
	vector<int>&   coordIndex      = getCoordIndex();

	// dmlab vertax order reconstruct array
	int *qVertexReArray = NULL;
	if (qVertexIndex.size())
	{  
		qVertexReArray = new int[qVertexIndex.size()];
		for(j = 0; j < qVertexIndex.size(); j++)
			qVertexReArray[j] = 0;
		for(j = 0; j < qVertexIndex.size(); j++)
		{
			qVertexReArray[qVertexIndex[j]] = j;
			// printf("%d  ", qVertexIndex[j]);
		}
	}

	// ~dmlab (sinwook 060405)
	// dmlab face order reconstruct array
	int *qFaceReArray = NULL;
	int *vmap=NULL;
	if (qFaceIndex.size())
	{
		qFaceReArray = new int[qFaceIndex.size()];
		for(j = 0; j < qFaceIndex.size(); j++)
			qFaceReArray[j] = 0;
		for(j = 0; j < qFaceIndex.size(); j++)
		{
			qFaceReArray[qFaceIndex[j]] = j;
		}

		vmap = new int[qFaceIndex.size()];
		int ory_cnt=0;
		for(j=0;j<coordIndex.size();j++)
			if(j==0 || coordIndex[j-1]==-1)
				vmap[qFaceIndex[ory_cnt++]]=j;
	}

	{
		int i;
		bool iswrite = true;
		if(qVertexIndex.size())
		{
			for(i=0;i<coord.size();i++)
			{
				int vertexOffset = qVertexReArray[i/3]*3+(i%3);
				// dmlab stitch process _ lsw 
				for(int j = 0; j < stitchDellist.size(); j++)
					if ((i/3) == stitchDellist[j]) 
					{
						iswrite = false;					
						break;
					}
				if (iswrite)
					tCoord.push_back(coord[vertexOffset]);
				iswrite = true;
				//~dmlab stitch process _ lsw 
			}
		}
		else
		{
			for(i=0;i<coord.size();i++)
			{
				// dmlab stitch process _ lsw 
				for(int j = 0; j < stitchDellist.size(); j++)
					if ((i/3) == stitchDellist[j])
					{
						iswrite = false;
						break;
					}

				if (iswrite) 
					tCoord.push_back(coord[i]);
				iswrite = true;
				//~dmlab stitch process _ lsw 
			}
		}

		if(qFaceIndex.size())
		{
			if(qVertexIndex.size())
			{
				for(i=0;i<qFaceIndex.size();i++)
				{
					for(int j=vmap[i];j<coordIndex.size();j++)
					{
						if(coordIndex[j]==-1)
						{
							tCoordIndex.push_back(-1);
							break;
						}
						else
						{
							// dmlab stitch process _ lsw 
							int q = 0;
							for(; q < stitchDellist.size(); q++)
							{
								if (qVertexIndex[coordIndex[j]] == stitchDellist[q])
									break;
							}
							if (q == stitchDellist.size())
								tCoordIndex.push_back(qVertexIndex[coordIndex[j]]);
							else tCoordIndex.push_back(stitchChangeList[q]);
							//~dmlab stitch process _ lsw 
						}
					}
				}
			}
			else
			{
				for(i=0;i<qFaceIndex.size();i++)
				{
					for(int j=vmap[i];j<coordIndex.size();j++)
					{
						if(coordIndex[j]==-1)
						{
							tCoordIndex.push_back(-1);
							break;
						}
						else
						{
							// dmlab stitch process _ lsw 
							int q = 0;
							for(; q < stitchDellist.size(); q++)
							{
								if (coordIndex[j] == stitchDellist[q])
								{
									int t = coordIndex[j];
									break;
								}
							}
							if (q == stitchDellist.size())
							{
								if(q!=0)
								{
									int dellistIndex = 0;
									while(coordIndex[j] > stitchDellist[dellistIndex])
									{
										int temp = coordIndex[j];
										dellistIndex++;
									}
									tCoordIndex.push_back(coordIndex[j] - dellistIndex);
								}
								else
									tCoordIndex.push_back(coordIndex[j]);
							}
							else tCoordIndex.push_back(stitchChangeList[q]);
							//~dmlab stitch process _ lsw 
						}
					}
				}
			}
		}
		else if(qVertexIndex.size())
		{
			for(i=0;i<coordIndex.size();i++)
			{
				if(coordIndex[i]==-1)
				{
					tCoordIndex.push_back(-1);
				}
				else
				{
					// dmlab stitch process _ lsw 
					int q = 0;
					for(; q < stitchDellist.size(); q++)
					{
						if (qVertexIndex[coordIndex[i]] == stitchDellist[q])
							break;
					}
					if (q == stitchDellist.size())
					{
						tCoordIndex.push_back(qVertexIndex[coordIndex[i]]);
					}
					else
					{
						tCoordIndex.push_back(stitchChangeList[q]);
					}
					//~dmlab stitch process _ lsw 
				}
			}
		}
		else
		{
			for(i=0;i<coordIndex.size();i++)
			{
				if(coordIndex[i]==-1) 
					tCoordIndex.push_back(-1);
				else 
				{
					// dmlab stitch process _ lsw 
					int q = 0;
					for(; q < stitchDellist.size(); q++)
					{
						if (coordIndex[i] == stitchDellist[q])
							break;
					}
					if (q == stitchDellist.size())
					{					
						if(q!=0)
						{
							int dellistIndex = 0;
							for(int dm = 0; dm < stitchDellist.size(); dm++)
							{
								if (coordIndex[i] > stitchDellist[dm])
									dellistIndex++;
							}
							tCoordIndex.push_back(coordIndex[i] - dellistIndex);
						}
						else
							tCoordIndex.push_back(coordIndex[i]);

					}
					else 					
					{
						int dellistIndex = 0;
						for(int dm = 0; dm < stitchDellist.size(); dm++)
						{
							if (stitchChangeList[q] > stitchDellist[dm] )
								dellistIndex++;
						}
						tCoordIndex.push_back(stitchChangeList[q]-dellistIndex);		
					}
					//~dmlab stitch process _ lsw 
				}
			}
		}
		//DMLAB ~ory
	}

	bool           colorPerVertex  = getColorPerVertex();
	vector<float>& color           = getColor();
	vector<int>&   colorIndex      = getColorIndex();
	//DMLAB ory color VO FO 2006 06
	MPG_Binding	 colorbinding	 = getColorBinding();

	if(color.size()>0)
	{
		if(qFaceIndex.size() && colorbinding==PB_PER_FACE)
		{
			for(int i=0;i<qFaceIndex.size();i++)
			{
				int indx=qFaceReArray[i]*3;
				float ci1 = color[indx], ci2 = color[indx+1], ci3 = color[indx+2];
				if(ci1<0.0) ci1=0.0;if(ci1>1.0) ci1=1.0;
				if(ci2<0.0) ci2=0.0;if(ci2>1.0) ci2=1.0;
				if(ci3<0.0) ci3=0.0;if(ci3>1.0) ci3=1.0;
				tColor.push_back(ci1);
				tColor.push_back(ci2);
				tColor.push_back(ci3);
			}
		}
		else if(qVertexIndex.size() && colorbinding==PB_PER_VERTEX)
		{
			for(int i=0;i<qVertexIndex.size();i++)
			{
				int indx=qVertexReArray[i]*3;
				float ci1 = color[indx], ci2 = color[indx+1], ci3 = color[indx+2];
				if(ci1<0.0) ci1=0.0;if(ci1>1.0) ci1=1.0;
				if(ci2<0.0) ci2=0.0;if(ci2>1.0) ci2=1.0;
				if(ci3<0.0) ci3=0.0;if(ci3>1.0) ci3=1.0;
				int exist = 0;
				for(int k = 0; k < stitchDellist.size(); k++)
					if (stitchDellist[k] == qVertexReArray[i])
						exist = 1;
				if (!exist)
				{
					tColor.push_back(ci1);
					tColor.push_back(ci2);
					tColor.push_back(ci3);
				}
			}
		}
		else
		{
			for(int i=0;i<color.size();i++)
			{
				float ci = color[i];
				if(ci<0.0) ci=0.0;
				if(ci>1.0) ci=1.0;
				int exist = 0;
				if (stitchDellist.size() && colorbinding == PB_PER_VERTEX)
					for(int k = 0; k < stitchDellist.size(); k++)
						if (i - (stitchDellist[k]*3) < 3 && i - (stitchDellist[k]*3) >= 0)
							exist = 1;
				if (!exist)
					tColor.push_back(ci);
			}
		}

		if(colorbinding==PB_PER_CORNER)
		{
			if(qFaceIndex.size())
			{
				for(int i=0;i<qFaceIndex.size();i++)
				{ 
					for(int j=vmap[i];j<colorIndex.size();j++)
					{
						if(colorIndex[j]==-1)
						{
							tColorIndex.push_back(-1);
							break;
						}
						else
							tColorIndex.push_back(colorIndex[j]);
					}
				}
			}
			else
			{
				for(int i=0;i<colorIndex.size();i++)
				{
					tColorIndex.push_back(colorIndex[i]);
				}
			}
		}
	}

	bool           normalPerVertex = getNormalPerVertex();
	vector<float>& normal          = getNormal();
	vector<int>&   normalIndex     = getNormalIndex();
	//DMLAB ory normal VO FO 2006 06
	MPG_Binding	 normalbinding	 = getNormalBinding();

	if(normal.size()>0)
	{
		if(qFaceIndex.size() && normalbinding==PB_PER_FACE)
		{
			for(int i=0;i<qFaceIndex.size();i++)
			{
				int indx=qFaceReArray[i]*3;
				float ci1 = normal[indx], ci2 = normal[indx+1], ci3 = normal[indx+2];
				if(ci1<-1.0) ci1=-1.0;if(ci1>1.0) ci1=1.0;
				if(ci2<-1.0) ci2=-1.0;if(ci2>1.0) ci2=1.0;
				if(ci3<-1.0) ci3=-1.0;if(ci3>1.0) ci3=1.0;
				tNormal.push_back(ci1);
				tNormal.push_back(ci2);
				tNormal.push_back(ci3);
			}
		}
		else if(qVertexIndex.size() && normalbinding==PB_PER_VERTEX)
		{
			for(int i=0;i<qVertexIndex.size();i++)
			{
				int indx=qVertexReArray[i]*3;
				float ci1 = normal[indx], ci2 = normal[indx+1], ci3 = normal[indx+2];
				if(ci1<-1.0) ci1=-1.0;if(ci1>1.0) ci1=1.0;
				if(ci2<-1.0) ci2=-1.0;if(ci2>1.0) ci2=1.0;
				if(ci3<-1.0) ci3=-1.0;if(ci3>1.0) ci3=1.0;
				int exist = 0;
				for(int k = 0; k < stitchDellist.size(); k++)
					if (stitchDellist[k] == qVertexReArray[i])
						exist = 1;
				if (!exist)
				{
					tNormal.push_back(ci1);
					tNormal.push_back(ci2);
					tNormal.push_back(ci3);
				}
			}
		}
		else
		{
			for(int i=0;i<normal.size();i++)
			{
				float ci = normal[i]; //qVertexReArray[i/3]*3+(i%3)];
				if(ci<-1.0) ci=-1.0;
				if(ci>1.0) ci=1.0;
				int exist = 0;
				if (stitchDellist.size() && normalbinding == PB_PER_VERTEX)
					for(int k = 0; k < stitchDellist.size(); k++)
						if (i - (stitchDellist[k]*3) < 3 && i - (stitchDellist[k]*3) >= 0)
							exist = 1;
				if (!exist)
					tNormal.push_back(ci);
			}
		}

		if(normalbinding==PB_PER_CORNER)
		{
			if(qFaceIndex.size())
			{
				for(int i=0;i<qFaceIndex.size();i++)
				{
					for(int j=vmap[i];j<normalIndex.size();j++)
					{
						if(normalIndex[j]==-1)
						{
							tNormalIndex.push_back(-1);
							break;
						}
						else
						{
							int t = normalIndex[j];
							tNormalIndex.push_back(normalIndex[j]);
						}
					}
				}			
			}
			else
			{
				for(int i=0;i<normalIndex.size();i++)
				{
					int t = normalIndex[i];
					tNormalIndex.push_back(normalIndex[i]);
				}
			}
		}
	}

	vector<float>& texCoord        = getTexCoord();
	vector<int>&   texCoordIndex   = getTexCoordIndex();
	//DMLAB ory tc VO FO 2006 06
	MPG_Binding	 texcoordbinding	 = getTexCoordBinding();

	if(texCoord.size()>0)
	{
		if(texcoordbinding==PB_PER_VERTEX && qVertexIndex.size())
		{
			for(int i=0;i<qVertexIndex.size();i++)
			{
				int indx=qVertexReArray[i]*2;
				float ci1 = texCoord[indx], ci2 = texCoord[indx+1];
				int exist = 0;
				for(int k = 0; k < stitchDellist.size(); k++)
					if (stitchDellist[k] == qVertexReArray[i])
						exist = 1;
				if (!exist)
				{
					tTexCoord.push_back(ci1);
					tTexCoord.push_back(ci2);
				}
			}
		}
		else
		{
			for(int i=0;i<texCoord.size();i++)
			{
				int exist = 0;
				if (stitchDellist.size() && texcoordbinding == PB_PER_VERTEX)
					for(int k = 0; k < stitchDellist.size(); k++)
						if (i - (stitchDellist[k]*2) < 2 && i - (stitchDellist[k]*2) >= 0)
							exist = 1;
				if (!exist)
					tTexCoord.push_back(texCoord[i]);
			}
		}


		if(texcoordbinding==PB_PER_CORNER)
		{
			if(qFaceIndex.size())
			{
				for(int i=0;i<qFaceIndex.size();i++)
				{
					for(int j=vmap[i];j<texCoordIndex.size();j++)
					{
						if(texCoordIndex[j]==-1)
						{
							tTexCoordIndex.push_back(-1);
							break;
						}
						else
							tTexCoordIndex.push_back(texCoordIndex[j]);
					}
				}
			}
			else
			{
				for(int i=0;i<texCoordIndex.size();i++)
				{
					tTexCoordIndex.push_back(texCoordIndex[i]);
				}
			}
		}
	}

	_coord			= tCoord;
	_coordIndex		= tCoordIndex;
	_normal			= tNormal;
	_normalIndex	= tNormalIndex;
	_texCoord		= tTexCoord;
	_texCoordIndex	= tTexCoordIndex;
	_color			= tColor;
	_colorIndex		= tColorIndex;

	delete[] qVertexReArray;
	delete[] qFaceReArray;
	delete[] vmap;

	qVertexIndex.clear();
	qFaceIndex.clear();
	return 0;
}
