/******************************************************************************\
* Includes
\******************************************************************************/
#include "EncodeMP4Streams.h"

#include "BBA_Encoder_Lib.h"
#include "mpg_ifsq_c_ifs.h"
#include "zlib.h"
#include "jasper/jasper.h"

#include "encoder/CI/CompressedCoordinateInterpolator.h" 
#include "encoder/PI/POSENCODER_PDAM.h" 
#include "encoder/OI/main.h" 

#include "FAMCParams.h"
#include "FAMCEncoder_E.h"


/******************************************************************************\
 EncodeMP4Streams.cpp: implementation of the EncodeMP4Streams class:
\******************************************************************************/


/******************************************************************************\
* Class EncodeMP4Streams
\******************************************************************************/
EncodeMP4Streams::EncodeMP4Streams( CMDArguments* cmd )
{
	Encode_OK		= 0;
	m_panimation	= NULL;
	m_pAnimbuff		= NULL;
	m_AnimbuffSize	= 0;
	m_AnimID		= -1;
	m_pAnimFileId	= NULL;
	m_p3DMC			= NULL;
	m_3DMCbuffSize	= 0;
	m_3DMCID		= -1;
	m_p3DMCbuff		= NULL;
	m_p3DMCFileId	= NULL;
	m_BinBuffSize	= 0;
	m_pBinBuff		= NULL;
	m_jpgBuffSize	= 0;
	m_pjpgBuff		= NULL;
	m_pAnimbuffOUT	= NULL;	
	m_AnimbuffSizeOUT = 0;

	//coding parametars
	
	m_params = cmd;

	 /*m_dmc_bitsPerCoord				= cmd->m_dmc_bitsPerCoord;
	 m_dmc_bitsPerNormal			= cmd->m_dmc_bitsPerNormal ;
	 m_dmc_bitsPerColor				= cmd->m_dmc_bitsPerColor;
	 m_dmc_bitsPerTexCoord			= cmd->m_dmc_bitsPerTexCoord ;
	 m_dmc_img_flag					= cmd->m_dmc_img_flag ;
	 m_dmc_img_u					= cmd->m_dmc_img_u ;
	 m_dmc_img_v					= cmd->m_dmc_img_v ;
	 m_dmc_coordPrediction			= cmd->m_dmc_coordPrediction  ;
	 m_dmc_normalPrediction			= cmd->m_dmc_normalPrediction ;
	 m_dmc_colorPrediction			= cmd->m_dmc_colorPrediction  ;
	 m_dmc_texCoordPrediction		= cmd->m_dmc_texCoordPrediction ;
	 m_dmc_erMode					= cmd->m_dmc_erMode;          
	 m_dmc_packetSize				= cmd->m_dmc_packetSize;
	 m_dmc_boundaryPrediction		= cmd->m_dmc_boundaryPrediction;
	 m_dmc_hierarchicalMode			= cmd->m_dmc_hierarchicalMode ;
	 m_dmc_saveClsFile				= cmd->m_dmc_saveClsFile ;
	 m_dmc_saveWrlLevels			= cmd->m_dmc_saveWrlLevels ;
	 m_dmc_vertex_order_flag		= cmd->m_dmc_vertex_order_flag ;
	 m_dmc_face_order_flag			= cmd->m_dmc_face_order_flag  ;
	 m_dmc_face_order_per_CC_flag	= cmd->m_dmc_face_order_per_CC_flag ;
	 m_dmc_vertex_order_per_CC_flag = cmd->m_dmc_vertex_order_per_CC_flag ;

	 m_bba_automatic	= cmd->m_bba_automatic ;
	 m_bba_P_frames		= cmd->m_bba_P_frames ;
	 m_bba_coding_type	= cmd->m_bba_coding_type ;
	 m_bba_p2q			= cmd->m_bba_p2q;
	 m_bba_qs			= cmd->m_bba_qs ;
	
	 m_famc_sizeAnimSeg		= cmd->m_famc_sizeAnimSeg ;
	 m_famc_transformType	= cmd->m_famc_transformType ;
	 m_famc_globalRMSE		= cmd->m_famc_globalRMSE ;
	 m_famc_ratioWeights	= cmd->m_famc_ratioWeights;
	 m_famc_qAT				= cmd->m_famc_qAT ;
	 m_famc_qCoord			= cmd->m_famc_qCoord ;
	 m_famc_qNormal			= cmd->m_famc_qNormal ;
	 m_famc_qColor			= cmd->m_famc_qColor ;
	 m_famc_qOther			= cmd->m_famc_qOther;
	 m_famc_LD_auto			= cmd->m_famc_LD_auto ;
	 m_famc_LD_L			= cmd->m_famc_LD_L ;
	 m_famc_LD_l			= cmd->m_famc_LD_l;
	 m_famc_LD_P			= cmd->m_famc_LD_P ;
	 m_famc_LD_B			= cmd->m_famc_LD_B;
	 m_famc_LD_Pred			= cmd->m_famc_LD_Pred ;
	 m_famc_SNR_L			= cmd->m_famc_SNR_L ;
	 m_famc_SNR_l			= cmd->m_famc_SNR_l ;
	 m_famc_Normal_Pred		= cmd->m_famc_Normal_Pred;*/

}


EncodeMP4Streams::~EncodeMP4Streams(void)
{
	if ( m_pAnimbuff )
		free( m_pAnimbuff );
	if ( m_pAnimbuffOUT )
		free( m_pAnimbuffOUT );
	if ( m_p3DMCbuff )
		free( m_p3DMCbuff );
	if ( m_pBinBuff )
		free( m_pBinBuff );
	if ( m_pjpgBuff )
		free( m_pjpgBuff );
}
int EncodeMP4Streams::EncodeTextureStream( char* file_name)
{
	
	//  add  jasper......


	jas_stream_t *in, *out;

	if (jas_init()) {
		return -1;
	}

	in = jas_stream_fopen( file_name , "rb" );

	jas_image_t *image;

	int infmt =jas_image_getfmt(in);
	char *inopts = NULL;
	image = jas_image_decode(in, infmt, inopts);
	jas_stream_close(in);

	int numcmpts = jas_image_numcmpts(image);

	{
		jas_image_t *newimage;
		jas_cmprof_t *outprof;
		outprof = jas_cmprof_createfromclrspc(JAS_CLRSPC_SRGB);
		newimage = jas_image_chclrspc(image, outprof, JAS_CMXFORM_INTENT_PER);
		jas_image_destroy(image);
		jas_cmprof_destroy(outprof);
		image = newimage;
	}

	out = jas_stream_memopen( NULL, 0 );

	int outfmt = jas_image_strtofmt( "jp2" );
	char outopts = '\0';
	jas_image_encode( image, out, outfmt, &outopts );
	jas_stream_flush(out);

	m_jpgBuffSize = jas_stream_length( out );
	m_pjpgBuff = ( char* ) malloc( m_jpgBuffSize );
	jas_stream_rewind( out );
	jas_stream_read( out, m_pjpgBuff, m_jpgBuffSize );

	jas_stream_close(out);
	

	jas_image_destroy(image);
	jas_cleanup();

	

}

bool EncodeMP4Streams::GetEncodedTexture(char *&buff, int &size, bool alloc)
{
	if (alloc)
		buff = (char*) malloc (m_jpgBuffSize);
	memcpy( buff, m_pjpgBuff, m_jpgBuffSize );
	size = m_jpgBuffSize;

	return true;
}


void EncodeMP4Streams::EncodeBBAStream( MP4AnimationBuff * animation )
{
	Encode_OK = true;
	m_AnimbuffSize = 0;
	m_pAnimbuff = NULL;
	m_AnimbuffSizeOUT = 0;
	m_pAnimbuffOUT = NULL;
	m_panimation = animation;
	Encode_OK = MakeTextualBBA();
	Encode_OK = encodeBBA();
	free( m_pAnimbuff );
	m_pAnimbuff = NULL;
}

bool EncodeMP4Streams::MakeTextualBBA()
{
	MP4Frames* frame = NULL;
	m_pAnimbuff = ( char*) malloc ( BBABUFERSIZE );
	MakeTextualBBAHeader ( );
	for (int i=0; i<m_panimation->GetMP4FramesCount();i++)
	{
		frame = m_panimation->GetMP4Frame( i );
		MakeTextualBBAFrame( frame );
	}
	m_AnimbuffSize = strlen( m_pAnimbuff ) + 1 ;

	return true;
}


void EncodeMP4Streams::MakeTextualBBAHeader()
{
	sprintf( m_pAnimbuff, "header 2.0 25\n"  );
}

void EncodeMP4Streams::MakeTextualBBAFrame( MP4Frames* frame)
{
	char tmpc[1000];
	

	// 0 bones number of bones

	tmpc[0] = 0;
	sprintf( tmpc, "%s0 1 %d ", tmpc, frame->GetMP4BoneDataCount()  );	
	strcat(m_pAnimbuff, tmpc);

	for (int i=0; i<frame->GetMP4BoneDataCount();i++)
	{
		//boneID
		tmpc[0] = 0;
		sprintf( tmpc, "%s   %d", tmpc, i );
		strcat(m_pAnimbuff, tmpc);
		//put mask
		tmpc[0] = 0;
		if (frame->GetMP4BoneData(i)->GetHasCenter())
		{
			sprintf( tmpc, "%s %d", tmpc, 1 );
			sprintf( tmpc, "%s %d", tmpc, 1 );
			sprintf( tmpc, "%s %d", tmpc, 1 );
			sprintf( tmpc, "%s %d", tmpc, 1 );
		}
		else 
			sprintf( tmpc, "%s %d", tmpc, 0 );
		strcat(m_pAnimbuff, tmpc);

		tmpc[0] = 0;
		if (frame->GetMP4BoneData(i)->GetHasRotation())
		{
			
			sprintf( tmpc, "%s %d", tmpc, 1 );
			if (frame->GetMP4BoneData(i)->GetIsQuaternion())
			{
				sprintf( tmpc, "%s %d", tmpc, 1 );
				sprintf( tmpc, "%s %d", tmpc, 1 );
				sprintf( tmpc, "%s %d", tmpc, 1 );
				sprintf( tmpc, "%s %d", tmpc, 1 );
				sprintf( tmpc, "%s %d", tmpc, 1 );
			}
			else
			{
				sprintf( tmpc, "%s %d", tmpc, 0 );
				sprintf( tmpc, "%s %d", tmpc, 1 );
				sprintf( tmpc, "%s %d", tmpc, 1 );
				sprintf( tmpc, "%s %d", tmpc, 1 );
			}			
		}
		else 
			sprintf( tmpc, "%s %d", tmpc, 0 );
		strcat(m_pAnimbuff, tmpc);

		tmpc[0] = 0;
		if (frame->GetMP4BoneData(i)->GetHasScale())
		{		
			sprintf( tmpc, "%s %d", tmpc, 1 );
			sprintf( tmpc, "%s %d", tmpc, 1 );
			sprintf( tmpc, "%s %d", tmpc, 1 );
			sprintf( tmpc, "%s %d", tmpc, 1 );
		}
		else 
			sprintf( tmpc, "%s %d", tmpc, 0 );
		strcat(m_pAnimbuff, tmpc);

		tmpc[0] = 0;
		if (frame->GetMP4BoneData(i)->GetHasScaleOrientation())
		{		
				sprintf( tmpc, "%s %d", tmpc, 1 );
				sprintf( tmpc, "%s %d", tmpc, 1 );
				sprintf( tmpc, "%s %d", tmpc, 1 );
				sprintf( tmpc, "%s %d", tmpc, 1 );
				sprintf( tmpc, "%s %d", tmpc, 1 );
		}
		else 
			sprintf( tmpc, "%s %d", tmpc, 0 );
		strcat(m_pAnimbuff, tmpc);
		
		tmpc[0] = 0;
		if (frame->GetMP4BoneData(i)->GetHasTranslation())
		{		
			sprintf( tmpc, "%s %d", tmpc, 1 );
			sprintf( tmpc, "%s %d", tmpc, 1 );
			sprintf( tmpc, "%s %d", tmpc, 1 );
			sprintf( tmpc, "%s %d", tmpc, 1 );
		}
		else 
			sprintf( tmpc, "%s %d", tmpc, 0 );
		strcat(m_pAnimbuff, tmpc);
		
	}

	tmpc[0] = 0;
	sprintf( tmpc, "%s\n", tmpc );
	strcat(m_pAnimbuff, tmpc);
	

	//put Data
	for (int i=0; i<frame->GetMP4BoneDataCount();i++)
	{
		int tmp = 0;
		Vec3f tr;
		Vec4f qv;

		tmpc[0] = 0;
		if (frame->GetMP4BoneData(i)->GetHasCenter())
		{
			frame->GetMP4BoneData(i)->GetCenter( tr );
			tmp = tr.x * 100 ;
			sprintf( tmpc, "%s %d", tmpc, tmp );
			tmp = tr.y * 100 ;
			sprintf( tmpc, "%s %d", tmpc, tmp );
			tmp = tr.z * 100 ;
			sprintf( tmpc, "%s %d", tmpc, tmp );
		}
		strcat(m_pAnimbuff, tmpc);
		
		tmpc[0] = 0;
		if (frame->GetMP4BoneData(i)->GetHasRotation())
		{
			frame->GetMP4BoneData(i)->GetRotation( qv );
			if (frame->GetMP4BoneData(i)->GetIsQuaternion())
			{
				
				tmp = qv.x * 100000 ;
				sprintf( tmpc, "%s %d", tmpc, tmp );
				tmp = qv.y * 100000 ;
				sprintf( tmpc, "%s %d", tmpc, tmp );
				tmp = qv.z * 100000 ;
				sprintf( tmpc, "%s %d", tmpc, tmp );
				tmp = qv.q * 100000 ;
				sprintf( tmpc, "%s %d", tmpc, tmp );
			}
			else
			{
				tmp = qv.x * 100000 ;
				sprintf( tmpc, "%s %d", tmpc, tmp );
				tmp = qv.y * 100000 ;
				sprintf( tmpc, "%s %d", tmpc, tmp );
				tmp = qv.z * 100000 ;
				sprintf( tmpc, "%s %d", tmpc, tmp );
				
			}
		}
		strcat(m_pAnimbuff, tmpc);

		tmpc[0] = 0;
		if (frame->GetMP4BoneData(i)->GetHasScale())
		{
			frame->GetMP4BoneData(i)->GetScale( tr );
			tmp = tr.x * 10000 ;
			sprintf( tmpc, "%s %d", tmpc, tmp );
			tmp = tr.y * 10000 ;
			sprintf( tmpc, "%s %d", tmpc, tmp );
			tmp = tr.z * 10000 ;
			sprintf( tmpc, "%s %d", tmpc, tmp );
		}
		strcat(m_pAnimbuff, tmpc);

		tmpc[0] = 0;
		if (frame->GetMP4BoneData(i)->GetHasScaleOrientation())
		{
			frame->GetMP4BoneData(i)->GetscaleOrienttion( qv );
			tmp = qv.x * 100000 ;
			sprintf( tmpc, "%s %d", tmpc, tmp );
			tmp = qv.y * 100000 ;
			sprintf( tmpc, "%s %d", tmpc, tmp );
			tmp = qv.z * 100000 ;
			sprintf( tmpc, "%s %d", tmpc, tmp );
			tmp = qv.q * 100000 ;
			sprintf( tmpc, "%s %d", tmpc, tmp );

		}
		strcat(m_pAnimbuff, tmpc);

		tmpc[0] = 0;
		if (frame->GetMP4BoneData(i)->GetHasTranslation())
		{
			frame->GetMP4BoneData(i)->GetTranslation( tr );
			tmp = tr.x * 100 ;
			sprintf( tmpc, "%s %d", tmpc, tmp );
			tmp = tr.y * 100 ;
			sprintf( tmpc, "%s %d", tmpc, tmp );
			tmp = tr.z * 100 ;
			sprintf( tmpc, "%s %d", tmpc, tmp );
		}
		strcat(m_pAnimbuff, tmpc);
	}

	tmpc[0] = 0;
	sprintf( tmpc, "%s\n", tmpc );
	strcat(m_pAnimbuff, tmpc);
	
}

bool EncodeMP4Streams::encodeBBA()
{
	m_pAnimbuffOUT = (unsigned char *)malloc ( BBABUFERSIZE );
	//EncodeFromBufferIN(true,0,0,0,2,7,m_pAnimbuff,m_AnimbuffSize , m_pAnimbuffOUT,m_AnimbuffSizeOUT,0,false,0,0,3,false);
	//EncodeFromBufferIN(true,0,0,1,6,7,m_pAnimbuff,m_AnimbuffSize , m_pAnimbuffOUT,m_AnimbuffSizeOUT,0,true,0,0,3, false);
	EncodeFromBufferIN( true, m_params->m_bba_automatic, m_params->m_bba_P_frames, m_params->m_bba_coding_type, m_params->m_bba_p2q, m_params->m_bba_qs, m_pAnimbuff,m_AnimbuffSize , m_pAnimbuffOUT,m_AnimbuffSizeOUT,0,false,0,0,3, false);
	return true;
}

void EncodeMP4Streams::GetEncodedBBA( unsigned char* &AnimbuffOUT, int &AnimbuffSizeOUT, bool alloc )
{
	AnimbuffSizeOUT = m_AnimbuffSizeOUT;
	if ( alloc )
		AnimbuffOUT = ( unsigned char* ) malloc ( AnimbuffSizeOUT * sizeof (unsigned char*));
	memcpy( AnimbuffOUT, m_pAnimbuffOUT, AnimbuffSizeOUT );
}

void EncodeMP4Streams::GetEncoded3DMC(  char* &DMCbuff, int &DMCbuffSize, bool alloc )
{
	DMCbuffSize = m_3DMCbuffSize;
	if ( alloc )
		DMCbuff = ( char* ) malloc ( m_3DMCbuffSize * sizeof ( char*));
	memcpy( DMCbuff, m_p3DMCbuff , m_3DMCbuffSize );
}

void EncodeMP4Streams::GetEncodedFAMC(  char* &FAMCbuff, int &FAMCbuffSize, bool alloc )
{
	FAMCbuffSize = m_FAMCbuffSize;
	if ( alloc )
		FAMCbuff = ( char* ) malloc ( m_FAMCbuffSize * sizeof ( char*));
	memcpy( FAMCbuff, m_pFAMCbuff , m_FAMCbuffSize );

}


void EncodeMP4Streams::Encode3DMCStream( MP43DMC *DMC )
{
		m_p3DMC = DMC;
		
		
		MPG_QFpm::_shift = 0;
		MPG_Global::reset();
		MPG_IfsQ_C_Ifs enc;
		enc.read3DMCData( DMC );
		
		int bitsPerCoord       = m_params->m_dmc_bitsPerCoord ;//10
		int bitsPerNormal      = m_params->m_dmc_bitsPerNormal  ;//9
		int bitsPerColor       = m_params->m_dmc_bitsPerColor ;//6
		int bitsPerTexCoord    = m_params->m_dmc_bitsPerTexCoord   ;//10

		int img_flag = m_params->m_dmc_img_flag;
		int img_u = m_params->m_dmc_img_u ;
		int img_v = m_params->m_dmc_img_v ;

		int coordPrediction    =  m_params->m_dmc_coordPrediction  ;
		int normalPrediction   =  m_params->m_dmc_normalPrediction ;
		int colorPrediction    =  m_params->m_dmc_colorPrediction ;
		int texCoordPrediction =  m_params->m_dmc_texCoordPrediction ;

		int erMode = m_params->m_dmc_erMode;            
		int packetSize=m_params->m_dmc_packetSize;
		int boundaryPrediction=m_params->m_dmc_boundaryPrediction;  

		bool hierarchicalMode  = m_params->m_dmc_hierarchicalMode ;
		bool saveClsFile       = m_params->m_dmc_saveClsFile    ;
		bool saveWrlLevels     = m_params->m_dmc_saveWrlLevels  ;
		
		bool vertex_order_flag  =  m_params->m_dmc_vertex_order_flag ;
		bool face_order_flag    =  m_params->m_dmc_face_order_flag  ;
		bool face_order_per_CC_flag = m_params->m_dmc_face_order_per_CC_flag ;
		bool vertex_order_per_CC_flag = m_params->m_dmc_vertex_order_per_CC_flag ;

		MPG_OutputStream ostrm;
		MPG_OutputStream t_ostrm;

		enc.compress( ostrm, t_ostrm, 
			bitsPerCoord, coordPrediction,
			bitsPerNormal, normalPrediction,
			bitsPerColor, colorPrediction,
			bitsPerTexCoord, texCoordPrediction,
			erMode, packetSize, boundaryPrediction, 
			hierarchicalMode, saveClsFile,
			saveWrlLevels, img_flag, img_u, img_v,
			vertex_order_flag, face_order_flag, face_order_per_CC_flag, vertex_order_per_CC_flag );
		


		m_p3DMCbuff = ( char* ) ostrm.GetBufferUChar();
		m_3DMCbuffSize = ostrm.size();
		ostrm.close();
}

void EncodeMP4Streams::EncodeFAMCStream( std::vector<MeshFrame> &dmcMesh )
{
	m_pFAMC = &dmcMesh;

	FAMCParams famcParam;
	char sfile[1024] = "";

	strcpy(famcParam.file_, "inputFileName.wrl");
	famcParam.sizeAnimSeg_ = m_params->m_famc_sizeAnimSeg ;
	famcParam.transformType_ = m_params->m_famc_transformType ;
	famcParam.globalRMSE_ = m_params->m_famc_globalRMSE ;
	famcParam.ratioWeights_ = m_params->m_famc_ratioWeights;
	famcParam.qAT_ = m_params->m_famc_qAT ;
	famcParam.qCoord_ = m_params->m_famc_qCoord ;
	famcParam.qNormal_ = m_params->m_famc_qNormal ;
	famcParam.qColor_ = m_params->m_famc_qColor ;
	famcParam.qOther_ = m_params->m_famc_qOther;
	famcParam.LD_auto_ = m_params->m_famc_LD_auto ;
	famcParam.LD_L_ = m_params->m_famc_LD_L ;
	famcParam.LD_l_ = m_params->m_famc_LD_l;
	famcParam.LD_P_ = m_params->m_famc_LD_P ;
	famcParam.LD_B_ = m_params->m_famc_LD_B;
	famcParam.LD_Pred_ = m_params->m_famc_LD_Pred ;
	famcParam.SNR_L_ = m_params->m_famc_SNR_L ;
	famcParam.SNR_l_ = m_params->m_famc_SNR_l ;
	famcParam.Normal_Pred_ = m_params->m_famc_Normal_Pred;
	strcpy(sfile, "size.txt" );

	


	FAMCEncoder_E FAMCEncoder_E( famcParam );
	FAMCEncoder_E.EncodeStream_3DMC( *m_pFAMC, sfile);

	FILE* f = fopen( "fileName.mp4", "rb" );
	fseek( f,0,SEEK_SET);
	int pos1 = ftell( f );
	fseek( f,0,SEEK_END);
	int pos2 = ftell( f );
	fseek( f,0,SEEK_SET);
	m_FAMCbuffSize = pos2 - pos1;
	fseek(f,0,SEEK_SET);
	m_pFAMCbuff = ( char* ) malloc ( m_FAMCbuffSize * sizeof ( char ));
	fread(m_pFAMCbuff,1,m_FAMCbuffSize,f);	
	fclose( f );

	//remove temporary file
	remove ( "size.txt");
	remove ( "partition.txt");
	remove ( "tmp.mp4");
	remove ( "fileNameFF.txt");
	remove ( "fileName.mp4" );
}



//CI
void EncodeMP4Streams::EncodeCIStream( MP4AnimationBuff * animation, int key_qp, int keyvalue_qp) 
{ 
	Encode_OK = true; 
	m_AnimbuffSize = 0; 
	m_pAnimbuff = NULL; 
	m_AnimbuffSizeOUT = 0; 
	m_pAnimbuffOUT = NULL; 
	m_panimation = animation; 
	Encode_OK = encodeCI(key_qp, keyvalue_qp); 
	free( m_pAnimbuff ); 
	m_pAnimbuff = NULL; 
} 

void EncodeMP4Streams::GetEncodedCI( unsigned char* &AnimbuffOUT, int &AnimbuffSizeOUT, bool alloc ) 
{ 
	AnimbuffSizeOUT = m_AnimbuffSizeOUT; 
	if ( alloc ) 
		AnimbuffOUT = ( unsigned char* ) malloc ( AnimbuffSizeOUT * sizeof (unsigned char*)); 
	memcpy( AnimbuffOUT, m_pAnimbuffOUT, AnimbuffSizeOUT ); 
} 

bool EncodeMP4Streams::encodeCI(int key_qp, int keyvalue_qp) 
{ 
	//      std::string buf; 
	//      buf.clear(); 
	//      buf.push_back('c'); 
	CI::CompressedCoordinateInterpolator CIencoder(&(m_panimation[0].m_key[0]), m_panimation[0].m_key.size(),&(m_panimation[0].m_keyvalue[0]), m_panimation[0].m_keyvalue.size(), key_qp, keyvalue_qp); 
	CIencoder.encode(); 
	m_pAnimbuffOUT = (unsigned char *)malloc ( m_AnimbuffSizeOUT=CIencoder.BitStream()->size()+1); 
	m_pAnimbuffOUT[0] = 'c'; 
	memcpy(m_pAnimbuffOUT + 1, CIencoder.BitStream()->c_str(), CIencoder.BitStream()->size()); 
	return true; 
} 

void EncodeMP4Streams::EncodePIStream( MP4AnimationBuff * animation, int key_qp, int keyvalue_qp) 
{ 
	Encode_OK = true; 
	m_AnimbuffSize = 0; 
	m_pAnimbuff = NULL; 
	m_AnimbuffSizeOUT = 0; 
	m_pAnimbuffOUT = NULL; 
	m_panimation = animation; 
	Encode_OK = encodePI(key_qp, keyvalue_qp); 
	free( m_pAnimbuff ); 
	m_pAnimbuff = NULL; 
} 

void EncodeMP4Streams::GetEncodedPI( unsigned char* &AnimbuffOUT, int &AnimbuffSizeOUT, bool alloc ) 
{ 
	AnimbuffSizeOUT = m_AnimbuffSizeOUT; 
	if ( alloc ) 
		AnimbuffOUT = ( unsigned char* ) malloc ( AnimbuffSizeOUT * sizeof (unsigned char*)); 
	memcpy( AnimbuffOUT, m_pAnimbuffOUT, AnimbuffSizeOUT ); 
} 

bool EncodeMP4Streams::encodePI(int key_qp, int keyvalue_qp) 
{ 
	std::string buf; 
	buf.clear(); 
	buf.push_back('p'); 
	SoWonPositionInterpolator(m_panimation[0].m_key, m_panimation[0].m_keyvalue, buf, key_qp, keyvalue_qp);  
	m_pAnimbuffOUT = (unsigned char *)malloc ( m_AnimbuffSizeOUT=buf.size() ); 
	memcpy(m_pAnimbuffOUT, buf.c_str(), buf.size()); 
	return true; 
} 

void EncodeMP4Streams::EncodeOIStream( MP4AnimationBuff * animation, int key_qp, int keyvalue_qp) 
{ 
	Encode_OK = true; 
	m_AnimbuffSize = 0; 
	m_pAnimbuff = NULL; 
	m_AnimbuffSizeOUT = 0; 
	m_pAnimbuffOUT = NULL; 
	m_panimation = animation; 
	Encode_OK = encodeOI(key_qp, keyvalue_qp); 
	free( m_pAnimbuff ); 
	m_pAnimbuff = NULL; 
} 

void EncodeMP4Streams::GetEncodedOI( unsigned char* &AnimbuffOUT, int &AnimbuffSizeOUT, bool alloc ) 
{ 
	AnimbuffSizeOUT = m_AnimbuffSizeOUT; 
	if ( alloc ) 
		AnimbuffOUT = ( unsigned char* ) malloc ( AnimbuffSizeOUT * sizeof (unsigned char*)); 
	memcpy( AnimbuffOUT, m_pAnimbuffOUT, AnimbuffSizeOUT ); 
} 

bool EncodeMP4Streams::encodeOI(int key_qp, int keyvalue_qp) 
{ 
	std::string buf; 
	buf.clear(); 
	buf.push_back('o'); 
	SoWonOrientationInterpolator(m_panimation[0].m_key, m_panimation[0].m_keyvalue, buf, key_qp, keyvalue_qp);  
	m_pAnimbuffOUT = (unsigned char *)malloc ( m_AnimbuffSizeOUT=buf.size() ); 
	memcpy(m_pAnimbuffOUT, buf.c_str(), buf.size()); 
	return true; 
} 

//CI
void EncodeMP4Streams::EncodeXMLData( char* buff, int size )
{
	gzFile gz;
	gz = gzopen("rarScene.gz","wb" );
	gzwrite( gz, buff, size );
	gzflush( gz, Z_FINISH );
	gzclose( gz );
	
	FILE *rar;
	rar = fopen( "rarScene.gz", "rb");
	fseek(rar, 0, SEEK_END);
	m_BinBuffSize = ftell(rar);
	fseek(rar, 0, SEEK_SET);
	m_pBinBuff = ( char*)malloc(m_BinBuffSize);
	fread(m_pBinBuff, 1, m_BinBuffSize, rar);
	fclose( rar );

	remove("rarScene.gz");	
}


bool EncodeMP4Streams::GetEncodedXml( char* &buff, int &size, bool alloc )
{
	if (alloc)
		buff = (char*) malloc (m_BinBuffSize);
	memcpy( buff, m_pBinBuff, m_BinBuffSize );
	size = m_BinBuffSize;
	
	return true;
}



void EncodeMP4Streams::Get3DMCFile ( const char* fileName )
{

	FILE *f = fopen( fileName, "ab" );
	fwrite( m_p3DMCbuff, m_3DMCbuffSize, 1, f );
	fclose ( f );
}


void EncodeMP4Streams::GetBBAFile ( const char* fileName )
{

	FILE *f = fopen( fileName, "ab" );
	fwrite( m_pAnimbuffOUT, m_AnimbuffSizeOUT, 1, f );
	fclose ( f );
}


void EncodeMP4Streams::GetFAMCFile ( const char* fileName )
{

	FILE *f = fopen( fileName, "ab" );
	fwrite( m_pFAMCbuff, m_FAMCbuffSize, 1, f );
	fclose ( f );
}

