/******************************************************************************\
* Includes.
\******************************************************************************/

#include "MakeOD.h"

/******************************************************************************\
 MakeOD.cpp: implementation of the MakeOD class:
\******************************************************************************/

/******************************************************************************\
* Constructor.
\******************************************************************************/


MakeOD::MakeOD(void)
{
	
	InitVars();
}
/******************************************************************************\
* Desttructor
\******************************************************************************/

MakeOD::~MakeOD(void)
{
	DeleteODData();
}


int MakeOD::InitVars()
{
	outAU			= NULL;
	u32  au_length	= 0;
	GF_Err e	;		
	int NumberODs	= 1 ;
	encoder			= NULL;
	command			= NULL;
	odUpdate		= NULL;
	od				= NULL;
	pOdESD			= NULL;
	pDecCon			= NULL;
	pSlcCon			= NULL;
	return 0;
}

int MakeOD::InitOD() 
{
	DeleteODData();
	encoder =  gf_odf_codec_new();

		
	command = gf_odf_com_new(GF_ODF_OD_UPDATE_TAG);
	odUpdate = (GF_ODUpdate*) command;
    return 0;
}


int MakeOD::AddODSample(int ODID, int ESID, const char* streamFormat, int streamType, int objectTypeIndication, int bufferSizeDB)
{
		od = (GF_ObjectDescriptor*) gf_odf_new_od(); // OD_NewDescriptor (ObjectDescriptor_Tag);
		od->objectDescriptorID = (u16) ODID;
		
		//pOdESD = OD_NewESDescriptor (2); 
		pOdESD = ( GF_ESD*)  gf_odf_new_esd(); //OD_NewDescriptor( ESDescriptor_Tag );
		pOdESD->ESID = (u16) ESID;
		//pOdESD->streamFormat = strdup(streamFormat);
		
		
		pDecCon = (GF_DecoderConfig*) gf_odf_new_dcd();  /*DecoderConfigDescriptor*) OD_NewDescriptor(DecoderConfigDescriptor_Tag);*/
		pDecCon->streamType = (u8)streamType; 
		pDecCon->objectTypeIndication = (u8) objectTypeIndication;
		
		pDecCon->bufferSizeDB = (u32) bufferSizeDB;
		if (ESID == 201)
		{
			GF_DefaultDescriptor* bc;
			bc = (GF_DefaultDescriptor*) malloc( sizeof(GF_DefaultDescriptor) );
			//bc->tag = DecoderSpecificInfo_Tag; //BIFSConfig_Tag;
			
			bc->data = (char*)malloc( 3 );
			bc->data[0] = 0x14;
			bc->data[1] = 0xA5;
			bc->data[2] = 0x00;
			bc->dataLength = 3; 
			//pDecCon->decoderSpecificInfo = (DefaultDescriptor*)bc;
			/*bc->isCommandStream = 1;
			bc->nodeIDbits = 10;
			bc->version = 2;*/
			//OD_AddDescToDesc( (Descriptor*)pDecCon, (Descriptor*)bc );
			pDecCon->decoderSpecificInfo = bc;
		}
		//TO DO : if need stg else in DecoderConfigDescriptor, can be add here;
		pOdESD->decoderConfig = pDecCon;

		pSlcCon = (GF_SLConfig*) gf_odf_new_slc( 0 ) ;//OD_NewDescriptor(SLConfigDescriptor_Tag);
		pSlcCon->useAccessUnitStartFlag   = true;
		pSlcCon->useAccessUnitEndFlag	  = true;
		pSlcCon->useRandomAccessPointFlag = true;
		pSlcCon->useTimestampsFlag		  = true;	
		pSlcCon->timestampResolution      = 1000;
		pSlcCon->timestampLength          = 10;
		
		pOdESD->slConfig  = pSlcCon;

		gf_list_add(od->ESDescriptors,pOdESD); //ChainAddEntry(od->ESDescriptors,pOdESD); 
		gf_list_add(odUpdate->objectDescriptors,od); //ChainAddEntry(odUpdate->objectDescriptors,od); 

		return 0;

}

int MakeOD::CreateODBuffer()
{
	e= gf_odf_codec_add_com(encoder, command); 
	//e = OD_AddCommand(encoder, command); 
	gf_odf_codec_encode( encoder, false );
	//e = OD_EncodeAU(encoder);  //with encoding each command is deleted, so no need to delete ODCommand *command
	command = NULL;
	gf_odf_codec_get_au(encoder, &outAU, &au_length); 
	//e = OD_GetEncodedAU(encoder, &outAU, &au_length); 
	gf_odf_codec_del( encoder );
	//OD_DeleteCodec(encoder);
	encoder = NULL;

	return 0;
}

int MakeOD::DeleteODData()
{
	if ( outAU )
	{
		free( outAU );
		outAU = NULL;
		au_length = 0;
	}
	if ( command )
		gf_odf_com_del( &command );
		//OD_DeleteCommand( &command );
	if ( encoder )
		gf_odf_codec_del( encoder );
		//OD_DeleteCodec( encoder );
	InitVars();
	return 0;
}
