#ifndef _MP4TOCOLLADADECODE_H_
#define _MP4TOCOLLADADECODE_H_

/******************************************************************************\
* Includes
\******************************************************************************/

#include "FCollada.h"
#include "ColladaInc.h"
#include "FAXColladaParser.h"
#include "FArchiveXML.h"
#include <vector>
#include "MP43DMC.h"


/******************************************************************************\
* Class MP4toColladaDecode
\******************************************************************************/
class MP4toColladaDecode
{
public:

	//de/constructor
	MP4toColladaDecode();
	~MP4toColladaDecode();
	
	//methods
	//create collada file from mp4 file
	//mp4 file in meta data should have part of gziped collada which is standard collada file without mesh and/or an animation
	//also mp4 file should have tracks with 3DMC stream and/or BBA stream
	bool RestoreColladaFile( const char * mp4FileName, const char* colladaFileName );

private:

	//methods
	//bool ColladaInit();
	bool RestoreGeometry( FCDocument* file );
	bool RestoreAnimation( FCDocument * file );
	bool RestoreImages( FCDocument* file );
	bool RestoreXML(  const char * colladaFileName );
	bool RestoreCoordInterpolator( FCDocument* file, FCDGeometry *ge, std::vector<MeshFrame> &MeshVec );
	
	FCDTransform::Type GetTransformNameSub(FCDocument* file, fm::string &tp, fm::string &tq, FCDSceneNode* node) const; 
	FCDTransform::Type GetTransformName(FCDocument* file, fm::string &tp, fm::string &tq) const;
};







#endif //_MP4TOCOLLADADECODE_H_