#pragma once

#include "MP43DMC.h"

#include "gpac/scenegraph.h"
#include "gpac/scene_manager.h"
#include "gpac/internal/scenegraph_dev.h"

class XMTParser
{
public:
	XMTParser(void);
	~XMTParser(void);

	//methods
	//fileName == name of the input file
	//load, parse and remove mesh and animation from fileName
	bool LoadXMTFile( const char * fileName );
	//return the number of meshes in XMT  == number of 3DMC stream in mp4
	int Get3DMCStreamsCount();
	//return id-th mesh in XMT
	MP43DMC* Get3DMCStream( int id );
	//return the rest of XMT file in buffer
	// If alloc is true, the buffer is allocated inside the function
	// If alloc is false, the buffer should be allocated before calling the function
	bool GetXMLrest ( char* &buff, int &size, bool alloc );

private:
	//variables
	char*			m_pXMTFileName;
	//MP4AnimationBuff**	m_pAnimation;
	MP43DMC**			m_p3dmc;
	char*				m_pRestXMTFileName;
	int					m_3dmcCount;
	//int					m_AnimationCount;
	GF_SceneLoader		m_lc;
	
	//methods
	
	bool ParseXMTFile();
	bool RemoveGeometry();
	//bool RemoveAnimation();
	//bool ParseImages();
	//FMQuaternion GetQuaternion( FMMatrix44& kRot );
	bool LoadFile();


};
