using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace MP25
{
    public partial class AdvancedEnc : Form
    {
        private EncoderParameters par;

        public AdvancedEnc(EncoderParameters Parameters)
        {
            InitializeComponent();

            par = Parameters;
            LoadParameters();
        }

        public void LoadParameters()
        {
            tr3dmcCoord.Value = par.m_3dmc_bits_coord;
            tr3dmcNormal.Value = par.m_3dmc_bits_normal;
            tr3dmcTexCoord.Value = par.m_3dmc_bits_texcoord;
            tr3dmcColor.Value = par.m_3dmc_bits_color;

            chk3dmcOrderVertex.Checked = par.m_3dmc_order_vertex;
            chk3dmcOrderFace.Checked = par.m_3dmc_order_face;

            trfamcCoord.Value = par.m_famc_bits_coord;
            trfamcNormal.Value = par.m_famc_bits_normal;
            trfamcTexCoord.Value = par.m_famc_bits_texcoord;
            trfamcColor.Value = par.m_famc_bits_color;

            if (par.m_bba_coding == 0)
                radbbaFB.Checked = true;
            else
                radbbaDCT.Checked = true;

            if (par.m_inter_coding == 0)
                radInterFAMC.Checked = true;
            else
                radInterCI.Checked = true;

            numbbap2qs.Value = par.m_bba_p2qs;
            numbbaqs.Value = par.m_bba_qs;
        }

        public void StoreParameters()
        {
            par.m_3dmc_bits_coord = tr3dmcCoord.Value;
            par.m_3dmc_bits_normal = tr3dmcNormal.Value;
            par.m_3dmc_bits_texcoord = tr3dmcTexCoord.Value;
            par.m_3dmc_bits_color = tr3dmcColor.Value;

            par.m_3dmc_order_vertex = chk3dmcOrderVertex.Checked;
            par.m_3dmc_order_face = chk3dmcOrderFace.Checked;

            par.m_famc_bits_coord = trfamcCoord.Value;
            par.m_famc_bits_normal = trfamcNormal.Value;
            par.m_famc_bits_texcoord = trfamcTexCoord.Value;
            par.m_famc_bits_color = trfamcColor.Value;

            if (radbbaFB.Checked)
                par.m_bba_coding = 0;
            else
                par.m_bba_coding = 1;

            if (radInterFAMC.Checked)
                par.m_inter_coding = 0;
            else
                par.m_inter_coding = 1;

            par.m_bba_p2qs = (int)numbbap2qs.Value;
            par.m_bba_qs = (int)numbbaqs.Value;
        }

        private void tr3dmcCoord_ValueChanged(object sender, EventArgs e)
        {
            textBox1.Text = tr3dmcCoord.Value.ToString();
        }

        private void tr3dmcNormal_ValueChanged(object sender, EventArgs e)
        {
            textBox4.Text = tr3dmcNormal.Value.ToString();
        }

        private void tr3dmcColor_ValueChanged(object sender, EventArgs e)
        {
            textBox6.Text = tr3dmcColor.Value.ToString();
        }

        private void tr3dmcTexCoord_ValueChanged(object sender, EventArgs e)
        {
            textBox8.Text = tr3dmcTexCoord.Value.ToString();
        }

        private void trfamcCoord_ValueChanged(object sender, EventArgs e)
        {
            textBox7.Text = trfamcCoord.Value.ToString();
        }

        private void trfamcNormal_ValueChanged(object sender, EventArgs e)
        {
            textBox5.Text = trfamcNormal.Value.ToString();
        }

        private void trfamcColor_ValueChanged(object sender, EventArgs e)
        {
            textBox3.Text = trfamcColor.Value.ToString();
        }

        private void trfamcTexCoord_ValueChanged(object sender, EventArgs e)
        {
            textBox2.Text = trfamcTexCoord.Value.ToString();
        }

        private void btnDefult_Click(object sender, EventArgs e)
        {
            par.SetDefaults();
            LoadParameters();
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.Cancel;
        }

        private void btnOK_Click(object sender, EventArgs e)
        {
            StoreParameters();
            this.DialogResult = DialogResult.OK;
        }

        private void radInterFAMC_CheckedChanged(object sender, EventArgs e)
        {
            label11.Enabled = label12.Enabled = label13.Enabled = label14.Enabled = radInterFAMC.Checked;
            trfamcCoord.Enabled = trfamcNormal.Enabled = trfamcTexCoord.Enabled = trfamcColor.Enabled = radInterFAMC.Checked;
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            
            label5.Enabled = label6.Enabled = label7.Enabled = label8.Enabled = checkBox1.Checked;
            tr3dmcCoord.Enabled = tr3dmcNormal.Enabled = tr3dmcTexCoord.Enabled = tr3dmcColor.Enabled = checkBox1.Checked;
            chk3dmcOrderFace.Enabled = chk3dmcOrderVertex.Enabled = checkBox1.Checked;
      
        }

        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
            groupBox1.Enabled = groupBox2.Enabled = radioButton1.Checked;
        }

        
    }
}