#include "CMDArguments.h"


//constructor for CDMArguments class
CMDArguments::CMDArguments()
{

	m_dmc_bitsPerCoord       = 10;//10
	m_dmc_bitsPerNormal      = 9;//9
	m_dmc_bitsPerColor       = 6;//6
	m_dmc_bitsPerTexCoord    = 10;//10
	m_dmc_img_flag = false;
	m_dmc_img_u = 0;
	m_dmc_img_v = 0;
	m_dmc_coordPrediction    =  2;
	m_dmc_normalPrediction   =  0;
	m_dmc_colorPrediction    =  1;
	m_dmc_texCoordPrediction =  1;
	m_dmc_erMode = 0;            
	m_dmc_packetSize=180;
	m_dmc_boundaryPrediction=0;  
	m_dmc_hierarchicalMode  = false;
	m_dmc_saveClsFile       = false;
	m_dmc_saveWrlLevels     = false;
	m_dmc_vertex_order_flag  =  true;
	m_dmc_face_order_flag    =  true;
	m_dmc_face_order_per_CC_flag = false;
	m_dmc_vertex_order_per_CC_flag = false;

	m_bba_automatic = 0;
	m_bba_P_frames = 0;
	m_bba_coding_type = 1;
	m_bba_p2q = 6;
	m_bba_qs = 7;

	m_famc_m_famc_sizeAnimSeg = 1;
	m_famc_transformType = 1;
	m_famc_globalRMSE = 0.0025f;
	m_famc_ratioWeights = 0.05f;
	m_famc_qAT = 16;
	m_famc_qCoord = 16;
	m_famc_qNormal = 0;
	m_famc_qColor = 0;
	m_famc_qOther = 0;
	m_famc_LD_auto = 0;
	m_famc_LD_L = 8;
	m_famc_LD_l = 8;
	m_famc_LD_P = -1;
	m_famc_LD_B = 15;
	m_famc_LD_Pred = 1;
	m_famc_SNR_L = 1;
	m_famc_SNR_l = 1;
	m_famc_Normal_Pred = 3;


}

CMDArguments::~CMDArguments()
{
}

void CMDArguments::Parse( int argc, char* argv[] )
{
	// make strings with lower chars
	//	for (int i=0; i<argc; i++)
	//		argv[i].MakeLower();

	// find arg
	for (int i=1; i<argc; i++)
	{
		if (argv[i] == "-dmc_bitsPerCoord" && i+1 < argc)
		{
			m_dmc_bitsPerCoord = atoi( argv[i+1] );
		}		
		if (argv[i] == "-dmc_bitsPerNormal" && i+1 < argc)
		{
			m_dmc_bitsPerNormal = atoi( argv[i+1]);
		}
		if (argv[i] == "-dmc_bitsPerColor" && i+1 < argc)
		{
			m_dmc_bitsPerColor = atoi( argv[i+1]);
		}
		if (argv[i] == "-dmc_bitsPerTexCoordr" && i+1 < argc)
		{
			m_dmc_bitsPerTexCoord = atoi( argv[i+1]);
		}
		if (argv[i] == "-dmc_img_flag" )
		{
			m_dmc_img_flag = true;
		}
		if (argv[i] == "-m_dmc_img_u" && i+1 < argc)
		{
			m_dmc_img_u = atoi( argv[i+1]);
		}
		if (argv[i] == "-dmc_img_v" && i+1 < argc)
		{
			m_dmc_img_v = atoi( argv[i+1]);
		}
		if (argv[i] == "-dmc_coordPrediction" && i+1 < argc)
		{
			m_dmc_coordPrediction = atoi( argv[i+1]);
		}
		if (argv[i] == "-dmc_normalPrediction" && i+1 < argc)
		{
			m_dmc_normalPrediction = atoi( argv[i+1]);
		}
		if (argv[i] == "-dmc_colorPrediction" && i+1 < argc)
		{
			m_dmc_colorPrediction = atoi( argv[i+1]);
		}
		if (argv[i] == "-dmc_texCoordPrediction" && i+1 < argc)
		{
			m_dmc_texCoordPrediction = atoi( argv[i+1]);
		}
		if (argv[i] == "-dmc_erMode" && i+1 < argc)
		{
			m_dmc_erMode = atoi( argv[i+1]);
		}
		if (argv[i] == "-dmc_packetSize" && i+1 < argc)
		{
			m_dmc_packetSize = atoi( argv[i+1]);
		}
		if (argv[i] == "-dmc_boundaryPrediction" && i+1 < argc)
		{
			m_dmc_boundaryPrediction = atoi( argv[i+1]);
		}
		if (argv[i] == "-dmc_hierarchicalMode" )
		{
			m_dmc_hierarchicalMode =  true;
		}
		if (argv[i] == "-dmc_saveClsFile" )
		{
			m_dmc_saveClsFile =  true;
		}
		if (argv[i] == "-dmc_saveWrlLevels" )
		{
			m_dmc_saveWrlLevels =  true;
		}
		if (argv[i] == "-dmc_vertex_order_flag" )
		{
			m_dmc_vertex_order_flag = false;
		}
		if (argv[i] == "-dmc_face_order_flag" )
		{
			m_dmc_face_order_flag = false;
		}
		if (argv[i] == "-dmc_face_order_per_CC_flag")
		{
			m_dmc_face_order_per_CC_flag = false;
		}
		if (argv[i] == "-dmc_vertex_order_per_CC_flag" )
		{
			m_dmc_vertex_order_per_CC_flag = false;
		}
		if (argv[i] == "-bba_automatic" && i+1 < argc)
		{
			m_bba_automatic = atoi( argv[i+1]);
		}
		if (argv[i] == "-bba_P_frames" && i+1 < argc)
		{
			m_bba_P_frames = atoi( argv[i+1]);
		}
		if (argv[i] == "-bba_coding_type" && i+1 < argc)
		{
			m_bba_coding_type = atoi( argv[i+1]);
		}
		if (argv[i] == "-bba_p2q" && i+1 < argc)
		{
			m_bba_p2q = atoi( argv[i+1]);
		}
		if (argv[i] == "-bba_qs" && i+1 < argc)
		{
			m_bba_qs = atoi( argv[i+1]);
		}
		if (argv[i] == "-famc_m_famc_sizeAnimSeg" && i+1 < argc)
		{
			m_famc_m_famc_sizeAnimSeg = atoi( argv[i+1]);
		}
		if (argv[i] == "-famc_transformType" && i+1 < argc)
		{
			m_famc_transformType = atoi( argv[i+1]);
		}
		if (argv[i] == "-famc_globalRMSE" && i+1 < argc)
		{
			m_famc_globalRMSE = atof( argv[i+1]);
		}
		if (argv[i] == "-famc_ratioWeights" && i+1 < argc)
		{
			m_famc_ratioWeights = atof( argv[i+1]);
		}
		if (argv[i] == "-famc_qAT" && i+1 < argc)
		{
			m_famc_qAT = atoi( argv[i+1]);
		}
		if (argv[i] == "-famc_qCoord" && i+1 < argc)
		{
			m_famc_qCoord = atoi( argv[i+1]);
		}
		if (argv[i] == "-famc_qNormal" && i+1 < argc)
		{
			m_famc_qNormal = atoi( argv[i+1]);
		}
		if (argv[i] == "-famc_qColor" && i+1 < argc)
		{
			m_famc_qColor = atoi( argv[i+1]);
		}
		if (argv[i] == "-famc_qOther" && i+1 < argc)
		{
			m_famc_qOther = atoi( argv[i+1]);
		}

		if (argv[i] == "-famc_LD_auto" && i+1 < argc)
		{
			m_famc_LD_auto = atoi( argv[i+1]);
		}
		if (argv[i] == "-famc_LD_L" && i+1 < argc)
		{
			m_famc_LD_L = atoi( argv[i+1]);
		}
		if (argv[i] == "-famc_LD_l" && i+1 < argc)
		{
			m_famc_LD_l = atoi( argv[i+1]);
		}
		if (argv[i] == "-famc_LD_P" && i+1 < argc)
		{
			m_famc_LD_P = atoi( argv[i+1]);
		}
		if (argv[i] == "-famc_LD_B" && i+1 < argc)
		{
			m_famc_LD_B = atoi( argv[i+1]);
		}
		if (argv[i] == "-famc_LD_Pred" && i+1 < argc)
		{
			m_famc_LD_Pred = atoi( argv[i+1]);
		}
		if (argv[i] == "-famc_SNR_L" && i+1 < argc)
		{
			m_famc_SNR_L = atoi( argv[i+1]);
		}
		if (argv[i] == "-famc_SNR_l" && i+1 < argc)
		{
			m_famc_SNR_l = atoi( argv[i+1]);
		}
		if (argv[i] == "-famc_Normal_Pred" && i+1 < argc)
		{
			m_famc_Normal_Pred = atoi( argv[i+1]);
		}
	}
}